unit test1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Comm, ExtCtrls;

type
  TForm1 = class(TForm)
    cbDevice: TComboBox;
    Label1: TLabel;
    btnOpen: TButton;
    btnSend: TButton;
    edInit: TEdit;
    Timer1: TTimer;
    procedure btnOpenClick(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    Comm: TComm;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnOpenClick(Sender: TObject);
begin
  if btnOpen.Caption = 'Verbinden' then begin
    Comm.ComPortNr := cbDevice.ItemIndex + 1;
    if Comm.InitCOM then begin
      btnOpen.Caption := 'Stoppen';
      Comm.mnShowClick(self);
    end;
  end else begin
    Comm.ExitCOM;
    btnOpen.Caption := 'Verbinden';
  end;
  btnSend.Enabled := Comm.COM_INITIALISIERT;
end;

procedure TForm1.btnSendClick(Sender: TObject);
var
  s, t, h : string;
  w : word;
  tot : word;
  p : integer;
begin
  if Comm.COM_INITIALISIERT then begin
    tot := 0;
    s := '';
    p := 1;
    t := trim(edInit.Text);
    while (p <= length(t)) and (length(s) < 10) do begin
      h := '';
      while (p <= length(t)) and (AnsiChar(t[p]) in ['a'..'f', 'A'..'F', '0'..'9', '$']) do begin
        h := h + t[p];
        inc(p);
      end;
      w := strtoint(h);
      s := s + chr(w and $ff);
      tot := tot + (w and $ff);
      while (p <= length(t)) and (t[p] = ' ') do
        inc(p);
    end;
    while length(s) < 10 do
      s := s + #0;
    s := s + chr(tot shr 8) + chr(tot and $ff);
    Comm.WriteTime(now);
    Comm.WriteStringToCOM(s);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  btnSend.Enabled := false;

  HideError := true;
  Comm := TComm.Create(self);
  Comm.UseTimeStamp := true;
  Comm.SetDTR(true);
  Comm.SetRTS(true);
  Comm.SetParity(2);
  Comm.SetStopBits(2);
  Comm.SetBaudrate(2400);
  Comm.SetRtsFlowControl(false);
  Comm.NewScreenSize(120, 2000);
  Comm.SetTimerInterval(10);

  Comm.write(''' '': sent hex. byte'); Comm.writeln;
  Comm.write('''.'': received hex. byte'); Comm.writeln;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Comm.ExitCOM;
  Comm.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  res : integer;
begin
  if Comm <> nil then begin
    res := Comm.ReadFromCOM;
    if res <> _NULL_CHAR then begin
      Comm.WriteTime(now);
      while Comm.ReadFromCOM <> _NULL_CHAR do
        begin end;
    end;
  end;
end;

end.
