
// Achtung: Die Tabelle befindet sich im Aufbau! Nicht alle Indizes sind korrekt.
//
// Die Indizes muessen zwingend vor einem produktiven Einsatz ueberprueft werden.
// Die beste Ueberpruefung erhaelt man mit der ComfortSoft und der Simulation
// der eigenen WP. Da werden die Telegramme der Schnittstelle protokolliert.
//
// Die Indizes, die ich mittels ComfortSoft zu meiner WP ueberpruefen konnte,
// sind korrekt. Da ich eine WPL33 ohne PV nutze, gibt es viele Indizes, die Ihr
// selbst ueberpruefen muesst.

// 19.10.2014: et_double_val und et_triple_val umgestellt

static const ElsterIndex ElsterTable[] =
{
//  Name                                                 Index   Type
//  Struktur-Definition in KElsterTable.h
  { "FEHLERMELDUNG"                                    , 0x0001, 0},
  { "KESSELSOLLTEMP"                                   , 0x0002, et_dec_val},
  { "SPEICHERSOLLTEMP"                                 , 0x0003, et_dec_val},
  { "VORLAUFSOLLTEMP"                                  , 0x0004, et_dec_val},
  { "RAUMSOLLTEMP_I"                                   , 0x0005, et_dec_val},
  { "RAUMSOLLTEMP_II"                                  , 0x0006, et_dec_val},
  { "RAUMSOLLTEMP_III"                                 , 0x0007, et_dec_val},
  { "RAUMSOLLTEMP_NACHT"                               , 0x0008, et_dec_val},
  { "UHRZEIT"                                          , 0x0009, et_zeit},
  { "DATUM"                                            , 0x000a, et_datum},
  { "GERAETE_ID"                                       , 0x000b, et_dev_id},
  { "AUSSENTEMP"                                       , 0x000c, et_dec_val},
  { "SAMMLERISTTEMP"                                   , 0x000d, et_dec_val},  // ev. KESSELISTTEMP
  { "SPEICHERISTTEMP"                                  , 0x000e, et_dec_val},
  { "VORLAUFISTTEMP"                                   , 0x000f, et_dec_val},
  { "GERAETEKONFIGURATION"                             , 0x0010, 0},
  { "RAUMISTTEMP"                                      , 0x0011, et_dec_val},
  { "VERSTELLTE_RAUMSOLLTEMP"                          , 0x0012, et_dec_val},
  { "EINSTELL_SPEICHERSOLLTEMP"                        , 0x0013, et_dec_val},
  { "VERDAMPFERTEMP"                                   , 0x0014, et_byte},
  { "SAMMLERSOLLTEMP"                                  , 0x0015, 0},
  { "RUECKLAUFISTTEMP"                                 , 0x0016, et_dec_val},
  { "SPEICHER_UNTEN_TEMP"                              , 0x0017, 0},
  { "SOLARZONENTEMP"                                   , 0x0018, 0},
  { "SPEICHER_OBEN_TEMP"                               , 0x0019, 0},
  { "KUNDENKENNUNG"                                    , 0x001a, 0},
  { "KOLLEKTORTEMP"                                    , 0x001b, 0},
  { "FESTSTOFFKESSELTEMP"                              , 0x001c, 0},
  { "WASSERDRUCK"                                      , 0x001f, 0},
  { "MIN_TEMP_KESSEL"                                  , 0x0020, 0},
  { "ANFAHRTEMP"                                       , 0x0021, 0},
  { "HYSTERESEZEIT"                                    , 0x0022, et_dec_val}, // MAX_HYSTERESE
  { "MAX_HYSTERESE"                                    , 0x0023, et_little_endian},
  { "PPL"                                              , 0x0024, 0},
  { "SPEICHERSPERRE"                                   , 0x0025, 0},
  { "SPERRZEIT"                                        , 0x0026, 0},
  { "HYSTERESE2"                                       , 0x0027, 0},
  { "MAX_TEMP_KESSEL"                                  , 0x0028, et_dec_val},
  { "MAX_TEMP_HZK"                                     , 0x0029, 0},
  { "KP"                                               , 0x002a, 0},
  { "TN"                                               , 0x002b, et_little_endian},
  { "MISCHERLAUFZEIT"                                  , 0x002c, 0},
  { "MODGRAD"                                          , 0x002d, 0},
  { "KESSELUEBERHOEHUNG_WW"                            , 0x002e, 0},
  { "STAENDIGE_MINIMALBEGRENZUNG"                      , 0x002f, 0},
  { "ACCESS_EEPROM"                                    , 0x0030, et_little_endian},
  { "MINDESTABTAUZEIT"                                 , 0x0031, 0},
  { "ACCESS_XRAM"                                      , 0x0032, 0},
  { "ACCESS_IRAM"                                      , 0x0033, 0},
  { "MIN_WASSERDRUCK"                                  , 0x0034, 0},
  { "LEISTUNGSKORREKTUR"                               , 0x0035, 0},
  { "KOLLEKTORTEMP_2"                                  , 0x0036, 0},
  { "MULTIFUNKTION_ISTTEMP"                            , 0x0051, 0},
  { "BRENNER"                                          , 0x0052, et_little_endian},
  { "HZK_PUMPE"                                        , 0x0053, 0},
  { "SPL_PUMPE"                                        , 0x0055, 0},
  { "DCF"                                              , 0x0056, et_little_endian},
  { "MISCHER_AUF"                                      , 0x0057, et_little_endian},
  { "MISCHER_ZU"                                       , 0x0058, et_little_endian},
  { "HEIZKREIS_STATUS"                                 , 0x0059, et_little_endian},
  { "SPEICHER_STATUS"                                  , 0x005a, et_little_endian},
  { "SCHALTERSTELLUNG"                                 , 0x005b, 0},
  { "ANFAHRENT"                                        , 0x005d, 0},
  { "TEILVORRANG_WW"                                   , 0x005e, 0},
  { "SPEICHERBEDARF"                                   , 0x005f, 0},
  { "SCHALTFKT_IWS"                                    , 0x0060, 0},
  { "ABTAUUNGAKTIV"                                    , 0x0061, 0},
  // nach chriss1980 / knx forum
  // Verdichter 1:        0x0001
  // DHC 1:               0x0002
  // DHC 2:               0x0004
  // Pufferladepumpe:     0x0008
  // Warmwasserladepumpe: 0x0010
  // HK 1 Pumpe:          0x0020
  // HK 2 Pumpe:          0x0040
  // Mischer auf:         0x0080
  // EVU-Sperre:          0x0100
  // Quellenpumpe:        0x0200
  // Kuehlkreispumpe:     0x0800
  { "WAERMEPUMPEN_STATUS"                              , 0x0062, et_little_endian},
  { "KESSELSTATUS"                                     , 0x0063, et_little_endian},
  { "SAMMLER_PUMPE"                                    , 0x0064, 0},
  { "ZIRK_PUMPE"                                       , 0x0065, 0},
  { "MISCHERSTATUS"                                    , 0x0066, et_little_endian},
  { "SONDERKREIS_STATUS"                               , 0x0067, et_little_endian},
  { "BETRIEBSART"                                      , 0x0068, 0},
//  { "KONFIGURATION"                                   , 0},
  { "IO_TEST"                                          , 0x0069, 0},
  { "RESET_KONFIGURATION"                              , 0x006a, 0},
  { "PARTY_EIN_AUS"                                    , 0x006b, 0},
  { "ECO_EIN_AUS"                                      , 0x006c, 0},
  { "WAHLUMSCHALTUNG"                                  , 0x006d, 0},
  { "HEIZKREIS_STATUS_PROGSTELL"                       , 0x006e, 0},
  { "FERIENBETRIEB"                                    , 0x006f, 0},
  { "DREHZAHLREG_JA_NEIN"                              , 0x0070, 0},
  { "ANFORDERUNG_LEISTUNGSZWANG"                       , 0x0071, 0},
  { "ANTILEG_AKTIV"                                    , 0x0072, 0},
  { "BITSCHALTER"                                      , 0x0073, 0},
  { "EVU_SPERRE_AKTIV"                                 , 0x0074, 0},
  { "FEUCHTE"                                          , 0x0075, et_dec_val},
  { "PUFFERTEMP_OBEN1"                                 , 0x0076, 0},
  { "PUFFERTEMP_MITTE1"                                , 0x0077, 0},
  { "PUFFERTEMP_UNTEN1"                                , 0x0078, 0},
  { "PUFFERTEMP_OBEN2"                                 , 0x0079, 0},
  { "PUFFERTEMP_MITTE2"                                , 0x007a, 0},
  { "PUFFERTEMP_UNTEN2"                                , 0x007b, 0},
  { "PUFFERTEMP_OBEN3"                                 , 0x007c, 0},
  { "PUFFERTEMP_MITTE3"                                , 0x007d, 0},
  { "PUFFERTEMP_UNTEN3"                                , 0x007e, 0},
  { "EINSTRAHLUNGS_SENSOR"                             , 0x007f, 0},
  { "ECO_AKZEPTANZ_WW"                                 , 0x0080, 0},
  { "ECO_AKZEPTANZ_RAUM"                               , 0x0081, 0},
  { "SOLAR_AKT_VOLUMENSTROM"                           , 0x0082, 0},
  { "SOLAR_DURCHSCHNITT_VOLUMENSTROM"                  , 0x0083, 0},
  { "SOLAR_AKT_LEISTUNG_W"                             , 0x0084, 0},
  { "SOLAR_TAGESERTRAG_WH"                             , 0x0085, 0},
  { "SOLAR_TAGESERTRAG_KWH"                            , 0x0086, et_double_val},
  { "SOLAR_GESAMTERTRAG_WH"                            , 0x0087, 0},
  { "SOLAR_GESAMTERTRAG_KWH"                           , 0x0088, et_double_val},
  { "SOLAR_GESAMTERTRAG_MWH"                           , 0x0089, et_triple_val},
  { "MODGRAD_IST"                                      , 0x008a, 0},
  { "ECO_AKZEPTANZ_PUFFER"                             , 0x008b, 0},
  { "GESAMT_MODGRAD"                                   , 0x008c, 0},
  { "MIN_MOD_KASKADE"                                  , 0x008d, 0},
  { "FEUCHTE_HYSTERESE"                                , 0x008e, 0},
  { "LOAD_STANDARD"                                    , 0x00ef, 0},
  { "ONL_CODENUMMER"                                   , 0x00f0, 0},
  { "ERWEITERUNGSTELEGRAMM"                            , 0x00fa, 0},
  { "SYSTEM_RESET"                                     , 0x00fb, 0}, // write only id 480
  { "CAN_FEHLERMELDUNG"                                , 0x00fc, 0},
  { "BUSKONFIGURATION"                                 , 0x00fd, 0},
  { "INITIALISIERUNG"                                  , 0x00fe, et_little_endian},
  { "UNGUELTIG"                                        , 0x00ff, 0},
  { "ANTILEGIONELLEN"                                  , 0x0101, 0},
  { "AUSSENFUEHLER_VERSORGUNG"                         , 0x0102, 0},
  { "AUFHEIZOPTIMIERUNG"                               , 0x0103, 0},
  { "FERIENDAUER_TAGE"                                 , 0x0106, 0},
  { "RAUMFUEHLERKORREKTUR"                             , 0x0109, 0},
  { "AUSSENTEMPVERZOEGERUNG"                           , 0x010c, 0},
  { "CODENUMMER"                                       , 0x010d, 0},
  { "HEIZKURVE"                                        , 0x010e, et_cent_val},
  { "RAUMEINFLUSS"                                     , 0x010f, 0},
  { "MAX_VORVERLEGUNG"                                 , 0x0110, 0},
  { "HZK_KURVENABSTAND"                                , 0x0111, et_dec_val},
  // Notbetrieb     0x0000
  // Bereitschaft   0x0100
  // Automatik      0x0200
  // Tagbetrieb     0x0300
  // Absenkbetrieb  0x0400
  // Warmwasser     0x0500
  { "PROGRAMMSCHALTER"                                 , 0x0112, et_betriebsart},
  // GERMAN         0x0000
  // ENGISH         0x0100
  // FRANZ          0x0200 ...
  { "SPRACHE"                                          , 0x0113, et_little_endian},
  { "AKTIVES_HEIZPROGRAMM"                             , 0x0114, 0},
  { "HEIZKURVENADAPTION"                               , 0x0115, 0},
  { "HEIZGRENZE_TAG"                                   , 0x0116, 0},
  { "HEIZGRENZE_NACHT"                                 , 0x0117, 0},
  { "ECO_BETRIEB"                                      , 0x0118, 0},
  { "AUSWAHL_STANDARDTEMP"                             , 0x0119, 0},
  // Aufheizprogramm   aus 0x0000   ein 0x0100
  { "ESTRICHFUNKTION"                                  , 0x011a, et_little_endian},
  { "FERIENANFANG_TAG"                                 , 0x011b, et_little_endian},
  { "FERIENANFANG_MONAT"                               , 0x011c, et_little_endian},
  { "FERIENANFANG_JAHR"                                , 0x011d, et_little_endian},
  { "FERIENENDE_TAG"                                   , 0x011e, et_little_endian},
  { "FERIENENDE_MONAT"                                 , 0x011f, et_little_endian},
  { "FERIENENDE_JAHR"                                  , 0x0120, et_little_endian},
  { "WOCHENTAG"                                        , 0x0121, et_little_endian},
  { "TAG"                                              , 0x0122, et_little_endian},
  { "MONAT"                                            , 0x0123, et_little_endian},
  { "JAHR"                                             , 0x0124, et_little_endian}, // +2000
  { "STUNDE"                                           , 0x0125, et_little_endian},
  { "MINUTE"                                           , 0x0126, et_little_endian},
  { "SEKUNDE"                                          , 0x0127, et_little_endian},
  { "BAUWEISE"                                         , 0x0128, 0},
  { "VORLAUF_NENN_SOLLWERT"                            , 0x0129, 0},
  { "VORLAUF_REDUZIER_SOLLWERT"                        , 0x012a, 0},
  { "MIN_TEMP_HZK"                                     , 0x012b, 0},
  { "FERIEN_ABSENKTEMP"                                , 0x012d, 0},
  { "AUSSCHALTZEITOPTI"                                , 0x012e, 0},
  { "MAX_PUMPENDREHZAHL"                               , 0x012f, 0},
  { "MIN_PUMPENDREHZAHL"                               , 0x0130, 0},
  { "BETRIEBSNIVEAU_PWMPUMPE"                          , 0x0131, 0},
  { "HZK_PUMPE_ABSENK"                                 , 0x0132, 0},
  { "WW_SOLLWERT_REDUZIERT"                            , 0x0133, 0},
  { "WW_MAXTEMP"                                       , 0x0134, 0},
  // Vorrang:  0x0100
  // Parallel: 0x0200
  // Vorrang:  0x0300
  { "WARMWASSERMODE"                                   , 0x0135, et_little_endian},
  { "ADAPT_INFO"                                       , 0x0136, 0},
  { "KESSELSOLLTEMP_2WE"                               , 0x0137, et_dec_val},
  { "DURCHFLUSS_CH"                                    , 0x0139, 0},
  { "STANDBY_GEBLAESE_DREHZAHL"                        , 0x013a, 0},
  { "BENOETIGTE_AUFHEIZZEIT"                           , 0x013b, 0},
  { "ABWESENHEITSTEMP"                                 , 0x013d, 0},
  { "EINSTELL_SPEICHERSOLLTEMP3"                       , 0x013e, 0},
  { "K_OS_OBERE_GEBLAESE_DREHZAHL"                     , 0x013f, 0},
  { "WW_HYSTERSE"                                      , 0x0140, 0},
  { "HZK_MODE"                                         , 0x0141, 0},
  { "HZK_NACHLAUF"                                     , 0x0142, 0},
  { "TAKTSPERRE"                                       , 0x0143, 0},
  { "EINMAL_WW_AKTIV"                                  , 0x0144, 0},
  { "ABGASTEMP"                                        , 0x0145, 0},
  { "KUNDEN_KENNUNG"                                   , 0x0146, 0},
  { "HERSTELLER_KENNUNG"                               , 0x0147, 0},
  { "GERAETE_KENNUNG"                                  , 0x0148, 0},
  { "K_OS_MAX_VL_AENDERUNG"                            , 0x0150, 0},
  { "K_OS_MAX_DREHZAHLAENDERUNG"                       , 0x0151, 0},
  { "K_OS_FREIGABEDREHZAHL"                            , 0x0152, 0},
  { "K_OS_SOFTSTARTZEIT"                               , 0x0153, 0},
  { "RUECKLAUF_HYSTERESE"                              , 0x0154, 0},
  { "MIN_PUMPENLEISTUNG"                               , 0x0155, 0},
  { "MAX_PUMPENLEISTUNG"                               , 0x0156, 0},
  { "PUMPENLEISTUNG_WW"                                , 0x0157, 0},
  { "PUMPENLEISTUNG_STANDBY"                           , 0x0158, 0},
  { "K_OS_OBERE_GEBLAESE_DREHZAHL_WW"                  , 0x0159, 0},
  { "K_OS_UNTERE_GEBLAESE_DREHZAHL"                    , 0x015a, 0},
  { "GERAETEKONFIGURATION_2"                           , 0x015b, et_little_endian},
  { "QQ_BEI_TRANSPARENT_MODE"                          , 0x015c, 0},
  { "NON_FAILSAVE_CRC"                                 , 0x015d, 0},
  { "FAILSAVE_CRC"                                     , 0x015e, 0},
  { "DATEN_GESCHRIEBEN"                                , 0x015f, 0},
  { "K_OS_GRENZE_OBERE_GEBLAESEDREHZAHL"               , 0x0160, 0},
  { "KESSELREGLER_P_ANTEIL"                            , 0x0161, 0},
  { "KESSELREGLER_I_ANTEIL"                            , 0x0162, 0},
  { "K_OS_FREIGABEDREHZAHL_SPEICHER_KOMBI"             , 0x0163, 0},
  { "DURCHLAUFREGLER_2_PUNKT_UEBERHOEHUNG"             , 0x0164, 0},
  { "K_OS_TURBINENPARAMETRIERUNG"                      , 0x0165, 0},
  { "FAKTOR_DURCHLAUFUEBERHOEHUNG"                     , 0x0166, 0},
  { "ZAPFBEGINN"                                       , 0x0167, 0},
  { "DURCHLAUFREGLER_P_ANTEIL"                         , 0x0168, 0},
  { "DURCHLAUFREGLER_I_ANTEIL"                         , 0x0169, 0},
  { "WW_SCHNELL_START_TEMPERATUR"                      , 0x016a, 0},
  { "GASART"                                           , 0x016b, 0},
  { "DURCHFLUSS_WW"                                    , 0x016c, 0},
  { "PWM_SIGNAL_PUMPE"                                 , 0x016d, 0},
  { "GEBLAESE_SOLLWERT"                                , 0x016e, 0},
  { "GEBLAESEDREHZAHL"                                 , 0x016f, 0},
  { "IO_ISTWERT"                                       , 0x0170, 0},
  { "INDIKATOR"                                        , 0x0171, 0},
  { "K_OS_EINGANGSZUSTAND_KM351"                       , 0x0172, 0},
  { "K_OS_AUSGANGSZUSTAND_KM351"                       , 0x0173, 0},
  { "K_OS_STATUS_KM351"                                , 0x0174, 0},
  { "FEUERUNGSAUTOMAT_STATUS"                          , 0x0175, 0},
  // Verdichter 1:        0x0001
  // Verdichter 2:        0x0002
  // Pufferladepumpe 1:   0x0040
  // Pufferladepumpe 2:   0x0080
  // DHC 1:               0x1000
  // DHC 2:               0x2000
  // Warmwasserladepumpe: 0x8000
  // EVU Sperre:          0x8000
  { "BETRIEBS_STATUS"                                  , 0x0176, 0},
  { "ZUSTAND_BCC"                                      , 0x0177, 0},
  { "BUSKENNUNG"                                       , 0x0178, 0},
  { "K_OS_GERAETEKONFIGURATON"                         , 0x0179, 0},
  { "TROCKENLAUFFUNKTION"                              , 0x017a, 0},
  { "MISCHERLEISTUNGSSOLLWERT"                         , 0x017b, 0},
  { "KONFIG_LEISTUNGSSOLLWERT"                         , 0x017c, 0},
  { "TELEFONKONTAKT"                                   , 0x017d, 0},
  { "HEIZ_ZEIT_STATUS"                                 , 0x017e, 0},
  { "WW_NACHLAUFZEIT"                                  , 0x017f, 0},
  { "MAX_WW_LADEZEIT"                                  , 0x0180, 0},
  { "MAX_WW_TEMP"                                      , 0x0181, et_dec_val},
  { "PARAMETER_ZIRKULATIONSPUMPE"                      , 0x0182, 0},
  { "FERNBEDIENUNGSZUORDNUNG"                          , 0x0183, 0},
  { "MITTELLUNGSZEIT"                                  , 0x0184, 0},
  { "EINSTELL_MODULATIONS_SPERRZEIT"                   , 0x0185, 0},
  { "BRENNERART"                                       , 0x0186, 0},
  { "BRENNERSTUFEN_WW"                                 , 0x0187, 0},
  { "SOMMER_WINTERZEITUMSTELLUNG"                      , 0x0188, 0},
  { "FEIERTAGS_PROGRAMM"                               , 0x0189, 0},
  { "FEIER_DAUER"                                      , 0x018a, 0},
  { "UNTERE_GRENZE_MINKESSELTEMP"                      , 0x018b, 0},
  { "SERVICE_MINUTEN"                                  , 0x018c, 0},
  { "KONFIG_KONTAKT_OHNE_SPF"                          , 0x018d, 0},
  { "MODULATIONSDYNAMIK"                               , 0x018e, 0},
  { "MISCHERPARAMETER"                                 , 0x018f, 0},
  { "RUECKLAUFTEMPERATURANHEBUNG"                      , 0x0190, 0},
  { "BRENNSTOFFVERBRAUCH_PAR_BR1"                      , 0x0191, 0},
  { "BRENNSTOFFVERBRAUCH_PAR_BR2"                      , 0x0192, 0},
  { "MAX_ABGASTEMP"                                    , 0x0193, 0},
  { "EINSCHALTTEMPERATUR_DIFFERENZ"                    , 0x0194, 0},
  { "AUSSCHALTTEMPERATUR_DIFFERENZ"                    , 0x0195, 0},
  { "BRENNSTOFFVERBRAUCH_BRENNER1"                     , 0x0196, 0},
  { "BRENNSTOFFVERBRAUCH_BRENNER2"                     , 0x0197, 0},
  { "MIN_SOLAR_SPEICHERTEMP"                           , 0x0198, 0},
// Wörsty:
// 0x500   0x0199: 0x00f3    0x019a: 0x0007
// 0x480   0x0199: 0xa500    0x019a: 0x1700
  { "SOFTWARE_NUMMER"                                  , 0x0199, 0},
  { "SOFTWARE_VERSION"                                 , 0x019a, 0},
  { "SPEICHER_ZEIT_STATUS"                             , 0x019b, 0},
  // HK1 Pumpe:         0x0001
  // HK2 Punpe:         0x0002
  // Mischer auf:       0x0004
  // Mischer zu:        0x0008
  // Quellenpumpe:      0x0010
  // Solarpumpe:        0x0020
  // 2. WE:             0x0040
  // Zirkulationspumpe: 0x0080
  { "INFO_TYP"                                         , 0x019c, 0},
  { "MISCHERPARAMETER_ZU"                              , 0x019d, 0},
  { "WW_BETRIEB"                                       , 0x019e, 0},
  { "MULTIFUNKTIONS_SCHALTHYSTERESE"                   , 0x019f, 0},
  { "MULTIFUNKTIONS_SCHALTTEMP"                        , 0x01a0, 0},
  { "PC_CODENUMMER"                                    , 0x01a1, 0},
  { "MAX_WASSERDRUCK"                                  , 0x01a2, 0},
  { "AUSGANG_KM_OS"                                    , 0x01a3, 0},
  { "EINGANG_KM_OS"                                    , 0x01a4, 0},
  { "K_OS_UNTERE_GEBLAESE_DREHZAHL_WW"                 , 0x01a5, 0},
  { "K_OS_GEBLAESE_DREHZAHL_WW"                        , 0x01a6, 0},
  { "K_OS_KASKADENRELAIS_EINSCHALTVERZOEGERUNG"        , 0x01a7, 0},
  { "K_OS_KASKADENRELAIS_AUSSCHALTLEISTUNG"            , 0x01a8, 0},
  { "EINGANG_SPANNUNG"                                 , 0x01a9, 0},
  { "EINGANG_STROM"                                    , 0x01aa, 0},
  { "DONGLE_NR"                                        , 0x01ab, 0},
  { "BIVALENTPARALLELTEMPERATUR_HZG"                   , 0x01ac, et_dec_val}, // negative Werte
  { "BIVALENTPARALLELTEMPERATUR_WW"                    , 0x01ad, et_dec_val},
  { "BIVALENZALTERNATIVTEMPERATUR_HZG"                 , 0x01ae, et_dec_val},
  { "BIVALENZALTERNATIVTEMPERATUR_WW"                  , 0x01af, et_dec_val},
  { "QUELLENSOLLTEMPERATUR"                            , 0x01b0, et_dec_val}, // min. Temp.?
  { "SOLLTEMP_ANZEIGE_0_1"                             , 0x01b1, 0},
  { "SOLLTEMP_ANZEIGE_0_2"                             , 0x01b2, 0},
  { "SOLLTEMP_ANZEIGE_0_3"                             , 0x01b3, 0},
  { "SOLLTEMP_ANZEIGE_1_1"                             , 0x01b4, 0},
  { "SOLLTEMP_ANZEIGE_1_2"                             , 0x01b5, 0},
  { "SOLLTEMP_ANZEIGE_1_3"                             , 0x01b6, 0},
  { "AUSSENTEMPERATUR_WARMWASSER"                      , 0x01b7, et_dec_val},
  { "SOLARDIFFERENZ"                                   , 0x01b8, et_dec_val},
  { "SOLARTEMP_MAX"                                    , 0x01b9, et_dec_val},
  { "ESTRICH_STEIGUNG_PRO_TAG"                         , 0x01ba, 0},
  { "ESTRICH_SOCKELTEMPERATUR"                         , 0x01bb, et_dec_val},
  { "ESTRICH_HALTEN_SOCKELTEMPERATUR"                  , 0x01bc, 0},
  { "ESTRICH_MAX_TEMPERATUR"                           , 0x01bd, et_dec_val},
  { "ESTRICH_HALTEN_MAX_TEMPERATUR"                    , 0x01be, 0},
  { "SW_AUSSENTEMP"                                    , 0x01bf, et_dec_val},
  // Regelung / Festwertregelung
  { "FESTWERT"                                         , 0x01c0, et_little_endian}, // Festwerttemp.
  { "GESAMTERTRAG_WATT"                                , 0x01c1, 0},
  { "GESAMTERTRAG_KWATT"                               , 0x01c2, 0},
  { "GESAMTERTRAG_MWATT"                               , 0x01c3, 0},
  { "LAUFZEIT_WP1"                                     , 0x01c4, 0},
  { "LAUFZEIT_WP2"                                     , 0x01c5, 0},
  { "LAUFZEIT_WP3"                                     , 0x01c6, 0},
  { "LAUFZEIT_WP4"                                     , 0x01c7, 0},
  { "LAUFZEIT_WP5"                                     , 0x01c8, 0},
  { "LAUFZEIT_WP6"                                     , 0x01c9, 0},
  { "LAUFZEIT_SOLAR"                                   , 0x01ca, 0},
  { "LAUFZEIT_2WE"                                     , 0x01cb, 0},
  { "STILLSTANDZEIT_0"                                 , 0x01cc, 0},
  { "STILLSTANDZEIT_1"                                 , 0x01cd, 0},
  { "STILLSTANDZEIT_2"                                 , 0x01ce, 0},
  { "STILLSTANDZEIT_3"                                 , 0x01cf, 0},
  { "STILLSTANDZEIT_4"                                 , 0x01d0, 0},
  { "STILLSTANDZEIT_5"                                 , 0x01d1, 0},
  { "PUMPENSTATUS"                                     , 0x01d2, et_little_endian},
  { "EVU"                                              , 0x01d3, 0},
  { "QUELLE_IST"                                       , 0x01d4, et_dec_val},
  { "PUFFERSOLL"                                       , 0x01d5, et_dec_val},
  { "WPVORLAUFIST"                                     , 0x01d6, et_dec_val},
  { "HILFSKESSELSOLL"                                  , 0x01d7, et_dec_val}, // Ruecklaufsoll.?
  { "FUEHLER_1"                                        , 0x01d8, et_dec_val},
  { "FUEHLER_2"                                        , 0x01d9, et_dec_val},
  { "VOLUMENSTROM"                                     , 0x01da, 0},
  { "ERTRAG_AKT"                                       , 0x01db, 0},
  { "ERTRAG_TAG_W"                                     , 0x01dc, 0},
  { "ERTRAG_TAG_KW"                                    , 0x01dd, 0},
  { "KESSELREGLER_D_ANTEIL"                            , 0x01de, 0},
  { "DURCHLAUFREGLER_D_ANTEIL"                         , 0x01df, 0},
  { "FUEHLERFROSTSCHUTZ"                               , 0x01e0, 0},
  { "PUMPENSTEUERUNG_dT"                               , 0x01e1, 0},
  { "SOLL_DIFFERENZ_RUECKLAUF"                         , 0x01e2, 0},
  { "MAX_DIFFERENZ_RUECKLAUF"                          , 0x01e3, 0},
  { "K_OS_GEBLAESEREGLERANPASSUNG"                     , 0x01e4, 0},
  { "K_OS_START_PWM"                                   , 0x01e5, 0},
  { "GEBLAESEREGLER_P_ANTEIL"                          , 0x01e6, 0},
  { "GEBLAESEREGLER_I_ANTEIL"                          , 0x01e7, 0},
  { "MAX_HEIZUNG_TEMP"                                 , 0x01e8, et_dec_val},
  { "MAX_POS_GEBLAESEANSTIEG"                          , 0x01e9, 0},
  { "MAX_NEG_GEBLAESEANSTIEG"                          , 0x01ea, 0},
  { "STEP_dT_REGELUNG"                                 , 0x01eb, 0},
  { "ABSENKZEIT"                                       , 0x01ec, 0},
  { "SCHALTPROG_0_6"                                   , 0x01ed, 0},
  { "SCHALTPROG_6_12"                                  , 0x01ee, 0},
  { "SCHALTPROG_12_18"                                 , 0x01ef, 0},
  { "SCHALTPROG_18_24"                                 , 0x01f0, 0},
  { "FEHLERLISTEN_EINTRAG"                             , 0x01f1, 0},
  { "FEHLERART"                                        , 0x01f2, 0},
  { "ZUFALLSZAHL"                                      , 0x01f3, 0},
  { "DONGELKEY1"                                       , 0x01f4, 0},
  { "DONGELKEY2"                                       , 0x01f5, 0},
  { "K_OS_PUMPENLEISTUNG_VORSPUELUNG"                  , 0x01f6, 0},
  { "K_OS_PUMPENTAKTUNG_PAUSE"                         , 0x01f7, 0},
  { "K_OS_PUMPENTAKTUNG_PULS"                          , 0x01f8, 0},
  { "K_OS_NEG_HYSTERESE_VORL"                          , 0x01f9, 0},
  { "K_OS_WW_SCHNELLSTARTTEMPERATUR"                   , 0x01fa, 0},
  { "K_OS_DYN_KESSELHYSTERESE_ZEIT"                    , 0x01fb, 0},
  { "K_OS_DYN_KESSELHYSTERESE_DELTA"                   , 0x01fc, 0},
  { "K_OS_WARMWASSER_HYSTERESE"                        , 0x01fd, 0},
  { "K_OS_TOLERANZZEIT_SW_KONTROLLE"                   , 0x01fe, 0},
  { "K_OS_TOLERANZZEIT_NON_ZERO_CHECK"                 , 0x01ff, 0},
  { "K_OS_LEISTUNG_KASKADENRELAIS_EIN"                 , 0x0200, 0},
  { "K_OS_AUSSCHALTVERZ_KASKADENRELAIS"                , 0x0201, 0},
  { "K_OS_FS_OPTIONEN"                                 , 0x0202, 0},
  { "K_OS_FS_GEBLAESEREGELUNG"                         , 0x0203, 0},
  { "K_OS_FS_VORSPUELZEIT"                             , 0x0204, 0},
  { "K_OS_FS_SICHERHEITSZEIT"                          , 0x0205, 0},
  { "K_OS_FS_NACHSPUELZEIT"                            , 0x0206, 0},
  { "K_OS_FS_VORZUENDZEIT"                             , 0x0207, 0},
  { "K_OS_FS_FLAMMENSTABILISIERUNGSZEIT"               , 0x0208, 0},
  { "K_OS_FS_ZUENDDREHZAHL"                            , 0x0209, 0},
  { "K_OS_FS_VORSPUELDREHZAHL"                         , 0x020a, 0},
  { "K_OS_FS_NACHSPUELDREHZAHL"                        , 0x020b, 0},
  { "K_OS_FS_ANZAHL_STARTVERSUCHE"                     , 0x020c, 0},
  { "K_OS_FS_MINIMALE_DREHZAHL"                        , 0x020d, 0},
  { "K_OS_FS_MAXIMALE_DREHZAHL"                        , 0x020e, 0},
  { "K_OS_FS_STB_KESSELTEMPERATUR"                     , 0x020f, 0},
  { "K_OS_FS_STW_KESSELTEMPERATUR"                     , 0x0210, 0},
  { "K_OS_FS_ASTB_ABSCHALTTEMPERATUR_ABGAS"            , 0x0211, 0},
  { "K_OS_FS_OFFSET_FLAMMENVERSTAERKER"                , 0x0212, 0},
  { "K_OS_FS_ABSCHALTSCHWELLE_FLAMMENVERST"            , 0x0213, 0},
  { "K_OS_FS_EINSCHALTSCHWELLE_FLAMMENVERST"           , 0x0214, 0},
  { "K_OS_FS_MAXIMALE_DREHZAHLGRENZE"                  , 0x0215, 0},
  { "K_OS_FS_CRC"                                      , 0x0216, 0},
  { "K_OS_DONGLE_NR_LO"                                , 0x0217, 0},
  { "K_OS_DONGLE_NR_HI"                                , 0x0218, 0},
  { "K_OS_FIRMWARE_01"                                 , 0x0219, 0},
  { "K_OS_FIRMWARE_02"                                 , 0x021a, 0},
  { "K_OS_FIRMWARE_03"                                 , 0x021b, 0},
  { "K_OS_FIRMWARE_04"                                 , 0x021c, 0},
  { "K_OS_FIRMWARE_05"                                 , 0x021d, 0},
  { "K_OS_BRENNERSTARTS_LO_MID"                        , 0x0226, 0},
  { "K_OS_BRENNERSTARTS_HI"                            , 0x0227, 0},
  { "K_OS_NETZBETRIEB_LO_HI"                           , 0x0228, 0},
  { "K_OS_NETZBETRIEB_HI"                              , 0x0229, 0},
  { "K_OS_BRENNERBETRIEB_LO_HI"                        , 0x022a, 0},
  { "K_OS_STOERMELDUNG_1"                              , 0x022b, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_1"                      , 0x022c, 0},
  { "K_OS_STOERMELDUNG_2"                              , 0x022d, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_2"                      , 0x022e, 0},
  { "K_OS_STOERMELDUNG_3"                              , 0x022f, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_3"                      , 0x0230, 0},
  { "K_OS_STOERMELDUNG_4"                              , 0x0231, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_4"                      , 0x0232, 0},
  { "K_OS_STOERMELDUNG_5"                              , 0x0233, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_5"                      , 0x0234, 0},
  { "K_OS_STOERMELDUNG_6"                              , 0x0235, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_6"                      , 0x0236, 0},
  { "K_OS_STOERMELDUNG_7"                              , 0x0237, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_7"                      , 0x0238, 0},
  { "K_OS_STOERMELDUNG_8"                              , 0x0239, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_8"                      , 0x023a, 0},
  { "K_OS_STOERMELDUNG_9"                              , 0x023b, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_9"                      , 0x023c, 0},
  { "K_OS_STOERMELDUNG_10"                             , 0x023d, 0},
  { "K_OS_STUNDEN_TAGESZAEHLER_10"                     , 0x023e, 0},
  { "K_OS_20S_ZAEHLER"                                 , 0x023f, 0},
  { "DEBUG_MEMORY_POINTER"                             , 0x024e, 0},
  { "DEBUG_MEMORY_WERT_INT8"                           , 0x024f, 0},
  { "DEBUG_MEMORY_WERT_INT16"                          , 0x0250, 0},
  { "DEBUG_EEPROM_POINTER"                             , 0x0251, 0},
  { "DEBUG_EEPROM_WERT_INT8"                           , 0x0252, 0},
  { "DEBUG_EEPROM_WERT_INT16"                          , 0x0253, 0},
  { "TARGET_COMPILING_DATE"                            , 0x0254, 0},
  { "TARGET_COMPILING_TIME"                            , 0x0255, 0},
  { "ENTRIEGELN_FA"                                    , 0x0258, 0},
  { "LAUFZEIT_DHC1"                                    , 0x0259, 0},
  { "LAUFZEIT_DHC2"                                    , 0x025a, 0},
  { "GEBLAESEKUEHLUNG"                                 , 0x025b, 0},
  { "VORLAUFSOLL_GEBLAESE"                             , 0x025c, et_dec_val},
  { "RAUMSOLL_GEBLAESE"                                , 0x025d, et_dec_val},
  { "HYSTERESE_GEBLAESE"                               , 0x025e, et_dec_val},
  { "FLAECHENKUEHLUNG"                                 , 0x025f, 0},
  { "VORLAUFSOLL_FLAECHE"                              , 0x0260, et_dec_val},
  { "RAUMSOLL_FLAECHE"                                 , 0x0261, et_dec_val},
  { "HYSTERESE_FLAECHE"                                , 0x0262, 0},
  { "WWKORREKTUR"                                      , 0x0263, 0},
  { "TAUPUNKT_TEMP"                                    , 0x0264, et_dec_val},
  { "HEISSGAS_TEMP"                                    , 0x0265, et_dec_val},
  { "HDSENSOR_TEMP"                                    , 0x0266, 0},
  { "TASTENSPERRE"                                     , 0x0267, 0},
  { "MASCHINENDRUCK"                                   , 0x0268, 0},
  { "EXT_RAUMFUEHLER"                                  , 0x0269, 0},
  { "WARTUNGSMELDUNGSZEIT"                             , 0x026a, 0},
  { "GEBLAESE_ZUENDDREHZAHL"                           , 0x026b, 0},
  { "GEBLAESE_VORSPUELDREHZAHL"                        , 0x026c, 0},
  { "MIN_DURCHFLUSS_FA"                                , 0x026d, 0},
  { "DURCHFLUSS_SCHUTZ_FA"                             , 0x026e, 0},
  { "HYSTERESE_MOD_KESSEL"                             , 0x026f, 0},
  { "GERAETEFOLGE_1"                                   , 0x0270, 0},
  { "GERAETEFOLGE_2"                                   , 0x0271, 0},
  { "GERAETEFOLGE_3"                                   , 0x0272, 0},
  { "GERAETEFOLGE_4"                                   , 0x0273, 0},
  { "SAMMLERKONSTANT_TEMP"                             , 0x0274, 0},
  { "UMSCHALTUNG_SPEICHERVORRANG"                      , 0x0275, 0},
  { "DT_MAX_PARALLELBETRIEB"                           , 0x0276, 0},
  { "OFFSET_TIME_MISCHERRELAIS"                        , 0x0277, 0},
  { "SYSTEMAUSWAHL"                                    , 0x0278, 0},
  { "TEMPERATURWAECHTER_TEMP"                          , 0x0279, 0},
  { "GESPEICHERTE_FEHLER_LOESCHEN"                     , 0x027a, 0},
  { "FEHLERSTATISTIK_FELDINDEX"                        , 0x027b, 0},
  { "FEHLERSTATISTIK_FEHLERNUMMER"                     , 0x027c, 0},
  { "FEHLERSTATISTIK_FEHLERANZAHL"                     , 0x027d, 0},
  // Warmwasser / WW ECO  aus 0   ein 01
  { "WW_ECO"                                           , 0x027e, et_bool},
  { "ANZEIGE_HEIZPROG_NACH_HEIZKREIS"                  , 0x027f, 0},
  { "SAMMEL_SOLAR_STATUS"                              , 0x0280, 0},
  { "MODULATION_SOLLWERT_SOLAR_1"                      , 0x0281, 0},
  { "MODULATION_SOLLWERT_SOLAR_2"                      , 0x0282, 0},
  { "MIN_TEMP_KESSEL_HEIZBETRIEB"                      , 0x0283, 0},
  { "MAX_TEMP_KESSEL_HEIZBETRIEB"                      , 0x0284, 0},
  { "HZK_PUMPENDREHZAHL_SOLLWERT"                      , 0x0285, 0},
  { "WEICHENISTTEMP"                                   , 0x0286, 0},
  { "KUEHLMODE"                                        , 0x0287, 0},
  { "KUEHLDYNAMIK_FLAECHE"                             , 0x0288, 0},
  { "KUEHLDYNAMIK_GEBLAESE"                            , 0x0289, 0},
  { "MIN_WW_TEMP"                                      , 0x028a, 0},
  { "RAUMEINFLUSS_PAR_ON_OFF"                          , 0x028b, 0},
  { "RUECKLAUFKONFIGURATION"                           , 0x028c, 0},
  { "BYPASSPUMPEN_STATUS"                              , 0x028d, 0},
  { "SPG_KURVE"                                        , 0x028e, 0},
  { "SPG_KURVE_U1"                                     , 0x028f, 0},
  { "SPG_KURVE_U2"                                     , 0x0290, 0},
  { "SPG_KURVE_T1"                                     , 0x0291, 0},
  { "SPG_KURVE_T2"                                     , 0x0292, 0},
  { "SPG_KURVE_U_AUS"                                  , 0x0293, 0},
  { "WE1_TYP"                                          , 0x0294, 0},
  { "WE_REGELUNGSTYP"                                  , 0x0295, 0},
  { "WE1_PELLET"                                       , 0x0296, 0},
  { "WE1_BUS"                                          , 0x0297, 0},
  { "WE2_TYP"                                          , 0x0298, 0},
  { "HZ_PUFFER"                                        , 0x0299, 0},
  { "WE2_SPEICHER"                                     , 0x029a, 0},
  { "WE2_MAXTEMP"                                      , 0x029b, 0},
  { "WE2_MINTEMP"                                      , 0x029c, 0},
  { "KESSELMODGRAD_BEI_WW"                             , 0x029d, 0},
  { "MIN_WE_MODGRAD"                                   , 0x029e, 0},
  { "TN_KASKADE"                                       , 0x029f, 0},
  { "QUOTIENT_KASKADE_AUF"                             , 0x02a0, 0},
  { "QUOTIENT_KASKADE_AB"                              , 0x02a1, 0},
  { "ANZAHL_START_KESSEL"                              , 0x02a2, 0},
  { "AKTIVE_FOLGE"                                     , 0x02a3, 0},
  { "WARTUNG_BETRIEBS_STD"                             , 0x02a4, 0},
  { "BUSABSCHLUSS"                                     , 0x02a5, 0},
  { "FUNKTION_MFR_INDEX"                               , 0x02a6, 0},
  { "FKT_MFR_FUNKTION"                                 , 0x02a7, 0},
  { "FKT_MFR_SCHALTTEMP"                               , 0x02a8, 0},
  { "FKT_MFR_HYSTERESE"                                , 0x02a9, 0},
  { "BRENNER_INDEX"                                    , 0x02aa, 0},
  { "BRENNER_LEISTUNG"                                 , 0x02ab, 0},
  { "BRENNER_STARTS"                                   , 0x02ac, 0},
  { "BRENNER_LAUFZEIT"                                 , 0x02bc, 0},
  { "ABGELAUFENE_WARTUNGSZEIT"                         , 0x02bd, 0},
  { "PUMPENSTOPP_MIT_RAUMREGLER"                       , 0x02be, 0},
  { "ABSENKSTOP"                                       , 0x02bf, 0},
  { "AUSSENTEMP_MAX"                                   , 0x02c0, 0},
  { "AUSSENTEMP_MIN"                                   , 0x02c1, 0},
  { "ANZAHL_STARTVERSUCHE"                             , 0x02c2, 0},
  { "FA_STATUS"                                        , 0x02c3, 0},
  { "FERNBEDIENUNG"                                    , 0x02c4, 0},
  { "WW_DURCHLADEN"                                    , 0x02c5, 0},
  { "EXT_SOLLTEMP"                                     , 0x02c6, 0},
  { "RUECKLAUFISTTEMP_2"                               , 0x02c7, 0},
  { "ANFORDERUNG_KONSTANTTEMPERATUR"                   , 0x02c8, 0},
  { "MATERIALNUMMER_LOW"                               , 0x02c9, 0},
  { "MATERIALNUMMER_HIGH"                              , 0x02ca, 0},
  { "HEIZSYSTEMTEMP_GEWICHTET"                         , 0x02cb, 0},
  { "LEISTUNG_PUMPE_HZK"                               , 0x02cc, 0},
  { "LEISTUNG_PUMPE_SPL"                               , 0x02cd, 0},
  { "LEISTUNG_PUMPE_WW_PRI"                            , 0x02ce, 0},
  { "SOLARPUMPEN_STATUS_1"                             , 0x02cf, 0},
  { "SOLARPUMPEN_STATUS_2"                             , 0x02d0, 0},
  { "LADEPUMPE_PUFFER_1"                               , 0x02d1, 0},
  { "LADEPUMPE_PUFFER_2"                               , 0x02d2, 0},
  { "LADEPUMPE_PUFFER_3"                               , 0x02d3, 0},
  { "VOLUMENSTROM_SOLARPUMPE_1"                        , 0x02d4, 0},
  { "VOLUMENSTROM_SOLARPUMPE_2"                        , 0x02d5, 0},
  { "SOLARPUMPE_DREHZAHL_SOLL_1"                       , 0x02d6, 0},
  { "SOLARPUMPE_DREHZAHL_MAX_1"                        , 0x02d7, 0},
  { "SOLARPUMPE_DREHZAHL_MIN_1"                        , 0x02d8, 0},
  { "SOLARPUMPE_DREHZAHLDYNAMIK_1"                     , 0x02d9, 0},
  { "KOLLEKTORANZAHL"                                  , 0x02da, 0},
  { "PRIO_1_PUFFER"                                    , 0x02db, 0},
  { "PRIO_2_PUFFER"                                    , 0x02dc, 0},
  { "PRIO_3_PUFFER"                                    , 0x02dd, 0},
  { "WE_GEFUNDEN"                                      , 0x02de, 0},
  { "WE_KONFIG_OK"                                     , 0x02df, 0},
  { "BUS_SCAN"                                         , 0x02e0, 0},
  { "WE2_ISTTEMP"                                      , 0x02e1, 0},
  { "WE_KONFIGURATION"                                 , 0x02e2, 0},
  { "VOLUMENSTROM_PUMPE_HZK"                           , 0x02e3, 0},
  { "VOLUMENSTROM_PUMPE_SPL"                           , 0x02e4, 0},
  { "VOLUMENSTROM_PUMPE_WW_PRI"                        , 0x02e5, 0},
  { "SOLAR_WOCHENERTRAG_WH"                            , 0x02e6, 0},
  { "SOLAR_WOCHENERTRAG_KWH"                           , 0x02e7, et_double_val},
  { "SOLAR_WOCHENERTRAG_MWH"                           , 0x02e8, et_triple_val},
  { "SOLAR_JAHRESERTRAG_WH"                            , 0x02e9, 0},
  { "SOLAR_JAHRESERTRAG_KWH"                           , 0x02ea, et_double_val},
  { "SOLAR_JAHRESERTRAG_MWH"                           , 0x02eb, et_triple_val},
  { "SOLAR_UMSCHALTVENTIL_1"                           , 0x02ec, 0},
  { "SOLAR_UMSCHALTVENTIL_2"                           , 0x02ed, 0},
  { "SOLAR_UMSCHALTVENTIL_3"                           , 0x02ee, 0},
  { "SOLARPUMPENDREHZAL_1"                             , 0x02ef, 0},
  { "SOLARPUMPENDREHZAL_2"                             , 0x02f0, 0},
  { "SOLARPUMPENDREHZAL_3"                             , 0x02f1, 0},
  { "SOLAR_BETRIEBSSTATUS"                             , 0x02f2, 0},
  { "ANFORDERUNG_NACHHEIZUNG"                          , 0x02f3, 0},
  { "MODUL_IDENTIFIKATION"                             , 0x02f4, 0},
  { "AEE_STATUS"                                       , 0x02f5, 0},
  { "KOLLEKTORSCHUTZFUNKTION"                          , 0x02f6, 0},
  { "KOLLEKTORMAXTEMP"                                 , 0x02f7, 0},
  { "SOLARSPEICHER_ZUORDNUNG"                          , 0x02f8, 0},
  { "DURCHFLUSSMENGE_SOLAR"                            , 0x02f9, 0},
  { "SOLARPUMPENBETRIEBSSTUNDEN1"                      , 0x02fa, 0},
  { "SOLARPUMPENBETRIEBSSTUNDEN2"                      , 0x02fb, 0},
  { "SOLARRUECKLAUFTEMP"                               , 0x02fc, 0},
  { "SOLAR_MONATRSERTRAG_W_1"                          , 0x02fd, 0},
  { "SOLAR_MONATRSERTRAG_W_2"                          , 0x02fe, 0},
  { "SOLAR_MONATRSERTRAG_W_3"                          , 0x02ff, 0},
  { "SOLAR_MONATRSERTRAG_W_4"                          , 0x0300, 0},
  { "SOLAR_MONATRSERTRAG_W_5"                          , 0x0301, 0},
  { "SOLAR_MONATRSERTRAG_W_6"                          , 0x0302, 0},
  { "SOLAR_MONATRSERTRAG_W_7"                          , 0x0303, 0},
  { "SOLAR_MONATRSERTRAG_W_8"                          , 0x0304, 0},
  { "SOLAR_MONATRSERTRAG_W_9"                          , 0x0305, 0},
  { "SOLAR_MONATRSERTRAG_W_10"                         , 0x0306, 0},
  { "SOLAR_MONATRSERTRAG_W_11"                         , 0x0307, 0},
  { "SOLAR_MONATRSERTRAG_W_12"                         , 0x0308, 0},
  { "SOLAR_MONATRSERTRAG_KW_1"                         , 0x0309, 0},
  { "SOLAR_MONATRSERTRAG_KW_2"                         , 0x030a, 0},
  { "SOLAR_MONATRSERTRAG_KW_3"                         , 0x030b, 0},
  { "SOLAR_MONATRSERTRAG_KW_4"                         , 0x030c, 0},
  { "SOLAR_MONATRSERTRAG_KW_5"                         , 0x030d, 0},
  { "SOLAR_MONATRSERTRAG_KW_6"                         , 0x030e, 0},
  { "SOLAR_MONATRSERTRAG_KW_7"                         , 0x030f, 0},
  { "SOLAR_MONATRSERTRAG_KW_8"                         , 0x0310, 0},
  { "SOLAR_MONATRSERTRAG_KW_9"                         , 0x0311, 0},
  { "SOLAR_MONATRSERTRAG_KW_10"                        , 0x0312, 0},
  { "SOLAR_MONATRSERTRAG_KW_11"                        , 0x0313, 0},
  { "SOLAR_MONATRSERTRAG_KW_12"                        , 0x0314, 0},
  { "SOLAR_MONATRSERTRAG_MW_1"                         , 0x0315, 0},
  { "SOLAR_MONATRSERTRAG_MW_2"                         , 0x0316, 0},
  { "SOLAR_MONATRSERTRAG_MW_3"                         , 0x0317, 0},
  { "SOLAR_MONATRSERTRAG_MW_4"                         , 0x0318, 0},
  { "SOLAR_MONATRSERTRAG_MW_5"                         , 0x0319, 0},
  { "SOLAR_MONATRSERTRAG_MW_6"                         , 0x031a, 0},
  { "SOLAR_MONATRSERTRAG_MW_7"                         , 0x031b, 0},
  { "SOLAR_MONATRSERTRAG_MW_8"                         , 0x031c, 0},
  { "SOLAR_MONATRSERTRAG_MW_9"                         , 0x031d, 0},
  { "SOLAR_MONATRSERTRAG_MW_10"                        , 0x031e, 0},
  { "SOLAR_MONATRSERTRAG_MW_11"                        , 0x031f, 0},
  { "SOLAR_MONATRSERTRAG_MW_12"                        , 0x0320, 0},
  { "SOLAR_JAHRESERTRAG_W_1"                           , 0x0321, 0},
  { "SOLAR_JAHRESERTRAG_W_2"                           , 0x0322, 0},
  { "SOLAR_JAHRESERTRAG_W_3"                           , 0x0323, 0},
  { "SOLAR_JAHRESERTRAG_W_4"                           , 0x0324, 0},
  { "SOLAR_JAHRESERTRAG_W_5"                           , 0x0325, 0},
  { "SOLAR_JAHRESERTRAG_KW_1"                          , 0x0326, 0},
  { "SOLAR_JAHRESERTRAG_KW_2"                          , 0x0327, 0},
  { "SOLAR_JAHRESERTRAG_KW_3"                          , 0x0328, 0},
  { "SOLAR_JAHRESERTRAG_KW_4"                          , 0x0329, 0},
  { "SOLAR_JAHRESERTRAG_KW_5"                          , 0x032a, 0},
  { "SOLAR_JAHRESERTRAG_MW_1"                          , 0x032b, 0},
  { "SOLAR_JAHRESERTRAG_MW_2"                          , 0x032c, 0},
  { "SOLAR_JAHRESERTRAG_MW_3"                          , 0x032d, 0},
  { "SOLAR_JAHRESERTRAG_MW_4"                          , 0x032e, 0},
  { "SOLAR_JAHRESERTRAG_MW_5"                          , 0x032f, 0},
  { "SPARBETRIEB_BIVALENZ"                             , 0x0330, 0},
  { "WARTEZEIT_DHC"                                    , 0x0331, 0},
  { "STUFEN_DHC"                                       , 0x0332, 0},
  { "FREIGEGEBENE_DHC_STUFEN"                          , 0x0333, 0},
  { "VERDAMPFERTEMP_LUEFTUNG"                          , 0x0334, 0},
  { "FROSTSCHUTZTEMP_LUEFTUNG"                         , 0x0335, 0},
  { "MINDESTVOLUMENSTROM_LUEFTUNG"                     , 0x0336, 0},
  { "ABSENKVOLUMENSTROM_LUEFTUNG"                      , 0x0337, 0},
  { "NORMALVOLUMENSTROM_LUEFTUNG"                      , 0x0338, 0},
  { "PARTYVOLUMENSTROM_LUEFTUNG"                       , 0x0339, 0},
  { "NACHTKUEHLUNG_LUEFTUNG"                           , 0x033a, 0},
  { "SOMMERBETRIEB_LUEFTUNG"                           , 0x033b, 0},
  { "FILTER_RESET_NACH_LAUFZEIT"                       , 0x033c, 0},
  { "INTEGRAL_REGELABWEICHUNG"                         , 0x033d, 0},
  { "REGELABWEICHUNG"                                  , 0x033e, 0},
  { "PROGRAMMSCHALTER_LUEFTUNG"                        , 0x033f, 0},
  { "ABLUFTTEMPERATUR_SOLL"                            , 0x0340, 0},
  { "LAUFZEIT_DHC3"                                    , 0x0341, 0},
  { "LAUFZEIT_FILTER"                                  , 0x0342, 0},
  { "EINSCHALTTEMPERATUR_DIFFERENZ2"                   , 0x0343, 0},
  { "AUSSCHALTTEMPERATUR_DIFFERENZ2"                   , 0x0344, 0},
  { "SOLARSPEICHER_ZUORDNUNG2"                         , 0x0345, 0},
  { "DREHZAHLREGELUNG_SOLARPUMPE1"                     , 0x0346, 0},
  { "DREHZAHLREGELUNG_SOLARPUMPE2"                     , 0x0347, 0},
  { "BRENNERSPERRZEIT_BEI_RUECKLAUFANHEBUNG_SOLAR"     , 0x0348, 0},
  { "EINSCHALTDIFFERENZ_RUECKLAUFANHEBUNG_SOLAR"       , 0x0349, 0},
  { "AUSSCHALTDIFFERENZ_RUECKLAUFANHEBUNG_SOLAR"       , 0x034a, 0},
  { "SPEICHERVORRANG_FUER_2_SPEICHER_SOLARANLAGEN"     , 0x034b, 0},
  { "SP_PARALLELBETR_TEMP_DIFF_SOLAR"                  , 0x034c, 0},
  { "EINSCHALT_KOLLEKTEMP_BEI_SOLBYPASS_SCHALT"        , 0x034d, 0},
  { "SP_UMSCHICHTUNG_BEI_ANTILEG_BETRIEB"              , 0x034e, 0},
  { "VERFLUESSIGERTEMP"                                , 0x034f, 0},
  { "OEL_VERBRAUCH_LOW"                                , 0x0350, 0},
  { "OEL_VERBRAUCH_HIGH"                               , 0x0351, 0},
  { "MIN_MODULATIONSSTROM_ERDGAS"                      , 0x0352, 0},
  { "MAX_MODULATIONSSTROM_HEIZUNG_ERDGAS"              , 0x0353, 0},
  { "MAX_MODULATIONSSTROM_WW_ERDGAS"                   , 0x0354, 0},
  { "MIN_MODULATIONSSTROM_FLUESSIGGAS"                 , 0x0355, 0},
  { "MAX_MODULATIONSSTROM_HEIZUNG_FLUESSIGGAS"         , 0x0356, 0},
  { "MAX_MODULATIONSSTROM_WW_FLUESSIGGAS"              , 0x0357, 0},
  { "PRUEFSTATUS"                                      , 0x0358, 0},
  { "HARDWARE_NUMMER"                                  , 0x0359, 0},
  { "GERAETEKONFIGURATION_3"                           , 0x035a, 0},
  { "AFB_PROGRAMMSCHALTER"                             , 0x035b, 0},
  { "AFB_VORHANDEN"                                    , 0x035c, 0},
  { "AFB_SOLLWERTVERSTELLUNG"                          , 0x035d, 0},
  { "AFB_TELEFONKONTAKT"                               , 0x035e, 0},
  { "AFB_RAUMISTTEMPERATUR"                            , 0x035f, 0},
  { "K_OS_WEICHENREGLER_I_ANTEIL"                      , 0x0360, 0},
  { "K_OS_WEICHENREGLER_P_ANTEIL"                      , 0x0361, 0},
  { "K_OS_WARTEZEIT_NACH_VORSPUELEN"                   , 0x0362, 0},
  { "K_OS_KESSELLEISTUNG_PUMPENLEISTUNG_MAX"           , 0x0363, 0},
  { "K_OS_GEBLAESE_ABTASTRATE"                         , 0x0364, 0},
  { "K_OS_ZUENDSTELLUNG"                               , 0x0365, 0},
  { "K_FEHLERZAEHLER_01"                               , 0x0366, 0},
  { "K_FEHLERZAEHLER_02"                               , 0x0367, 0},
  { "K_FEHLERZAEHLER_03"                               , 0x0368, 0},
  { "K_FEHLERZAEHLER_04"                               , 0x0369, 0},
  { "K_FEHLERZAEHLER_05"                               , 0x036a, 0},
  { "K_FEHLERZAEHLER_06"                               , 0x036b, 0},
  { "K_FEHLERZAEHLER_07"                               , 0x036c, 0},
  { "K_FEHLERZAEHLER_08"                               , 0x036d, 0},
  { "K_FEHLERZAEHLER_09"                               , 0x036e, 0},
  { "K_FEHLERZAEHLER_10"                               , 0x036f, 0},
  { "K_FEHLERZAEHLER_11"                               , 0x0370, 0},
  { "K_FEHLERZAEHLER_12"                               , 0x0371, 0},
  { "K_FEHLERZAEHLER_13"                               , 0x0372, 0},
  { "K_FEHLERZAEHLER_14"                               , 0x0373, 0},
  { "K_FEHLERZAEHLER_15"                               , 0x0374, 0},
  { "K_FEHLERZAEHLER_16"                               , 0x0375, 0},
  { "K_FEHLERZAEHLER_17"                               , 0x0376, 0},
  { "K_FEHLERZAEHLER_18"                               , 0x0377, 0},
  { "K_FEHLERZAEHLER_19"                               , 0x0378, 0},
  { "K_FEHLERZAEHLER_20"                               , 0x0379, 0},
  { "K_FEHLERZAEHLER_21"                               , 0x037a, 0},
  { "K_FEHLERZAEHLER_22"                               , 0x037b, 0},
  { "K_FEHLERZAEHLER_23"                               , 0x037c, 0},
  { "K_FEHLERZAEHLER_24"                               , 0x037d, 0},
  { "K_FEHLERZAEHLER_25"                               , 0x037e, 0},
  { "K_OS_STOERMELDUNG_POINTER"                        , 0x037f, 0},
  { "K_OS_STOERMELDUNG_11"                             , 0x0380, 0},
  { "K_OS_STOERMELDUNG_12"                             , 0x0381, 0},
  { "K_OS_STOERMELDUNG_13"                             , 0x0382, 0},
  { "K_OS_STOERMELDUNG_14"                             , 0x0383, 0},
  { "K_OS_STOERMELDUNG_15"                             , 0x0384, 0},
  { "K_OS_STOERMELDUNG_16"                             , 0x0385, 0},
  { "K_OS_STOERMELDUNG_17"                             , 0x0386, 0},
  { "K_OS_STOERMELDUNG_18"                             , 0x0387, 0},
  { "K_OS_STOERMELDUNG_19"                             , 0x0388, 0},
  { "K_OS_STOERMELDUNG_20"                             , 0x0389, 0},
  { "K_OS_DUMMY"                                       , 0x038a, 0},
  { "K_OS_STARTBEDINGUNGEN_1"                          , 0x038b, 0},
  { "K_OS_STARTBEDINGUNGEN_2"                          , 0x038c, 0},
  { "K_OS_STARTBEDINGUNGEN_3"                          , 0x038d, 0},
  { "K_OS_SAMLERIST_FUEHLER"                           , 0x038e, 0},
  { "KESSELISTTEMP_2"                                  , 0x038f, 0},
  { "WW_AUSLAUFTEMPERATUR"                             , 0x0390, 0},
  { "MODULATIONSSTROM_GASVENTIL"                       , 0x0391, 0},
  { "MAX_VORVERLEGUNG_MIN"                             , 0x0392, 0},
  { "WE1_GRADIENTENUEBERWACHUNG"                       , 0x0393, 0},
  { "WE2_GRADIENTENUEBERWACHUNG"                       , 0x0394, 0},
  { "BUSKENNUNG_2"                                     , 0x0395, 0},
  { "BUSKENNUNG_3"                                     , 0x0396, 0},
  { "ZIRKULATIONSTEMP"                                 , 0x0397, 0},
  { "ZUSCHALTSPERRE_KASKADE_PAR"                       , 0x0398, 0},
  { "HYSTERESE_ZUSCHALTSPERRE"                         , 0x0399, 0},
  { "KSOLL_RUECKLANHEB_HOLZKESSEL1"                    , 0x039a, 0},
  { "KSOLL_RUECKLANHEB_HYST1"                          , 0x039b, 0},
  { "KSOLL_RUECKLANHEB_HOLZKESSEL2"                    , 0x039c, 0},
  { "KSOLL_RUECKLANHEB_HYST2"                          , 0x039d, 0},
  { "LADEPUMPE_PUFFER_DREHZAL_1"                       , 0x039e, 0},
  { "LADEPUMPE_PUFFER_DREHZAL_2"                       , 0x039f, 0},
  { "LADEPUMPE_PUFFER_DREHZAL_3"                       , 0x03a0, 0},
  { "MISCHER_ABTASTZEIT"                               , 0x03a1, 0},
  { "MISCHER_BETRIEBSART"                              , 0x03a2, 0},
  { "HD_EVE_GRENZWERT_VND"                             , 0x03a3, 0},
  { "ANZAHL_KUEHLUNGSSTUFEN"                           , 0x03a4, 0},
  { "KONFIGURATION_KUEHLUNG"                           , 0x03a5, 0},
  { "MISCHER_KP"                                       , 0x03a6, 0},
  { "MISCHER_TN"                                       , 0x03a7, 0},
  { "MISCHER_TV"                                       , 0x03a8, 0},
  { "PERIODENDAUER_ABTAUEN"                            , 0x03a9, 0},
  { "RELATIVE_ABTAUDAUER1"                             , 0x03aa, 0},
  { "RELATIVE_ABTAUDAUER2"                             , 0x03ab, 0},
  { "MAX_ABTAUDAUER_VERDAMPFER"                        , 0x03ac, 0},
  { "WE1_TYP_NEU"                                      , 0x03ad, 0},
  { "BUSSYSTEM"                                        , 0x03ae, 0},
  { "WAERMEERTRAG_RUECKGE_TAG_WH"                      , 0x03af, 0},
  { "WAERMEERTRAG_RUECKGE_TAG_KWH"                     , 0x03b0, et_double_val},
  { "WAERMEERTRAG_RUECKGE_SUMME_KWH"                   , 0x03b1, 0},
  { "WAERMEERTRAG_RUECKGE_SUMME_MWH"                   , 0x03b6, et_double_val},
  { "SOLAR_MAX_DREHZAHL_TEMP"                          , 0x03b7, 0},
  { "SOLAR_KOLLEKTOR_FREIGABETEMP"                     , 0x03b8, 0},
  { "SOLAR_KOLLEKTOR_SPERRTEMP"                        , 0x03b9, 0},
  { "SOLAR_FREIGABETEMP_2WE"                           , 0x03ba, 0},
  { "SOLAR_MAX_TEMP_2WE"                               , 0x03bb, 0},
  { "SOLAR_KOLLEKTORSCHUTZTEMP"                        , 0x03bc, et_dec_val},
  { "SOLAR_SCHALTSCHWELLE_RUECKKUEHLUNG"               , 0x03bd, 0},
  { "SOLAR_ZIRKPUMPE_EINSCHALTZEIT"                    , 0x03be, 0},
  { "SOLAR_ZIRKPUMPE_AUSSCHALTZEIT"                    , 0x03bf, 0},
  { "SOLAR_NACHHEIZEN_EINSCHALTZEIT"                   , 0x03c0, 0},
  { "SOLAR_NACHHEIZEN_AUSSCHALTZEIT"                   , 0x03c1, 0},
  { "SOLAR_ANLAGENAUSWAHL"                             , 0x03c2, 0},
  { "SOLAR_TOLERANZ_SOLARERTRAG"                       , 0x03c3, 0},
  { "SOLAR_MIN_RUECKLAUFTEMP"                          , 0x03c4, 0},
  { "SOLAR_VOLUMENSTROMVERTEILUNG_WMZ"                 , 0x03c5, 0},
  { "SOLAR_IMPULSRATE_EINHEIT_WMZ"                     , 0x03c6, 0},
  { "SOLAR_ZUSATZRELAISFUNKTION2"                      , 0x03c7, 0},
  { "SOLAR_ZUSATZRELAISFUNKTION"                       , 0x03c8, 0},
  { "SOLAR_MAX_DREHZAHL"                               , 0x03c9, 0},
  { "SOLAR_MIN_DREHZAHL"                               , 0x03ca, 0},
  { "SOLAR_HAND_DREHZAHLSOLL"                          , 0x03cb, 0},
  { "SOLAR_BETRIEBSART_DREHZAHL"                       , 0x03cc, 0},
  { "SOLAR_THERMOSTATFUNKTION_EINSCHALTTEMP"           , 0x03cd, 0},
  { "SOLAR_THERMOSTATFUNKTION_AUSSCHALTDIFFERENZ"      , 0x03ce, 0},
  { "SOLAR_ROEHRENKOLLEKTORFUNKTION"                   , 0x03cf, 0},
  { "SOLAR_FROSTSCHUTZFUNKTION"                        , 0x03d0, 0},
  { "SOLAR_SPEICHERLADUNG_ERFOLGREICH"                 , 0x03d1, 0},
  { "EINSCHALTTEMPERATUR_DIFFERENZ3"                   , 0x03d2, 0},
  { "AUSSCHALTTEMPERATUR_DIFFERENZ3"                   , 0x03d3, 0},
  { "MAXTEMP_ERDSONDE"                                 , 0x03d4, 0},
  { "MAXTEMP_ERDSONDE_WIEDEREIN"                       , 0x03d5, 0},
  { "MAXTEMP_SCHWIMMBAD"                               , 0x03d6, 0},
  { "MAXTEMP_SCHWIMMBAD_WIEDEREIN"                     , 0x03d7, 0},
  { "SOLAR_HAND_DREHZAHL2_SOLL"                        , 0x03d8, 0},
  { "DURCHFLUSSMENGE_SOLAR_SOLL"                       , 0x03d9, 0},
  { "DURCHFLUSSMENGE_SOLAR2"                           , 0x03da, 0},
  { "DURCHFLUSSMENGE_SOLAR2_SOLL"                      , 0x03dc, 0},
  { "KUEHL_FREIGABE_TEMPERATUR"                        , 0x03dd, 0},
  { "KUEHL_VORLAUFSOLLTEMP"                            , 0x03de, 0},
  { "KUEHL_RUECKLAUFSOLLTEMP"                          , 0x03df, 0},
  { "SOLAR_HYSTERESE_NACHHEIZUNG"                      , 0x03e0, 0},
  { "UMLADUNG_PUMPEMSTATUS1"                           , 0x03e1, 0},
  { "UMLADUNG_PUMPEMSTATUS2"                           , 0x03e2, 0},
  { "HF_FELDSTAERKE"                                   , 0x03e3, 0},
  { "KUEHLDYNAMIK_FLAECHE_PASSIV"                      , 0x03e4, 0},
  { "KUEHLDYNAMIK_GEBLAESE_PASSIV"                     , 0x03e5, 0},
  { "MANAGER_SYSTEM_INFOS"                             , 0x03e6, 0},
  { "QUELLENPUMPEN_STATUS"                             , 0x03e7, 0},
  { "KUEHL_AUSGANG"                                    , 0x03e8, 0},
  { "WERKSTEST_BESTANDEN"                              , 0x03e9, 0},
  { "KESSEL_1_STUFE_1_LEISTUNG"                        , 0x03ea, 0},
  { "KESSEL_2_STUFE_1_LEISTUNG"                        , 0x03eb, 0},
  { "KESSEL_3_STUFE_1_LEISTUNG"                        , 0x03ec, 0},
  { "KESSEL_4_STUFE_1_LEISTUNG"                        , 0x03ed, 0},
  { "KESSEL_5_STUFE_1_LEISTUNG"                        , 0x03ee, 0},
  { "KESSEL_6_STUFE_1_LEISTUNG"                        , 0x03ef, 0},
  { "KESSEL_7_STUFE_1_LEISTUNG"                        , 0x03f0, 0},
  { "KESSEL_8_STUFE_1_LEISTUNG"                        , 0x03f1, 0},
  { "KESSEL_9_STUFE_1_LEISTUNG"                        , 0x03f2, 0},
  { "KESSEL_10_STUFE_1_LEISTUNG"                       , 0x03f3, 0},
  { "KESSEL_11_STUFE_1_LEISTUNG"                       , 0x03f4, 0},
  { "KESSEL_12_STUFE_1_LEISTUNG"                       , 0x03f5, 0},
  { "KESSEL_13_STUFE_1_LEISTUNG"                       , 0x03f6, 0},
  { "KESSEL_14_STUFE_1_LEISTUNG"                       , 0x03f7, 0},
  { "KESSEL_15_STUFE_1_LEISTUNG"                       , 0x03f8, 0},
  { "KESSEL_16_STUFE_1_LEISTUNG"                       , 0x03f9, 0},
  { "KESSEL_1_STUFE_2_LEISTUNG"                        , 0x03fa, 0},
  { "KESSEL_2_STUFE_2_LEISTUNG"                        , 0x03fb, 0},
  { "KESSEL_3_STUFE_2_LEISTUNG"                        , 0x03fc, 0},
  { "KESSEL_4_STUFE_2_LEISTUNG"                        , 0x03fd, 0},
  { "KESSEL_5_STUFE_2_LEISTUNG"                        , 0x03fe, 0},
  { "KESSEL_6_STUFE_2_LEISTUNG"                        , 0x03ff, 0},
  { "KESSEL_7_STUFE_2_LEISTUNG"                        , 0x0400, 0},
  { "KESSEL_8_STUFE_2_LEISTUNG"                        , 0x0401, 0},
  { "KESSEL_9_STUFE_2_LEISTUNG"                        , 0x0402, 0},
  { "KESSEL_10_STUFE_2_LEISTUNG"                       , 0x0403, 0},
  { "KESSEL_11_STUFE_2_LEISTUNG"                       , 0x0404, 0},
  { "KESSEL_12_STUFE_2_LEISTUNG"                       , 0x0405, 0},
  { "KESSEL_13_STUFE_2_LEISTUNG"                       , 0x0406, 0},
  { "KESSEL_14_STUFE_2_LEISTUNG"                       , 0x0407, 0},
  { "KESSEL_15_STUFE_2_LEISTUNG"                       , 0x0408, 0},
  { "KESSEL_16_STUFE_2_LEISTUNG"                       , 0x0409, 0},
  { "KESSEL_1_STUFE_1_STARTS"                          , 0x040a, 0},
  { "KESSEL_2_STUFE_1_STARTS"                          , 0x040b, 0},
  { "KESSEL_3_STUFE_1_STARTS"                          , 0x040c, 0},
  { "KESSEL_4_STUFE_1_STARTS"                          , 0x040d, 0},
  { "KESSEL_5_STUFE_1_STARTS"                          , 0x040e, 0},
  { "KESSEL_6_STUFE_1_STARTS"                          , 0x040f, 0},
  { "KESSEL_7_STUFE_1_STARTS"                          , 0x0410, 0},
  { "KESSEL_8_STUFE_1_STARTS"                          , 0x0411, 0},
  { "KESSEL_9_STUFE_1_STARTS"                          , 0x0412, 0},
  { "KESSEL_10_STUFE_1_STARTS"                         , 0x0413, 0},
  { "KESSEL_11_STUFE_1_STARTS"                         , 0x0414, 0},
  { "KESSEL_12_STUFE_1_STARTS"                         , 0x0415, 0},
  { "KESSEL_13_STUFE_1_STARTS"                         , 0x0416, 0},
  { "KESSEL_14_STUFE_1_STARTS"                         , 0x0417, 0},
  { "KESSEL_15_STUFE_1_STARTS"                         , 0x0418, 0},
  { "KESSEL_16_STUFE_1_STARTS"                         , 0x0419, 0},
  { "KESSEL_1_STUFE_2_STARTS"                          , 0x041a, 0},
  { "KESSEL_2_STUFE_2_STARTS"                          , 0x041b, 0},
  { "KESSEL_3_STUFE_2_STARTS"                          , 0x041c, 0},
  { "KESSEL_4_STUFE_2_STARTS"                          , 0x041d, 0},
  { "KESSEL_5_STUFE_2_STARTS"                          , 0x041e, 0},
  { "KESSEL_6_STUFE_2_STARTS"                          , 0x041f, 0},
  { "KESSEL_7_STUFE_2_STARTS"                          , 0x0420, 0},
  { "KESSEL_8_STUFE_2_STARTS"                          , 0x0421, 0},
  { "KESSEL_9_STUFE_2_STARTS"                          , 0x0422, 0},
  { "KESSEL_10_STUFE_2_STARTS"                         , 0x0423, 0},
  { "KESSEL_11_STUFE_2_STARTS"                         , 0x0424, 0},
  { "KESSEL_12_STUFE_2_STARTS"                         , 0x0425, 0},
  { "KESSEL_13_STUFE_2_STARTS"                         , 0x0426, 0},
  { "KESSEL_14_STUFE_2_STARTS"                         , 0x0427, 0},
  { "KESSEL_15_STUFE_2_STARTS"                         , 0x0428, 0},
  { "KESSEL_16_STUFE_2_STARTS"                         , 0x0429, 0},
  { "KESSEL_1_STUFEN_1_STARTS_UEBERLAUF"               , 0x042a, 0},
  { "KESSEL_2_STUFEN_1_STARTS_UEBERLAUF"               , 0x042b, 0},
  { "KESSEL_3_STUFEN_1_STARTS_UEBERLAUF"               , 0x042c, 0},
  { "KESSEL_4_STUFEN_1_STARTS_UEBERLAUF"               , 0x042d, 0},
  { "KESSEL_5_STUFEN_1_STARTS_UEBERLAUF"               , 0x042e, 0},
  { "KESSEL_6_STUFEN_1_STARTS_UEBERLAUF"               , 0x042f, 0},
  { "KESSEL_7_STUFEN_1_STARTS_UEBERLAUF"               , 0x0430, 0},
  { "KESSEL_8_STUFEN_1_STARTS_UEBERLAUF"               , 0x0431, 0},
  { "KESSEL_9_STUFEN_1_STARTS_UEBERLAUF"               , 0x0432, 0},
  { "KESSEL_10_STUFEN_1_STARTS_UEBERLAUF"              , 0x0433, 0},
  { "KESSEL_11_STUFEN_1_STARTS_UEBERLAUF"              , 0x0434, 0},
  { "KESSEL_12_STUFEN_1_STARTS_UEBERLAUF"              , 0x0435, 0},
  { "KESSEL_13_STUFEN_1_STARTS_UEBERLAUF"              , 0x0436, 0},
  { "KESSEL_14_STUFEN_1_STARTS_UEBERLAUF"              , 0x0437, 0},
  { "KESSEL_15_STUFEN_1_STARTS_UEBERLAUF"              , 0x0438, 0},
  { "KESSEL_16_STUFEN_1_STARTS_UEBERLAUF"              , 0x0439, 0},
  { "KESSEL_1_STUFEN_2_STARTS_UEBERLAUF"               , 0x043a, 0},
  { "KESSEL_2_STUFEN_2_STARTS_UEBERLAUF"               , 0x043b, 0},
  { "KESSEL_3_STUFEN_2_STARTS_UEBERLAUF"               , 0x043c, 0},
  { "KESSEL_4_STUFEN_2_STARTS_UEBERLAUF"               , 0x043d, 0},
  { "KESSEL_5_STUFEN_2_STARTS_UEBERLAUF"               , 0x043e, 0},
  { "KESSEL_6_STUFEN_2_STARTS_UEBERLAUF"               , 0x043f, 0},
  { "KESSEL_7_STUFEN_2_STARTS_UEBERLAUF"               , 0x0440, 0},
  { "KESSEL_8_STUFEN_2_STARTS_UEBERLAUF"               , 0x0441, 0},
  { "KESSEL_9_STUFEN_2_STARTS_UEBERLAUF"               , 0x0442, 0},
  { "KESSEL_10_STUFEN_2_STARTS_UEBERLAUF"              , 0x0443, 0},
  { "KESSEL_11_STUFEN_2_STARTS_UEBERLAUF"              , 0x0444, 0},
  { "KESSEL_12_STUFEN_2_STARTS_UEBERLAUF"              , 0x0445, 0},
  { "KESSEL_13_STUFEN_2_STARTS_UEBERLAUF"              , 0x0446, 0},
  { "KESSEL_14_STUFEN_2_STARTS_UEBERLAUF"              , 0x0447, 0},
  { "KESSEL_15_STUFEN_2_STARTS_UEBERLAUF"              , 0x0448, 0},
  { "KESSEL_16_STUFEN_2_STARTS_UEBERLAUF"              , 0x0449, 0},
  { "KESSEL_1_STUFE_1_LAUFZEIT"                        , 0x044a, 0},
  { "KESSEL_2_STUFE_1_LAUFZEIT"                        , 0x044b, 0},
  { "KESSEL_3_STUFE_1_LAUFZEIT"                        , 0x044c, 0},
  { "KESSEL_4_STUFE_1_LAUFZEIT"                        , 0x044d, 0},
  { "KESSEL_5_STUFE_1_LAUFZEIT"                        , 0x044e, 0},
  { "KESSEL_6_STUFE_1_LAUFZEIT"                        , 0x044f, 0},
  { "KESSEL_7_STUFE_1_LAUFZEIT"                        , 0x0450, 0},
  { "KESSEL_8_STUFE_1_LAUFZEIT"                        , 0x0451, 0},
  { "KESSEL_9_STUFE_1_LAUFZEIT"                        , 0x0452, 0},
  { "KESSEL_10_STUFE_1_LAUFZEIT"                       , 0x0453, 0},
  { "KESSEL_11_STUFE_1_LAUFZEIT"                       , 0x0454, 0},
  { "KESSEL_12_STUFE_1_LAUFZEIT"                       , 0x0455, 0},
  { "KESSEL_13_STUFE_1_LAUFZEIT"                       , 0x0456, 0},
  { "KESSEL_14_STUFE_1_LAUFZEIT"                       , 0x0457, 0},
  { "KESSEL_15_STUFE_1_LAUFZEIT"                       , 0x0458, 0},
  { "KESSEL_16_STUFE_1_LAUFZEIT"                       , 0x0459, 0},
  { "KESSEL_1_STUFE_2_LAUFZEIT"                        , 0x045a, 0},
  { "KESSEL_2_STUFE_2_LAUFZEIT"                        , 0x045b, 0},
  { "KESSEL_3_STUFE_2_LAUFZEIT"                        , 0x045c, 0},
  { "KESSEL_4_STUFE_2_LAUFZEIT"                        , 0x045d, 0},
  { "KESSEL_5_STUFE_2_LAUFZEIT"                        , 0x045e, 0},
  { "KESSEL_6_STUFE_2_LAUFZEIT"                        , 0x045f, 0},
  { "KESSEL_7_STUFE_2_LAUFZEIT"                        , 0x0460, 0},
  { "KESSEL_8_STUFE_2_LAUFZEIT"                        , 0x0461, 0},
  { "KESSEL_9_STUFE_2_LAUFZEIT"                        , 0x0462, 0},
  { "KESSEL_10_STUFE_2_LAUFZEIT"                       , 0x0463, 0},
  { "KESSEL_11_STUFE_2_LAUFZEIT"                       , 0x0464, 0},
  { "KESSEL_12_STUFE_2_LAUFZEIT"                       , 0x0465, 0},
  { "KESSEL_13_STUFE_2_LAUFZEIT"                       , 0x0466, 0},
  { "KESSEL_14_STUFE_2_LAUFZEIT"                       , 0x0467, 0},
  { "KESSEL_15_STUFE_2_LAUFZEIT"                       , 0x0468, 0},
  { "KESSEL_16_STUFE_2_LAUFZEIT"                       , 0x0469, 0},
  { "KESSEL_1_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x046a, 0},
  { "KESSEL_2_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x046b, 0},
  { "KESSEL_3_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x046c, 0},
  { "KESSEL_4_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x046d, 0},
  { "KESSEL_5_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x046e, 0},
  { "KESSEL_6_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x046f, 0},
  { "KESSEL_7_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x0470, 0},
  { "KESSEL_8_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x0471, 0},
  { "KESSEL_9_STUFE_1_LAUFZEIT_UEBERLAUF"              , 0x0472, 0},
  { "KESSEL_10_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0473, 0},
  { "KESSEL_11_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0474, 0},
  { "KESSEL_12_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0475, 0},
  { "KESSEL_13_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0476, 0},
  { "KESSEL_14_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0477, 0},
  { "KESSEL_15_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0478, 0},
  { "KESSEL_16_STUFE_1_LAUFZEIT_UEBERLAUF"             , 0x0479, 0},
  { "KESSEL_1_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x047a, 0},
  { "KESSEL_2_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x047b, 0},
  { "KESSEL_3_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x047c, 0},
  { "KESSEL_4_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x047d, 0},
  { "KESSEL_5_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x047e, 0},
  { "KESSEL_6_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x047f, 0},
  { "KESSEL_7_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x0480, 0},
  { "KESSEL_8_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x0481, 0},
  { "KESSEL_9_STUFE_2_LAUFZEIT_UEBERLAUF"              , 0x0482, 0},
  { "KESSEL_10_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0483, 0},
  { "KESSEL_11_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0484, 0},
  { "KESSEL_12_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0485, 0},
  { "KESSEL_13_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0486, 0},
  { "KESSEL_14_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0487, 0},
  { "KESSEL_15_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0488, 0},
  { "KESSEL_16_STUFE_2_LAUFZEIT_UEBERLAUF"             , 0x0489, 0},
  { "MFR_FUNKTION_1"                                   , 0x048a, 0},
  { "MFR_FUNKTION_2"                                   , 0x048b, 0},
  { "MFR_FUNKTION_3"                                   , 0x048c, 0},
  { "MFR_FUNKTION_4"                                   , 0x048d, 0},
  { "MFR_FUNKTION_5"                                   , 0x048e, 0},
  { "MFR_FUNKTION_6"                                   , 0x048f, 0},
  { "MFR_FUNKTION_7"                                   , 0x0490, 0},
  { "MFR_FUNKTION_8"                                   , 0x0491, 0},
  { "MFR_FUNKTION_9"                                   , 0x0492, 0},
  { "MFR_FUNKTION_10"                                  , 0x0493, 0},
  { "MFR_FUNKTION_11"                                  , 0x0494, 0},
  { "MFR_FUNKTION_12"                                  , 0x0495, 0},
  { "MFR_FUNKTION_13"                                  , 0x0496, 0},
  { "MFR_FUNKTION_14"                                  , 0x0497, 0},
  { "MFR_FUNKTION_15"                                  , 0x0498, 0},
  { "MFR_FUNKTION_16"                                  , 0x0499, 0},
  { "MFR_FUNKTION_17"                                  , 0x049a, 0},
  { "MFR_FUNKTION_18"                                  , 0x049b, 0},
  { "MFR_FUNKTION_19"                                  , 0x049c, 0},
  { "MFR_FUNKTION_20"                                  , 0x049d, 0},
  { "MFR_FUNKTION_21"                                  , 0x049e, 0},
  { "MFR_FUNKTION_22"                                  , 0x049f, 0},
  { "MFR_FUNKTION_23"                                  , 0x04a0, 0},
  { "MFR_FUNKTION_24"                                  , 0x04a1, 0},
  { "MFR_FUNKTION_25"                                  , 0x04a2, 0},
  { "MFR_FUNKTION_26"                                  , 0x04a3, 0},
  { "MFR_FUNKTION_27"                                  , 0x04a4, 0},
  { "MFR_FUNKTION_28"                                  , 0x04a5, 0},
  { "MFR_FUNKTION_29"                                  , 0x04a6, 0},
  { "MFR_FUNKTION_30"                                  , 0x04a7, 0},
  { "MFR_FUNKTION_31"                                  , 0x04a8, 0},
  { "MFR_FUNKTION_32"                                  , 0x04a9, 0},
  { "MFR_SCHALTTEMP_1"                                 , 0x04aa, 0},
  { "MFR_SCHALTTEMP_2"                                 , 0x04ab, 0},
  { "MFR_SCHALTTEMP_3"                                 , 0x04ac, 0},
  { "MFR_SCHALTTEMP_4"                                 , 0x04ad, 0},
  { "MFR_SCHALTTEMP_5"                                 , 0x04ae, 0},
  { "MFR_SCHALTTEMP_6"                                 , 0x04af, 0},
  { "MFR_SCHALTTEMP_7"                                 , 0x04b0, 0},
  { "MFR_SCHALTTEMP_8"                                 , 0x04b1, 0},
  { "MFR_SCHALTTEMP_9"                                 , 0x04b2, 0},
  { "MFR_SCHALTTEMP_10"                                , 0x04b3, 0},
  { "MFR_SCHALTTEMP_11"                                , 0x04b4, 0},
  { "MFR_SCHALTTEMP_12"                                , 0x04b5, 0},
  { "MFR_SCHALTTEMP_13"                                , 0x04b6, 0},
  { "MFR_SCHALTTEMP_14"                                , 0x04b7, 0},
  { "MFR_SCHALTTEMP_15"                                , 0x04b8, 0},
  { "MFR_SCHALTTEMP_16"                                , 0x04b9, 0},
  { "MFR_SCHALTTEMP_17"                                , 0x04ba, 0},
  { "MFR_SCHALTTEMP_18"                                , 0x04bb, 0},
  { "MFR_SCHALTTEMP_19"                                , 0x04bc, 0},
  { "MFR_SCHALTTEMP_20"                                , 0x04bd, 0},
  { "MFR_SCHALTTEMP_21"                                , 0x04be, 0},
  { "MFR_SCHALTTEMP_22"                                , 0x04bf, 0},
  { "MFR_SCHALTTEMP_23"                                , 0x04c0, 0},
  { "MFR_SCHALTTEMP_24"                                , 0x04c1, 0},
  { "MFR_SCHALTTEMP_25"                                , 0x04c2, 0},
  { "MFR_SCHALTTEMP_26"                                , 0x04c3, 0},
  { "MFR_SCHALTTEMP_27"                                , 0x04c4, 0},
  { "MFR_SCHALTTEMP_28"                                , 0x04c5, 0},
  { "MFR_SCHALTTEMP_29"                                , 0x04c6, 0},
  { "MFR_SCHALTTEMP_30"                                , 0x04c7, 0},
  { "MFR_SCHALTTEMP_31"                                , 0x04c8, 0},
  { "MFR_SCHALTTEMP_32"                                , 0x04c9, 0},
  { "MFR_HYSTERESE_1"                                  , 0x04ca, 0},
  { "MFR_HYSTERESE_2"                                  , 0x04cb, 0},
  { "MFR_HYSTERESE_3"                                  , 0x04cc, 0},
  { "MFR_HYSTERESE_4"                                  , 0x04cd, 0},
  { "MFR_HYSTERESE_5"                                  , 0x04ce, 0},
  { "MFR_HYSTERESE_6"                                  , 0x04cf, 0},
  { "MFR_HYSTERESE_7"                                  , 0x04d0, 0},
  { "MFR_HYSTERESE_8"                                  , 0x04d1, 0},
  { "MFR_HYSTERESE_9"                                  , 0x04d2, 0},
  { "MFR_HYSTERESE_10"                                 , 0x04d3, 0},
  { "MFR_HYSTERESE_11"                                 , 0x04d4, 0},
  { "MFR_HYSTERESE_12"                                 , 0x04d5, 0},
  { "MFR_HYSTERESE_13"                                 , 0x04d6, 0},
  { "MFR_HYSTERESE_14"                                 , 0x04d7, 0},
  { "MFR_HYSTERESE_15"                                 , 0x04d8, 0},
  { "MFR_HYSTERESE_16"                                 , 0x04d9, 0},
  { "MFR_HYSTERESE_17"                                 , 0x04da, 0},
  { "MFR_HYSTERESE_18"                                 , 0x04db, 0},
  { "MFR_HYSTERESE_19"                                 , 0x04dc, 0},
  { "MFR_HYSTERESE_20"                                 , 0x04dd, 0},
  { "MFR_HYSTERESE_21"                                 , 0x04de, 0},
  { "MFR_HYSTERESE_22"                                 , 0x04df, 0},
  { "MFR_HYSTERESE_23"                                 , 0x04e0, 0},
  { "MFR_HYSTERESE_24"                                 , 0x04e1, 0},
  { "MFR_HYSTERESE_25"                                 , 0x04e2, 0},
  { "MFR_HYSTERESE_26"                                 , 0x04e3, 0},
  { "MFR_HYSTERESE_27"                                 , 0x04e4, 0},
  { "MFR_HYSTERESE_28"                                 , 0x04e5, 0},
  { "MFR_HYSTERESE_29"                                 , 0x04e6, 0},
  { "MFR_HYSTERESE_30"                                 , 0x04e7, 0},
  { "MFR_HYSTERESE_31"                                 , 0x04e8, 0},
  { "MFR_HYSTERESE_32"                                 , 0x04e9, 0},
  { "MFR_ISTTEMP1_1"                                   , 0x04ea, 0},
  { "MFR_ISTTEMP1_2"                                   , 0x04eb, 0},
  { "MFR_ISTTEMP1_3"                                   , 0x04ec, 0},
  { "MFR_ISTTEMP1_4"                                   , 0x04ed, 0},
  { "MFR_ISTTEMP1_5"                                   , 0x04ee, 0},
  { "MFR_ISTTEMP1_6"                                   , 0x04ef, 0},
  { "MFR_ISTTEMP1_7"                                   , 0x04f0, 0},
  { "MFR_ISTTEMP1_8"                                   , 0x04f1, 0},
  { "MFR_ISTTEMP1_9"                                   , 0x04f2, 0},
  { "MFR_ISTTEMP1_10"                                  , 0x04f3, 0},
  { "MFR_ISTTEMP1_11"                                  , 0x04f4, 0},
  { "MFR_ISTTEMP1_12"                                  , 0x04f5, 0},
  { "MFR_ISTTEMP1_13"                                  , 0x04f6, 0},
  { "MFR_ISTTEMP1_14"                                  , 0x04f7, 0},
  { "MFR_ISTTEMP1_15"                                  , 0x04f8, 0},
  { "MFR_ISTTEMP1_16"                                  , 0x04f9, 0},
  { "MFR_ISTTEMP1_17"                                  , 0x04fa, 0},
  { "MFR_ISTTEMP1_18"                                  , 0x04fb, 0},
  { "MFR_ISTTEMP1_19"                                  , 0x04fc, 0},
  { "MFR_ISTTEMP1_20"                                  , 0x04fd, 0},
  { "MFR_ISTTEMP1_21"                                  , 0x04fe, 0},
  { "MFR_ISTTEMP1_22"                                  , 0x04ff, 0},
  { "MFR_ISTTEMP1_23"                                  , 0x0500, 0},
  { "MFR_ISTTEMP1_24"                                  , 0x0501, 0},
  { "MFR_ISTTEMP1_25"                                  , 0x0502, 0},
  { "MFR_ISTTEMP1_26"                                  , 0x0503, 0},
  { "MFR_ISTTEMP1_27"                                  , 0x0504, 0},
  { "MFR_ISTTEMP1_28"                                  , 0x0505, 0},
  { "MFR_ISTTEMP1_29"                                  , 0x0506, 0},
  { "MFR_ISTTEMP1_30"                                  , 0x0507, 0},
  { "MFR_ISTTEMP1_31"                                  , 0x0508, 0},
  { "MFR_ISTTEMP1_32"                                  , 0x0509, 0},
  { "MFR_ISTTEMP2_1"                                   , 0x050a, 0},
  { "MFR_ISTTEMP2_2"                                   , 0x050b, 0},
  { "MFR_ISTTEMP2_3"                                   , 0x050c, 0},
  { "MFR_ISTTEMP2_4"                                   , 0x050d, 0},
  { "MFR_ISTTEMP2_5"                                   , 0x050e, 0},
  { "MFR_ISTTEMP2_6"                                   , 0x050f, 0},
  { "MFR_ISTTEMP2_7"                                   , 0x0510, 0},
  { "MFR_ISTTEMP2_8"                                   , 0x0511, 0},
  { "MFR_ISTTEMP2_9"                                   , 0x0512, 0},
  { "MFR_ISTTEMP2_10"                                  , 0x0513, 0},
  { "MFR_ISTTEMP2_11"                                  , 0x0514, 0},
  { "MFR_ISTTEMP2_12"                                  , 0x0515, 0},
  { "MFR_ISTTEMP2_13"                                  , 0x0516, 0},
  { "MFR_ISTTEMP2_14"                                  , 0x0517, 0},
  { "MFR_ISTTEMP2_15"                                  , 0x0518, 0},
  { "MFR_ISTTEMP2_16"                                  , 0x0519, 0},
  { "MFR_ISTTEMP2_17"                                  , 0x051a, 0},
  { "MFR_ISTTEMP2_18"                                  , 0x051b, 0},
  { "MFR_ISTTEMP2_19"                                  , 0x051c, 0},
  { "MFR_ISTTEMP2_20"                                  , 0x051d, 0},
  { "MFR_ISTTEMP2_21"                                  , 0x051e, 0},
  { "MFR_ISTTEMP2_22"                                  , 0x051f, 0},
  { "MFR_ISTTEMP2_23"                                  , 0x0520, 0},
  { "MFR_ISTTEMP2_24"                                  , 0x0521, 0},
  { "MFR_ISTTEMP2_25"                                  , 0x0522, 0},
  { "MFR_ISTTEMP2_26"                                  , 0x0523, 0},
  { "MFR_ISTTEMP2_27"                                  , 0x0524, 0},
  { "MFR_ISTTEMP2_28"                                  , 0x0525, 0},
  { "MFR_ISTTEMP2_29"                                  , 0x0526, 0},
  { "MFR_ISTTEMP2_30"                                  , 0x0527, 0},
  { "MFR_ISTTEMP2_31"                                  , 0x0528, 0},
  { "MFR_ISTTEMP2_32"                                  , 0x0529, 0},
  { "MFR_STATUS_1"                                     , 0x052a, 0},
  { "MFR_STATUS_2"                                     , 0x052b, 0},
  { "MFR_STATUS_3"                                     , 0x052c, 0},
  { "MFR_STATUS_4"                                     , 0x052d, 0},
  { "MFR_STATUS_5"                                     , 0x052e, 0},
  { "MFR_STATUS_6"                                     , 0x052f, 0},
  { "MFR_STATUS_7"                                     , 0x0530, 0},
  { "MFR_STATUS_8"                                     , 0x0531, 0},
  { "MFR_STATUS_9"                                     , 0x0532, 0},
  { "MFR_STATUS_10"                                    , 0x0533, 0},
  { "MFR_STATUS_11"                                    , 0x0534, 0},
  { "MFR_STATUS_12"                                    , 0x0535, 0},
  { "MFR_STATUS_13"                                    , 0x0536, 0},
  { "MFR_STATUS_14"                                    , 0x0537, 0},
  { "MFR_STATUS_15"                                    , 0x0538, 0},
  { "MFR_STATUS_16"                                    , 0x0539, 0},
  { "MFR_STATUS_17"                                    , 0x053a, 0},
  { "MFR_STATUS_18"                                    , 0x053b, 0},
  { "MFR_STATUS_19"                                    , 0x053c, 0},
  { "MFR_STATUS_20"                                    , 0x053d, 0},
  { "MFR_STATUS_21"                                    , 0x053e, 0},
  { "MFR_STATUS_22"                                    , 0x053f, 0},
  { "MFR_STATUS_23"                                    , 0x0540, 0},
  { "MFR_STATUS_24"                                    , 0x0541, 0},
  { "MFR_STATUS_25"                                    , 0x0542, 0},
  { "MFR_STATUS_26"                                    , 0x0543, 0},
  { "MFR_STATUS_27"                                    , 0x0544, 0},
  { "MFR_STATUS_28"                                    , 0x0545, 0},
  { "MFR_STATUS_29"                                    , 0x0546, 0},
  { "MFR_STATUS_30"                                    , 0x0547, 0},
  { "MFR_STATUS_31"                                    , 0x0548, 0},
  { "MFR_STATUS_32"                                    , 0x0549, 0},
  { "WE_TEMPERATUR_1"                                  , 0x054a, 0},
  { "WE_TEMPERATUR_2"                                  , 0x054b, 0},
  { "WE_TEMPERATUR_3"                                  , 0x054c, 0},
  { "WE_TEMPERATUR_4"                                  , 0x054d, 0},
  { "WE_TEMPERATUR_5"                                  , 0x054e, 0},
  { "WE_TEMPERATUR_6"                                  , 0x054f, 0},
  { "WE_TEMPERATUR_7"                                  , 0x0550, 0},
  { "WE_TEMPERATUR_8"                                  , 0x0551, 0},
  { "WE_TEMPERATUR_9"                                  , 0x0552, 0},
  { "WE_TEMPERATUR_10"                                 , 0x0553, 0},
  { "WE_TEMPERATUR_11"                                 , 0x0554, 0},
  { "WE_TEMPERATUR_12"                                 , 0x0555, 0},
  { "WE_TEMPERATUR_13"                                 , 0x0556, 0},
  { "WE_TEMPERATUR_14"                                 , 0x0557, 0},
  { "WE_TEMPERATUR_15"                                 , 0x0558, 0},
  { "WE_TEMPERATUR_16"                                 , 0x0559, 0},
  { "WE_MODGRAD_IST_1"                                 , 0x055a, 0},
  { "WE_MODGRAD_IST_2"                                 , 0x055b, 0},
  { "WE_MODGRAD_IST_3"                                 , 0x055c, 0},
  { "WE_MODGRAD_IST_4"                                 , 0x055d, 0},
  { "WE_MODGRAD_IST_5"                                 , 0x055e, 0},
  { "WE_MODGRAD_IST_6"                                 , 0x055f, 0},
  { "WE_MODGRAD_IST_7"                                 , 0x0560, 0},
  { "WE_MODGRAD_IST_8"                                 , 0x0561, 0},
  { "WE_MODGRAD_IST_9"                                 , 0x0562, 0},
  { "WE_MODGRAD_IST_10"                                , 0x0563, 0},
  { "WE_MODGRAD_IST_11"                                , 0x0564, 0},
  { "WE_MODGRAD_IST_12"                                , 0x0565, 0},
  { "WE_MODGRAD_IST_13"                                , 0x0566, 0},
  { "WE_MODGRAD_IST_14"                                , 0x0567, 0},
  { "WE_MODGRAD_IST_15"                                , 0x0568, 0},
  { "WE_MODGRAD_IST_16"                                , 0x0569, 0},
  { "KUEHL_RAUMSOLL_TAG"                               , 0x056a, 0},
  { "KUEHL_RAUMSOLL_ABWESEND"                          , 0x056b, 0},
  { "KUEHL_RAUMSOLL_NACHT"                             , 0x056c, 0},
  { "LUEFT_STUFE_TAG"                                  , 0x056d, 0},
  { "LUEFT_STUFE_NACHT"                                , 0x056f, 0},
  { "LUEFT_STUFE_ABWESEND"                             , 0x0570, 0},
  { "LUEFT_STUFE_PARTY"                                , 0x0571, 0},
  { "LUEFT_ZEIT_AUSSERPLAN_STUFE0"                     , 0x0572, 0},
  { "LUEFT_ZEIT_AUSSERPLAN_STUFE1"                     , 0x0573, 0},
  { "LUEFT_ZEIT_AUSSERPLAN_STUFE2"                     , 0x0574, 0},
  { "LUEFT_ZEIT_AUSSERPLAN_STUFE3"                     , 0x0575, 0},
  { "LUEFT_PASSIVKUEHLUNG"                             , 0x0576, 0},
  { "LUEFT_ZULUFT_STUFE1"                              , 0x0577, 0},
  { "LUEFT_ZULUFT_STUFE2"                              , 0x0578, 0},
  { "LUEFT_ZULUFT_STUFE3"                              , 0x0579, 0},
  { "LUEFT_ABLUFT_STUFE1"                              , 0x057a, 0},
  { "LUEFT_ABLUFT_STUFE2"                              , 0x057b, 0},
  { "LUEFT_ABLUFT_STUFE3"                              , 0x057c, 0},
  { "OFEN_FUNKTION"                                    , 0x057d, 0},
  { "MAX_ABTAUDAUER"                                   , 0x057e, 0},
  { "ABTAUBEGINNSCHWELLE"                              , 0x057f, 0},
  { "DREHZAHL_FILTERWECHSEL"                           , 0x0580, 0},
  { "EINSTELLSPEICHER_HAND"                            , 0x0581, 0},
  { "EINSTELLSPEICHER_ABWESEND"                        , 0x0582, 0},
  { "KUEL_VORLAUFSOLLTEMP"                             , 0x0583, 0},
  { "KUEHL_HYST_SOLLTEMP"                              , 0x0584, 0},
  { "KUEHL_HYST_RAUMTEMP"                              , 0x0585, 0},
  { "MAX_ABTAUDAUER_LUFT"                              , 0x0586, 0},
  { "ANTILEG_INTERVALL_TAGE"                           , 0x0587, 0},
  { "ANTILEG_TEMP"                                     , 0x0588, 0},
  { "NHZ_VERZOEGERUNG_WW"                              , 0x0589, 0},
  { "NHZ_AUSSENTEMP_SOFORT_WW"                         , 0x058a, 0},
  { "NHZ_ANZAHL_STUFEN_WW"                             , 0x058b, 0},
  { "WW_SPEICHER_ALS_PUFFER"                           , 0x058c, 0},
  { "MAX_VORLAUFTEMP_BEI_WW"                           , 0x058d, 0},
  { "ABSCHALTUNG_VERDICHTER_WW"                        , 0x058e, 0},
  { "VERZOEGERUNG_VERDICHTER_WW"                       , 0x058f, 0},
  { "SOLAR_HYSTERESE"                                  , 0x0590, 0},
  { "PARTY_ANFANG_TAG"                                 , 0x0591, 0},
  { "PARTY_ANFANG_MONAT"                               , 0x0592, 0},
  { "PARTY_ANFANG_JAHR"                                , 0x0593, 0},
  { "PARTY_ENDE_TAG"                                   , 0x0594, 0},
  { "PARTY_ENDE_MONAT"                                 , 0x0595, 0},
  { "PARTY_ENDE_JAHR"                                  , 0x0596, 0},
  { "ZULUFT_SOLL"                                      , 0x0597, 0},
  { "ZULUFT_IST"                                       , 0x0598, 0},
  { "ABLUFT_SOLL"                                      , 0x0599, 0},
  { "ABLUFT_IST"                                       , 0x059a, 0},
  { "FORTLUFT_SOLL"                                    , 0x059b, 0},
  { "FORTLUFT_IST"                                     , 0x059c, 0},
  { "VERFLUESSIGER_TEMP"                               , 0x059d, 0},
  { "ANTEIL_VORLAUF"                                   , 0x059e, 0},
  { "FUSSPUNKT_HEIZKURVE"                              , 0x059f, 0},
  { "NHZ_ANZAHL_STUFEN"                                , 0x05a0, 0},
  { "NHZ_VERZOEGERUNG"                                 , 0x05a1, 0},
  { "NHZ_LEISTUNG1"                                    , 0x05a2, 0},
  { "HEIZGRENZE_HYST"                                  , 0x05a3, 0},
  { "AUSSENTEMP_KORREKTUR"                             , 0x05a4, 0},
  { "LAUFZEIT_VERDICHTER_HEIZEN"                       , 0x05a5, 0},
  { "LAUFZEIT_VERDICHTER_KUEHLEN"                      , 0x05a6, 0},
  { "LAUFZEIT_VERDICHTER_WW"                           , 0x05a7, 0},
  { "LAUFZEIT_NHZ_WW"                                  , 0x05a8, 0},
  { "LAUFZEIT_NHZ_HEIZEN"                              , 0x05a9, 0},
  { "MANUELL_VERDICHTER"                               , 0x05aa, 0},
  { "MANUELL_NHZ_STUFE"                                , 0x05ab, 0},
  { "MANUELL_DREHZAHL_ABLUEFTER"                       , 0x05ac, 0},
  { "MANUELL_DREHZAHL_ZULUEFTER"                       , 0x05ad, 0},
  { "MANUELL_LUEFT_PARTY"                              , 0x05ae, 0},
  { "MANUELL_LUEFT_NACHT"                              , 0x05af, 0},
  { "MANUELL_FENSTERKONTAKT"                           , 0x05b0, 0},
  { "MANUELL_HEAT_PIPE_VENTIL"                         , 0x05b1, 0},
  { "MANUELL_UMSCHALTVENTIL"                           , 0x05b2, 0},
  { "ABTAUENDE_TEMP"                                   , 0x05b3, 0},
  { "NHZ_FROSTSCHUTZ"                                  , 0x05b4, 0},
  { "ABTAU_FROSTSCHUTZ"                                , 0x05b5, 0},
  { "VERDICHTER_EINSCHALT_VERZ"                        , 0x05b6, 0},
  { "FORTLUFT_LUEFTER_DREHZAHL"                        , 0x05b7, 0},
  { "PUMPENZYKLEN_MAX"                                 , 0x05b8, 0},
  { "PUMPENZYKLEN_MIN"                                 , 0x05b9, 0},
  { "PUMPENZYKLEN_MAX_AUSSENT"                         , 0x05ba, 0},
  { "PUMPENZYKLEN_MIN_AUSSENT"                         , 0x05bb, 0},
  { "AKTIVE_HEIZSTUFEN"                                , 0x05bc, 0},
  { "ABTAUEN_LL_WT_AKTIV"                              , 0x05bd, 0},
  { "RAUMTEMP_ERFASSUNG"                               , 0x05be, 0},
  { "SOLAR_EINSTELLSPEICHERSOLLT"                      , 0x05bf, 0},
  { "EINSTELLSPEICHER_NACHT"                           , 0x05c0, 0},
  { "HYST_HEIZSTUFE1"                                  , 0x05c1, 0},
  { "HYST_HEIZSTUFE2"                                  , 0x05c2, 0},
  { "HYST_HEIZSTUFE3"                                  , 0x05c3, 0},
  { "HYST_HEIZSTUFE4"                                  , 0x05c4, 0},
  { "HYST_HEIZSTUFE5"                                  , 0x05c5, 0},
  { "ASYMETRIE_HEIZSTUFEN"                             , 0x05c6, 0},
  { "VOLUMENSTROMMESSUNG"                              , 0x05c7, 0},
  { "FEHLERAUFZEICHNUNG_STOP"                          , 0x05c8, 0},
  { "HEIZEITVORVERLEGUNG_VERDICHTER"                   , 0x05c9, 0},
  { "SOLAR_SPEERZEIT_VERDICHTER"                       , 0x05ca, 0},
  { "PUMPSTEUER_FUEHRUNGSKESSEL"                       , 0x05cb, 0},
  { "AKTIVIERUNG_LEISTUNGSZWANG_WW"                    , 0x05cc, 0},
  { "HYSTERESE_LEISTUNGSZWANG_WW"                      , 0x05cd, 0},
  { "MIN_TEMP_DREHZAHLREGELUNG"                        , 0x05ce, 0},
  { "MAX_SPREIZUNG_DREHZAHLREGELUNG"                   , 0x05cf, 0},
  { "P_BEREICH_DREHZAHLPUMPE"                          , 0x05d0, 0},
  { "HF_NETZWERK_ID"                                   , 0x05d1, 0},
  { "PARTY_ANFANG_UHRZEIT"                             , 0x05d2, 0},
  { "PARTY_ENDE_UHRZEIT"                               , 0x05d3, 0},
  { "FERIEN_ANFANG_UHRZEIT"                            , 0x05d4, 0},
  { "FERIEN_ENDE_UHRZEIT"                              , 0x05d5, 0},
  { "FABRIKTEST_START"                                 , 0x05d6, 0},
  { "LEISTUNGSREDUZIERUNG_KUEHLEN"                     , 0x05d7, 0},
  { "ZWISCHENEINSPRITZUNG_ISTTEMP"                     , 0x05d8, 0},
  { "BETRIEBSART_QUELLENPUMPE"                         , 0x05d9, 0},
  { "GASVENTIL1"                                       , 0x05da, 0},
  { "GASVENTIL2"                                       , 0x05db, 0},
  { "LUEFT_PASSIVKUEHLUNG_UEBER_FORTLUEFTER"           , 0x05dc, 0},
  { "KUEHLZUSTAND"                                     , 0x05dd, 0},
  { "TEMPORALE_LUEFTUNGSSTUFE_STUFE"                   , 0x05de, 0},
  { "TEMPORALE_LUEFTUNGSSTUFE_DAUER"                   , 0x05df, 0},
  { "SCHALTFKT_QUELLE_IWS"                             , 0x05e0, 0},
  { "BITSCHALTER_1"                                    , 0x05e1, 0},
  { "WE_STATUS_1"                                      , 0x05e2, 0},
  { "WE_STATUS_2"                                      , 0x05e3, 0},
  { "WE_STATUS_3"                                      , 0x05e4, 0},
  { "WE_STATUS_4"                                      , 0x05e5, 0},
  { "WE_STATUS_5"                                      , 0x05e6, 0},
  { "WE_STATUS_6"                                      , 0x05e7, 0},
  { "WE_STATUS_7"                                      , 0x05e8, 0},
  { "WE_STATUS_8"                                      , 0x05e9, 0},
  { "WE_STATUS_9"                                      , 0x05ea, 0},
  { "WE_STATUS_10"                                     , 0x05eb, 0},
  { "WE_STATUS_11"                                     , 0x05ec, 0},
  { "WE_STATUS_12"                                     , 0x05ed, 0},
  { "WE_STATUS_13"                                     , 0x05ee, 0},
  { "WE_STATUS_14"                                     , 0x05ef, 0},
  { "WE_STATUS_15"                                     , 0x05f0, 0},
  { "WE_STATUS_16"                                     , 0x05f1, 0},
  { "WE_MODGRAD_VORGABE_1"                             , 0x05f2, 0},
  { "WE_MODGRAD_VORGABE_2"                             , 0x05f3, 0},
  { "WE_MODGRAD_VORGABE_3"                             , 0x05f4, 0},
  { "WE_MODGRAD_VORGABE_4"                             , 0x05f5, 0},
  { "WE_MODGRAD_VORGABE_5"                             , 0x05f6, 0},
  { "WE_MODGRAD_VORGABE_6"                             , 0x05f7, 0},
  { "WE_MODGRAD_VORGABE_7"                             , 0x05f8, 0},
  { "WE_MODGRAD_VORGABE_8"                             , 0x05f9, 0},
  { "WE_MODGRAD_VORGABE_9"                             , 0x05fa, 0},
  { "WE_MODGRAD_VORGABE_10"                            , 0x05fb, 0},
  { "WE_MODGRAD_VORGABE_11"                            , 0x05fc, 0},
  { "WE_MODGRAD_VORGABE_12"                            , 0x05fd, 0},
  { "WE_MODGRAD_VORGABE_13"                            , 0x05fe, 0},
  { "WE_MODGRAD_VORGABE_14"                            , 0x05ff, 0},
  { "WE_MODGRAD_VORGABE_15"                            , 0x0600, 0},
  { "WE_MODGRAD_VORGABE_16"                            , 0x0601, 0},
  { "WE_STB_TESTFUNKTION_1"                            , 0x0602, 0},
  { "WE_STB_TESTFUNKTION_2"                            , 0x0603, 0},
  { "WE_STB_TESTFUNKTION_3"                            , 0x0604, 0},
  { "WE_STB_TESTFUNKTION_4"                            , 0x0605, 0},
  { "WE_STB_TESTFUNKTION_5"                            , 0x0606, 0},
  { "WE_STB_TESTFUNKTION_6"                            , 0x0607, 0},
  { "WE_STB_TESTFUNKTION_7"                            , 0x0608, 0},
  { "WE_STB_TESTFUNKTION_8"                            , 0x0609, 0},
  { "WE_STB_TESTFUNKTION_9"                            , 0x060a, 0},
  { "WE_STB_TESTFUNKTION_10"                           , 0x060b, 0},
  { "WE_STB_TESTFUNKTION_11"                           , 0x060c, 0},
  { "WE_STB_TESTFUNKTION_12"                           , 0x060d, 0},
  { "WE_STB_TESTFUNKTION_13"                           , 0x060e, 0},
  { "WE_STB_TESTFUNKTION_14"                           , 0x060f, 0},
  { "WE_STB_TESTFUNKTION_15"                           , 0x0610, 0},
  { "WE_STB_TESTFUNKTION_16"                           , 0x0611, 0},
  { "UNTERD_TEMPM_PUMPENANL"                           , 0x0612, 0},
  { "LUEFT_STUFE_HAND"                                 , 0x0613, 0},// Min. Quellentemp. auf aus / Klaus
  { "KUEHLSYSTEM"                                      , 0x0614, 0},
  { "KESSEL_STARTVERZOEGERUNG"                         , 0x0615, 0},
  { "MFR_HYSTERESE2_1"                                 , 0x0616, 0},
  { "MFR_HYSTERESE2_2"                                 , 0x0617, 0},
  { "MFR_HYSTERESE2_3"                                 , 0x0618, 0},
  { "MFR_HYSTERESE2_4"                                 , 0x0619, 0},
  { "MFR_HYSTERESE2_5"                                 , 0x061a, 0},
  { "MFR_HYSTERESE2_6"                                 , 0x061b, 0},
  { "MFR_HYSTERESE2_7"                                 , 0x061c, 0},
  { "MFR_HYSTERESE2_8"                                 , 0x061d, 0},
  { "MFR_HYSTERESE2_9"                                 , 0x061e, 0},
  { "MFR_HYSTERESE2_10"                                , 0x061f, 0},
  { "MFR_HYSTERESE2_11"                                , 0x0620, 0},
  { "MFR_HYSTERESE2_12"                                , 0x0621, 0},
  { "MFR_HYSTERESE2_13"                                , 0x0622, 0},
  { "MFR_HYSTERESE2_14"                                , 0x0623, 0},
  { "MFR_HYSTERESE2_15"                                , 0x0624, 0},
  { "MFR_HYSTERESE2_16"                                , 0x0625, 0},
  { "MFR_HYSTERESE2_17"                                , 0x0626, 0},
  { "MFR_HYSTERESE2_18"                                , 0x0627, 0},
  { "MFR_HYSTERESE2_19"                                , 0x0628, 0},
  { "MFR_HYSTERESE2_20"                                , 0x0629, 0},
  { "MFR_HYSTERESE2_21"                                , 0x062a, 0},
  { "MFR_HYSTERESE2_22"                                , 0x062b, 0},
  { "MFR_HYSTERESE2_23"                                , 0x062c, 0},
  { "MFR_HYSTERESE2_24"                                , 0x062d, 0},
  { "MFR_HYSTERESE2_25"                                , 0x062e, 0},
  { "MFR_HYSTERESE2_26"                                , 0x062f, 0},
  { "MFR_HYSTERESE2_27"                                , 0x0630, 0},
  { "MFR_HYSTERESE2_28"                                , 0x0631, 0},
  { "MFR_HYSTERESE2_29"                                , 0x0632, 0},
  { "MFR_HYSTERESE2_30"                                , 0x0633, 0},
  { "MFR_HYSTERESE2_31"                                , 0x0634, 0},
  { "MFR_HYSTERESE2_32"                                , 0x0635, 0},
  { "K_OS_START_DREHZAHLAENDERUNG"                     , 0x0636, 0},
  { "K_OS_RMX_RESERVE_INFO1"                           , 0x0637, 0},
  { "K_OS_RMX_RESERVE_INFO2"                           , 0x0638, 0},
  { "K_OS_RMX_RESERVE_INFO3"                           , 0x0639, 0},
  { "HW_BITSCHALTER"                                   , 0x063a, 0},
  { "KUEHLFUNKTION"                                    , 0x063b, 0},
  { "SOLLDREHZAHL_VERDICHTER_1"                        , 0x063c, 0},
  { "SOLLDREHZAHL_VERDICHTER_2"                        , 0x063d, 0},
  { "ISTDREHZAHL_VERDICHTER_1"                         , 0x063e, 0},
  { "ISTDREHZAHL_VERDICHTER_2"                         , 0x063f, 0},
  { "ZWISCHENEINSPRITZUNG_ISTTEMP_VND"                 , 0x0640, 0},
  { "TEST_OBJEKT_0"                                    , 0x0641, 0},
  { "TEST_OBJEKT_1"                                    , 0x0642, 0},
  { "TEST_OBJEKT_2"                                    , 0x0643, 0},
  { "TEST_OBJEKT_3"                                    , 0x0644, 0},
  { "TEST_OBJEKT_4"                                    , 0x0645, 0},
  { "TEST_OBJEKT_5"                                    , 0x0646, 0},
  { "TEST_OBJEKT_6"                                    , 0x0647, 0},
  { "TEST_OBJEKT_7"                                    , 0x0648, 0},
  { "TEST_OBJEKT_8"                                    , 0x0649, 0},
  { "TEST_OBJEKT_9"                                    , 0x064a, 0},
  { "TEST_OBJEKT_10"                                   , 0x064b, 0},
  { "TEST_OBJEKT_11"                                   , 0x064c, 0},
  { "TEST_OBJEKT_12"                                   , 0x064d, 0},
  { "TEST_OBJEKT_13"                                   , 0x064e, 0},
  { "TEST_OBJEKT_14"                                   , 0x064f, 0},
  { "TEST_OBJEKT_15"                                   , 0x0650, 0},
  { "TEST_OBJEKT_16"                                   , 0x0651, 0},
  { "TEST_OBJEKT_17"                                   , 0x0652, 0},
  { "TEST_OBJEKT_18"                                   , 0x0653, 0},
  { "TEST_OBJEKT_19"                                   , 0x0654, 0},
  { "TEST_OBJEKT_20"                                   , 0x0655, 0},
  { "TEST_OBJEKT_21"                                   , 0x0656, 0},
  { "TEST_OBJEKT_22"                                   , 0x0657, 0},
  { "TEST_OBJEKT_23"                                   , 0x0658, 0},
  { "TEST_OBJEKT_24"                                   , 0x0659, 0},
  { "TEST_OBJEKT_25"                                   , 0x065a, 0},
  { "TEST_OBJEKT_26"                                   , 0x065b, 0},
  { "TEST_OBJEKT_27"                                   , 0x065c, 0},
  { "TEST_OBJEKT_28"                                   , 0x065d, 0},
  { "TEST_OBJEKT_29"                                   , 0x065e, 0},
  { "TEST_OBJEKT_30"                                   , 0x065f, 0},
  { "TEST_OBJEKT_31"                                   , 0x0660, 0},
  { "TEST_OBJEKT_32"                                   , 0x0661, 0},
  { "TEST_OBJEKT_33"                                   , 0x0662, 0},
  { "TEST_OBJEKT_34"                                   , 0x0663, 0},
  { "TEST_OBJEKT_35"                                   , 0x0664, 0},
  { "TEST_OBJEKT_36"                                   , 0x0665, 0},
  { "TEST_OBJEKT_37"                                   , 0x0666, 0},
  { "TEST_OBJEKT_38"                                   , 0x0667, 0},
  { "TEST_OBJEKT_39"                                   , 0x0668, 0},
  { "TEST_OBJEKT_40"                                   , 0x0669, 0},
  { "TEST_OBJEKT_41"                                   , 0x066a, 0},
  { "TEST_OBJEKT_42"                                   , 0x066b, 0},
  { "TEST_OBJEKT_43"                                   , 0x066c, 0},
  { "TEST_OBJEKT_44"                                   , 0x066d, 0},
  { "TEST_OBJEKT_45"                                   , 0x066e, 0},
  { "TEST_OBJEKT_46"                                   , 0x066f, 0},
  { "TEST_OBJEKT_47"                                   , 0x0670, 0},
  { "TEST_OBJEKT_48"                                   , 0x0671, 0},
  { "TEST_OBJEKT_49"                                   , 0x0672, 0},
  { "TEST_OBJEKT_50"                                   , 0x0673, 0},
  { "TEST_OBJEKT_51"                                   , 0x0674, 0},
  { "TEST_OBJEKT_52"                                   , 0x0675, 0},
  { "TEST_OBJEKT_53"                                   , 0x0676, 0},
  { "TEST_OBJEKT_54"                                   , 0x0677, 0},
  { "TEST_OBJEKT_55"                                   , 0x0678, 0},
  { "TEST_OBJEKT_56"                                   , 0x0679, 0},
  { "TEST_OBJEKT_57"                                   , 0x067a, 0},
  { "TEST_OBJEKT_58"                                   , 0x067b, 0},
  { "TEST_OBJEKT_59"                                   , 0x067c, 0},
  { "TEST_OBJEKT_60"                                   , 0x067d, 0},
  { "TEST_OBJEKT_61"                                   , 0x067e, 0},
  { "TEST_OBJEKT_62"                                   , 0x067f, 0},
  { "TEST_OBJEKT_63"                                   , 0x0680, 0},
  { "TEST_OBJEKT_64"                                   , 0x0681, 0},
  { "TEST_OBJEKT_65"                                   , 0x0682, 0},
  { "TEST_OBJEKT_66"                                   , 0x0683, 0},
  { "TEST_OBJEKT_67"                                   , 0x0684, 0},
  { "TEST_OBJEKT_68"                                   , 0x0685, 0},
  { "TEST_OBJEKT_69"                                   , 0x0686, 0},
  { "TEST_OBJEKT_70"                                   , 0x0687, 0},
  { "TEST_OBJEKT_71"                                   , 0x0688, 0},
  { "TEST_OBJEKT_72"                                   , 0x0689, 0},
  { "TEST_OBJEKT_73"                                   , 0x068a, 0},
  { "TEST_OBJEKT_74"                                   , 0x068b, 0},
  { "TEST_OBJEKT_75"                                   , 0x068c, 0},
  { "TEST_OBJEKT_76"                                   , 0x068d, 0},
  { "TEST_OBJEKT_77"                                   , 0x068e, 0},
  { "TEST_OBJEKT_78"                                   , 0x068f, 0},
  { "TEST_OBJEKT_79"                                   , 0x0690, 0},
  { "TEST_OBJEKT_80"                                   , 0x0691, 0},
  { "TEST_OBJEKT_81"                                   , 0x0692, 0},
  { "TEST_OBJEKT_82"                                   , 0x0693, 0},
  { "TEST_OBJEKT_83"                                   , 0x0694, 0},
  { "TEST_OBJEKT_84"                                   , 0x0695, 0},
  { "TEST_OBJEKT_85"                                   , 0x0696, 0},
  { "TEST_OBJEKT_86"                                   , 0x0697, 0},
  { "TEST_OBJEKT_87"                                   , 0x0698, 0},
  { "TEST_OBJEKT_88"                                   , 0x0699, 0},
  { "TEST_OBJEKT_89"                                   , 0x069a, 0},
  { "TEST_OBJEKT_90"                                   , 0x069b, 0},
  { "TEST_OBJEKT_91"                                   , 0x069c, 0},
  { "TEST_OBJEKT_92"                                   , 0x069d, 0},
  { "TEST_OBJEKT_93"                                   , 0x069e, 0},
  { "TEST_OBJEKT_94"                                   , 0x069f, 0},
  { "TEST_OBJEKT_95"                                   , 0x06a0, 0},
  { "TEST_OBJEKT_96"                                   , 0x06a1, 0},
  { "TEST_OBJEKT_97"                                   , 0x06a2, 0},
  { "TEST_OBJEKT_98"                                   , 0x06a3, 0},
  { "TEST_OBJEKT_99"                                   , 0x06a4, 0},
  { "TEST_OBJEKT_100"                                  , 0x06a5, 0},
  { "TEST_OBJEKT_101"                                  , 0x06a6, 0},
  { "TEST_OBJEKT_102"                                  , 0x06a7, 0},
  { "TEST_OBJEKT_103"                                  , 0x06a8, 0},
  { "TEST_OBJEKT_104"                                  , 0x06a9, 0},
  { "TEST_OBJEKT_105"                                  , 0x06aa, 0},
  { "TEST_OBJEKT_106"                                  , 0x06ab, 0},
  { "TEST_OBJEKT_107"                                  , 0x06ac, 0},
  { "TEST_OBJEKT_108"                                  , 0x06ad, 0},
  { "TEST_OBJEKT_109"                                  , 0x06ae, 0},
  { "TEST_OBJEKT_110"                                  , 0x06af, 0},
  { "TEST_OBJEKT_111"                                  , 0x06b0, 0},
  { "TEST_OBJEKT_112"                                  , 0x06b1, 0},
  { "TEST_OBJEKT_113"                                  , 0x06b2, 0},
  { "TEST_OBJEKT_114"                                  , 0x06b3, 0},
  { "TEST_OBJEKT_115"                                  , 0x06b4, 0},
  { "TEST_OBJEKT_116"                                  , 0x06b5, 0},
  { "TEST_OBJEKT_117"                                  , 0x06b6, 0},
  { "TEST_OBJEKT_118"                                  , 0x06b7, 0},
  { "TEST_OBJEKT_119"                                  , 0x06b8, 0},
  { "TEST_OBJEKT_120"                                  , 0x06b9, 0},
  { "TEST_OBJEKT_121"                                  , 0x06ba, 0},
  { "TEST_OBJEKT_122"                                  , 0x06bb, 0},
  { "TEST_OBJEKT_123"                                  , 0x06bc, 0},
  { "TEST_OBJEKT_124"                                  , 0x06bd, 0},
  { "TEST_OBJEKT_125"                                  , 0x06be, 0},
  { "TEST_OBJEKT_126"                                  , 0x06bf, 0},
  { "TEST_OBJEKT_127"                                  , 0x06c0, 0},
  { "TEST_OBJEKT_128"                                  , 0x06c1, 0},
  { "TEST_OBJEKT_129"                                  , 0x06c2, 0},
  { "TEST_OBJEKT_130"                                  , 0x06c3, 0},
  { "TEST_OBJEKT_131"                                  , 0x06c4, 0},
  { "TEST_OBJEKT_132"                                  , 0x06c5, 0},
  { "TEST_OBJEKT_133"                                  , 0x06c6, 0},
  { "TEST_OBJEKT_134"                                  , 0x06c7, 0},
  { "TEST_OBJEKT_135"                                  , 0x06c8, 0},
  { "TEST_OBJEKT_136"                                  , 0x06c9, 0},
  { "TEST_OBJEKT_137"                                  , 0x06ca, 0},
  { "TEST_OBJEKT_138"                                  , 0x06cb, 0},
  { "TEST_OBJEKT_139"                                  , 0x06cc, 0},
  { "TEST_OBJEKT_140"                                  , 0x06cd, 0},
  { "TEST_OBJEKT_141"                                  , 0x06ce, 0},
  { "TEST_OBJEKT_142"                                  , 0x06cf, 0},
  { "TEST_OBJEKT_143"                                  , 0x06d0, 0},
  { "TEST_OBJEKT_144"                                  , 0x06d1, 0},
  { "TEST_OBJEKT_145"                                  , 0x06d2, 0},
  { "TEST_OBJEKT_146"                                  , 0x06d3, 0},
  { "TEST_OBJEKT_147"                                  , 0x06d4, 0},
  { "TEST_OBJEKT_148"                                  , 0x06d5, 0},
  { "TEST_OBJEKT_149"                                  , 0x06d6, 0},
  { "TEST_OBJEKT_150"                                  , 0x06d7, 0},
  { "TEST_OBJEKT_151"                                  , 0x06d8, 0},
  { "TEST_OBJEKT_152"                                  , 0x06d9, 0},
  { "TEST_OBJEKT_153"                                  , 0x06da, 0},
  { "TEST_OBJEKT_154"                                  , 0x06db, 0},
  { "TEST_OBJEKT_155"                                  , 0x06dc, 0},
  { "TEST_OBJEKT_156"                                  , 0x06dd, 0},
  { "TEST_OBJEKT_157"                                  , 0x06de, 0},
  { "TEST_OBJEKT_158"                                  , 0x06df, 0},
  { "TEST_OBJEKT_159"                                  , 0x06e0, 0},
  { "TEST_OBJEKT_160"                                  , 0x06e1, 0},
  { "TEST_OBJEKT_161"                                  , 0x06e2, 0},
  { "TEST_OBJEKT_162"                                  , 0x06e3, 0},
  { "TEST_OBJEKT_163"                                  , 0x06e4, 0},
  { "TEST_OBJEKT_164"                                  , 0x06e5, 0},
  { "TEST_OBJEKT_165"                                  , 0x06e6, 0},
  { "TEST_OBJEKT_166"                                  , 0x06e7, 0},
  { "TEST_OBJEKT_167"                                  , 0x06e8, 0},
  { "TEST_OBJEKT_168"                                  , 0x06e9, 0},
  { "TEST_OBJEKT_169"                                  , 0x06ea, 0},
  { "TEST_OBJEKT_170"                                  , 0x06eb, 0},
  { "TEST_OBJEKT_171"                                  , 0x06ec, 0},
  { "TEST_OBJEKT_172"                                  , 0x06ed, 0},
  { "TEST_OBJEKT_173"                                  , 0x06ee, 0},
  { "TEST_OBJEKT_174"                                  , 0x06ef, 0},
  { "TEST_OBJEKT_175"                                  , 0x06f0, 0},
  { "TEST_OBJEKT_176"                                  , 0x06f1, 0},
  { "TEST_OBJEKT_177"                                  , 0x06f2, 0},
  { "TEST_OBJEKT_178"                                  , 0x06f3, 0},
  { "TEST_OBJEKT_179"                                  , 0x06f4, 0},
  { "TEST_OBJEKT_180"                                  , 0x06f5, 0},
  { "TEST_OBJEKT_181"                                  , 0x06f6, 0},
  { "TEST_OBJEKT_182"                                  , 0x06f7, 0},
  { "TEST_OBJEKT_183"                                  , 0x06f8, 0},
  { "TEST_OBJEKT_184"                                  , 0x06f9, 0},
  { "TEST_OBJEKT_185"                                  , 0x06fa, 0},
  { "TEST_OBJEKT_186"                                  , 0x06fb, 0},
  { "TEST_OBJEKT_187"                                  , 0x06fc, 0},
  { "TEST_OBJEKT_188"                                  , 0x06fd, 0},
  { "TEST_OBJEKT_189"                                  , 0x06fe, 0},
  { "TEST_OBJEKT_190"                                  , 0x06ff, 0},
  { "TEST_OBJEKT_191"                                  , 0x0700, 0},
  { "TEST_OBJEKT_192"                                  , 0x0701, 0},
  { "TEST_OBJEKT_193"                                  , 0x0702, 0},
  { "TEST_OBJEKT_194"                                  , 0x0703, 0},
  { "TEST_OBJEKT_195"                                  , 0x0704, 0},
  { "TEST_OBJEKT_196"                                  , 0x0705, 0},
  { "TEST_OBJEKT_197"                                  , 0x0706, 0},
  { "TEST_OBJEKT_198"                                  , 0x0707, 0},
  { "TEST_OBJEKT_199"                                  , 0x0708, 0},
  { "TEST_OBJEKT_200"                                  , 0x0709, 0},
  { "TEST_OBJEKT_201"                                  , 0x070a, 0},
  { "TEST_OBJEKT_202"                                  , 0x070b, 0},
  { "TEST_OBJEKT_203"                                  , 0x070c, 0},
  { "TEST_OBJEKT_204"                                  , 0x070d, 0},
  { "TEST_OBJEKT_205"                                  , 0x070e, 0},
  { "TEST_OBJEKT_206"                                  , 0x070f, 0},
  { "TEST_OBJEKT_207"                                  , 0x0710, 0},
  { "TEST_OBJEKT_208"                                  , 0x0711, 0},
  { "TEST_OBJEKT_209"                                  , 0x0712, 0},
  { "TEST_OBJEKT_210"                                  , 0x0713, 0},
  { "TEST_OBJEKT_211"                                  , 0x0714, 0},
  { "TEST_OBJEKT_212"                                  , 0x0715, 0},
  { "TEST_OBJEKT_213"                                  , 0x0716, 0},
  { "TEST_OBJEKT_214"                                  , 0x0717, 0},
  { "TEST_OBJEKT_215"                                  , 0x0718, 0},
  { "TEST_OBJEKT_216"                                  , 0x0719, 0},
  { "TEST_OBJEKT_217"                                  , 0x071a, 0},
  { "TEST_OBJEKT_218"                                  , 0x071b, 0},
  { "TEST_OBJEKT_219"                                  , 0x071c, 0},
  { "TEST_OBJEKT_220"                                  , 0x071d, 0},
  { "TEST_OBJEKT_221"                                  , 0x071e, 0},
  { "TEST_OBJEKT_222"                                  , 0x071f, 0},
  { "TEST_OBJEKT_223"                                  , 0x0720, 0},
  { "TEST_OBJEKT_224"                                  , 0x0721, 0},
  { "TEST_OBJEKT_225"                                  , 0x0722, 0},
  { "TEST_OBJEKT_226"                                  , 0x0723, 0},
  { "TEST_OBJEKT_227"                                  , 0x0724, 0},
  { "TEST_OBJEKT_228"                                  , 0x0725, 0},
  { "TEST_OBJEKT_229"                                  , 0x0726, 0},
  { "TEST_OBJEKT_230"                                  , 0x0727, 0},
  { "TEST_OBJEKT_231"                                  , 0x0728, 0},
  { "TEST_OBJEKT_232"                                  , 0x0729, 0},
  { "TEST_OBJEKT_233"                                  , 0x072a, 0},
  { "TEST_OBJEKT_234"                                  , 0x072b, 0},
  { "TEST_OBJEKT_235"                                  , 0x072c, 0},
  { "TEST_OBJEKT_236"                                  , 0x072d, 0},
  { "TEST_OBJEKT_237"                                  , 0x072e, 0},
  { "TEST_OBJEKT_238"                                  , 0x072f, 0},
  { "TEST_OBJEKT_239"                                  , 0x0730, 0},
  { "TEST_OBJEKT_240"                                  , 0x0731, 0},
  { "TEST_OBJEKT_241"                                  , 0x0732, 0},
  { "TEST_OBJEKT_242"                                  , 0x0733, 0},
  { "TEST_OBJEKT_243"                                  , 0x0734, 0},
  { "TEST_OBJEKT_244"                                  , 0x0735, 0},
  { "TEST_OBJEKT_245"                                  , 0x0736, 0},
  { "TEST_OBJEKT_246"                                  , 0x0737, 0},
  { "TEST_OBJEKT_247"                                  , 0x0738, 0},
  { "TEST_OBJEKT_248"                                  , 0x0739, 0},
  { "TEST_OBJEKT_249"                                  , 0x073b, 0},
  { "KALIBRIERWERT_1_1"                                , 0x073b, 0},
  { "KALIBRIERWERT_1_2"                                , 0x073c, 0},
  { "KALIBRIERWERT_1_3"                                , 0x073d, 0},
  { "KALIBRIERWERT_1_4"                                , 0x073e, 0},
  { "KALIBRIERWERT_1_5"                                , 0x073f, 0},
  { "KALIBRIERWERT_1_6"                                , 0x0740, 0},
  { "KALIBRIERWERT_1_7"                                , 0x0741, 0},
  { "KALIBRIERWERT_1_8"                                , 0x0742, 0},
  { "KALIBRIERWERT_1_9"                                , 0x0743, 0},
  { "KALIBRIERWERT_1_10"                               , 0x0744, 0},
  { "KALIBRIERWERT_2_1"                                , 0x0745, 0},
  { "KALIBRIERWERT_2_2"                                , 0x0746, 0},
  { "KALIBRIERWERT_2_3"                                , 0x0747, 0},
  { "KALIBRIERWERT_2_4"                                , 0x0748, 0},
  { "KALIBRIERWERT_2_5"                                , 0x0749, 0},
  { "KALIBRIERWERT_2_6"                                , 0x074a, 0},
  { "KALIBRIERWERT_2_7"                                , 0x074b, 0},
  { "KALIBRIERWERT_2_8"                                , 0x074c, 0},
  { "KALIBRIERWERT_2_9"                                , 0x074d, 0},
  { "KALIBRIERWERT_2_10"                               , 0x074e, 0},
  { "KALIBRIERWERT_3_1"                                , 0x074f, 0},
  { "KALIBRIERWERT_3_2"                                , 0x0750, 0},
  { "KALIBRIERWERT_3_3"                                , 0x0751, 0},
  { "KALIBRIERWERT_3_4"                                , 0x0752, 0},
  { "KALIBRIERWERT_3_5"                                , 0x0753, 0},
  { "KALIBRIERWERT_3_6"                                , 0x0754, 0},
  { "KALIBRIERWERT_3_7"                                , 0x0755, 0},
  { "KALIBRIERWERT_3_8"                                , 0x0756, 0},
  { "KALIBRIERWERT_3_9"                                , 0x0757, 0},
  { "KALIBRIERWERT_3_10"                               , 0x0758, 0},
  { "KALIBRIERWERT_4_1"                                , 0x0759, 0},
  { "KALIBRIERWERT_4_2"                                , 0x075a, 0},
  { "KALIBRIERWERT_4_3"                                , 0x075b, 0},
  { "KALIBRIERWERT_4_4"                                , 0x075c, 0},
  { "KALIBRIERWERT_4_5"                                , 0x075d, 0},
  { "KALIBRIERWERT_4_6"                                , 0x075e, 0},
  { "KALIBRIERWERT_4_7"                                , 0x075f, 0},
  { "KALIBRIERWERT_4_8"                                , 0x0760, 0},
  { "KALIBRIERWERT_4_9"                                , 0x0761, 0},
  { "KALIBRIERWERT_4_10"                               , 0x0762, 0},
  { "KALIBRIERWERT_5_1"                                , 0x0763, 0},
  { "KALIBRIERWERT_5_2"                                , 0x0764, 0},
  { "KALIBRIERWERT_5_3"                                , 0x0765, 0},
  { "KALIBRIERWERT_5_4"                                , 0x0766, 0},
  { "KALIBRIERWERT_5_5"                                , 0x0767, 0},
  { "KALIBRIERWERT_5_6"                                , 0x0768, 0},
  { "KALIBRIERWERT_5_7"                                , 0x0769, 0},
  { "KALIBRIERWERT_5_8"                                , 0x076a, 0},
  { "KALIBRIERWERT_5_9"                                , 0x076b, 0},
  { "KALIBRIERWERT_5_10"                               , 0x076c, 0},
  { "KALIBRIERWERT_6_1"                                , 0x076d, 0},
  { "KALIBRIERWERT_6_2"                                , 0x076e, 0},
  { "KALIBRIERWERT_6_3"                                , 0x076f, 0},
  { "KALIBRIERWERT_6_4"                                , 0x0770, 0},
  { "KALIBRIERWERT_6_5"                                , 0x0771, 0},
  { "KALIBRIERWERT_6_6"                                , 0x0772, 0},
  { "KALIBRIERWERT_6_7"                                , 0x0773, 0},
  { "KALIBRIERWERT_6_8"                                , 0x0774, 0},
  { "KALIBRIERWERT_6_9"                                , 0x0775, 0},
  { "KALIBRIERWERT_6_10"                               , 0x0776, 0},
  { "KALIBRIERWERT_7_1"                                , 0x0777, 0},
  { "KALIBRIERWERT_7_2"                                , 0x0778, 0},
  { "KALIBRIERWERT_7_3"                                , 0x0779, 0},
  { "KALIBRIERWERT_7_4"                                , 0x077a, 0},
  { "KALIBRIERWERT_7_5"                                , 0x077b, 0},
  { "KALIBRIERWERT_7_6"                                , 0x077c, 0},
  { "KALIBRIERWERT_7_7"                                , 0x077d, 0},
  { "KALIBRIERWERT_7_8"                                , 0x077e, 0},
  { "KALIBRIERWERT_7_9"                                , 0x077f, 0},
  { "KALIBRIERWERT_7_10"                               , 0x0780, 0},
  { "KALIBRIERWERT_8_1"                                , 0x0781, 0},
  { "KALIBRIERWERT_8_2"                                , 0x0782, 0},
  { "KALIBRIERWERT_8_3"                                , 0x0783, 0},
  { "KALIBRIERWERT_8_4"                                , 0x0784, 0},
  { "KALIBRIERWERT_8_5"                                , 0x0785, 0},
  { "KALIBRIERWERT_8_6"                                , 0x0786, 0},
  { "KALIBRIERWERT_8_7"                                , 0x0787, 0},
  { "KALIBRIERWERT_8_8"                                , 0x0788, 0},
  { "KALIBRIERWERT_8_9"                                , 0x0789, 0},
  { "KALIBRIERWERT_8_10"                               , 0x078a, 0},
  { "KALIBRIERWERT_9_1"                                , 0x078b, 0},
  { "KALIBRIERWERT_9_2"                                , 0x078c, 0},
  { "KALIBRIERWERT_9_3"                                , 0x078d, 0},
  { "KALIBRIERWERT_9_4"                                , 0x078e, 0},
  { "KALIBRIERWERT_9_5"                                , 0x078f, 0},
  { "KALIBRIERWERT_9_6"                                , 0x0790, 0},
  { "KALIBRIERWERT_9_7"                                , 0x0791, 0},
  { "KALIBRIERWERT_9_8"                                , 0x0792, 0},
  { "KALIBRIERWERT_9_9"                                , 0x0793, 0},
  { "KALIBRIERWERT_9_10"                               , 0x0794, 0},
  { "KALIBRIERWERT_10_1"                               , 0x0795, 0},
  { "KALIBRIERWERT_10_2"                               , 0x0796, 0},
  { "KALIBRIERWERT_10_3"                               , 0x0797, 0},
  { "KALIBRIERWERT_10_4"                               , 0x0798, 0},
  { "KALIBRIERWERT_10_5"                               , 0x0799, 0},
  { "KALIBRIERWERT_10_6"                               , 0x079a, 0},
  { "KALIBRIERWERT_10_7"                               , 0x079b, 0},
  { "KALIBRIERWERT_10_8"                               , 0x079c, 0},
  { "KALIBRIERWERT_10_9"                               , 0x079d, 0},
  { "KALIBRIERWERT_10_10"                              , 0x079e, 0},
  { "STUETZSTELLE_ND1"                                 , 0x079f, 0},
  { "STUETZSTELLE_ND2"                                 , 0x07a0, 0},
  { "STUETZSTELLE_HD1"                                 , 0x07a1, 0},
  { "STUETZSTELLE_HD2"                                 , 0x07a2, 0},
  { "REKUPERATORISTTEMP"                               , 0x07a3, 0},
  { "MESSSTROM_HOCHDRUCK"                              , 0x07a4, 0},
  { "MESSSTROM_NIEDERDRUCK"                            , 0x07a5, 0},
  { "ANZEIGE_HOCHDRUCK"                                , 0x07a6, et_dec_val},
  { "ANZEIGE_NIEDERDRUCK"                              , 0x07a7, et_dec_val},
  { "VERDICHTER"                                       , 0x07a8, et_dec_val},
  { "VERDAMPFERISTTEMP_KOMPENSIERT"                    , 0x07a9, 0},
  { "TAU_PENDEL_ERKENNUNGSZEIT"                        , 0x07aa, 0},
  { "VERZOEGERUNG_PENDELERKENNUNG"                     , 0x07ab, 0},
  { "UEBERHITZUNG_VERDAMPFER_LOW"                      , 0x07ac, 0},
  { "UEBERHITZUNG_VERDAMPFER_MID"                      , 0x07ad, 0},
  { "UEBERHITZUNG_VERDAMPFER_HIGH"                     , 0x07ae, 0},
  { "UEBERHITZUNG_REKUPERATOR"                         , 0x07af, 0},
  { "UEBERHITZUNG_BEI_KUEHLBETRIEB"                    , 0x07b0, 0},
  { "ANFAHRFAKTOR_UEBERHITZUNG"                        , 0x07b1, 0},
  { "ANFAHRZEIT_UEBERHITZUNG"                          , 0x07b2, 0},
  { "GRENZE_PENDELN_VERDAMPFER"                        , 0x07b3, 0},
  { "GRENZE_PENDELN_REKUPERATOR"                       , 0x07b4, 0},
  { "TAU_UEBERHITZUNG_VERKLEINERN"                     , 0x07b5, 0},
  { "TAU_UEBERHITZUNG_VERGROESSERN"                    , 0x07b6, 0},
  { "VARIATION_UEBERHITZUNG"                           , 0x07b7, 0},
  { "V_H_EXPONENT_VSKL"                                , 0x07b8, 0},
  { "V_H_FAKTOR_VSKL"                                  , 0x07b9, 0},
  { "V_H_OFFSET_VSKL"                                  , 0x07ba, 0},
  { "V_K_EXPONENT_VSKL"                                , 0x07bb, 0},
  { "V_K_FAKTOR_VSKL"                                  , 0x07bc, 0},
  { "V_K_OFFSET_VSKL"                                  , 0x07bd, 0},
  { "WICHTUNG_REGELABWEICHUNG"                         , 0x07be, 0},
  { "P_VERDAMPFER"                                     , 0x07bf, 0},
  { "I_VERDAMPFER"                                     , 0x07c0, 0},
  { "D_VERDAMPFER"                                     , 0x07c1, 0},
  { "P_REKUPERATOR"                                    , 0x07c2, 0},
  { "I_REKUPERATOR"                                    , 0x07c3, 0},
  { "D_REKUPERATOR"                                    , 0x07c4, 0},
  { "MIN_REGELDYNAMIK"                                 , 0x07c5, 0},
  { "TAU_REGELDYNAMIK"                                 , 0x07c6, 0},
  { "EXV_OEFFNUNGSGRAD_MIN"                            , 0x07c7, 0},
  { "EXV_OEFFNUNGSGRAD_MAX"                            , 0x07c8, 0},
  { "EXV_TOTZONE"                                      , 0x07c9, 0},
  { "EXV_OEFFNUNGSGRAD"                                , 0x07ca, 0},
  { "PARAMETERSATZ"                                    , 0x07cb, 0},
  { "TIEFPASS_ND"                                      , 0x07cc, 0},
  { "ELEKTRONISCHE_ABTAUBEDARFSERKENNUNG"              , 0x07cd, 0},
  { "ELEKTRONISCHE_ABTAUENDEERKENNUNG"                 , 0x07ce, 0},
  { "OEFFNUNGSGRAD_ABTAUEN"                            , 0x07cf, 0},
  { "DRUCKDIFFERENZ_ABTAUEN"                           , 0x07d0, 0},
  { "OEFFNUNGSGRAD_HANDBETRIEB"                        , 0x07d1, 0},
  { "GRENZDRUCK_PUMPDOWN"                              , 0x07d2, 0},
  { "INJEKTION_PUMPDOWN"                               , 0x07d3, 0},
  { "UMSCHALTUNG_VERFLUESSIGERTEMP"                    , 0x07d4, 0},
  { "UMSCHALTUNG_TAUPUNKTTEMP"                         , 0x07d5, 0},
  { "KALIBRIERUNG_ON_OFF"                              , 0x07d6, 0},
  { "STARTZAHL_BIS_KALIBRIERUNG"                       , 0x07d7, 0},
  { "LAUFZEIT_BIS_KALIBRIERUNG"                        , 0x07d8, 0},
  { "ARBEITSPUNKT_KALIBRIERUNG"                        , 0x07d9, 0},
  { "OEG_KALIBRIERUNG_FAKTOR"                          , 0x07da, 0},
  { "KALIBRIERDAUER"                                   , 0x07db, 0},
  { "KALIBRIERABWEICHUNG_GRENZ"                        , 0x07dc, 0},
  { "KALIBRIERABWEICHUNG_ABSCHALTUNG"                  , 0x07dd, 0},
  { "FREIGABE_AUSSENTEMP_ZWISCHENEINSPRITZUNG"         , 0x07de, 0},
  { "NIEDERDRUCK_MOP_ND"                               , 0x07df, 0},
  { "ABTAUVERFAHREN"                                   , 0x07e0, 0},
  { "GRENZDRUCK_ABTAUENDE"                             , 0x07e1, 0},
  { "DAEMPFUNG_TAUTEMP_ABTAUAUSLOESUNG"                , 0x07e2, 0},
  { "TEMPERATURDIFFERENZ_ABTAUAUSLOESUNG"              , 0x07e3, 0},
  { "FREIGABE_ABTAUERKENNUNG"                          , 0x07e4, 0},
  { "BEGRENZUNG_HEISSGASTEMPERATUR"                    , 0x07e5, 0},
  { "P_FAKTOR_BEGRENZUNG_HEISSGASTEMPERATUR"           , 0x07e6, 0},
  { "LUEFTERLEISTUNG_AT_MIN"                           , 0x07e7, 0},
  { "LUEFTERLEISTUNG_AT_MAX"                           , 0x07e8, 0},
  { "GRENZWERT_ABWEICHUNG_V_KENNLINIE"                 , 0x07e9, 0},
  { "ZEIT_WAECHTER_ABWEICHUNG_V_KENNLINIE"             , 0x07ea, 0},
  { "MINIMALER_GRENZWERT_UEBERHITZUNG"                 , 0x07eb, 0},
  { "ZEIT_WAECHTER_UEBERHITZUNG"                       , 0x07ec, 0},
  { "ND_EVE_FUNKTION"                                  , 0x07ed, 0},
  { "ND_EVE_GRENZWERT"                                 , 0x07ee, 0},
  { "ND_MASKIERZEIT"                                   , 0x07ef, 0},
  { "HD_EVE_FUNKTION"                                  , 0x07f0, 0},
  { "HD_EVE_GRENZWERT_VHD"                             , 0x07f1, 0},
  { "BETRIEBSART_WP"                                   , 0x07f2, 0},
  { "SOLLWERT_UEBERHITZUNG"                            , 0x07f3, 0},
  { "ISTWERT_UEBERHITZUNG_VERDAMPFER"                  , 0x07f4, 0},
  { "ISTWERT_UEBERHITZUNG_REKUPERATOR_KUEHLEN"         , 0x07f5, 0},
  { "VORSTEUER_OEFFNUNGSGRAD"                          , 0x07f6, 0},
  { "P_ANTEIL_EXV"                                     , 0x07f7, 0},
  { "I_ANTEIL_EXV"                                     , 0x07f8, 0},
  { "D_ANTEIL_EXV"                                     , 0x07f9, 0},
  { "PENDELN_RELATIV"                                  , 0x07fa, 0},
  { "FAKTOR_REGELDYNAMIK"                              , 0x07fb, 0},
  { "LZ_VERD_1_HEIZBETRIEB"                            , 0x07fc, et_mil_val},
  { "LZ_VERD_2_HEIZBETRIEB"                            , 0x07fd, et_mil_val},
  { "LZ_VERD_1_2_HEIZBETRIEB"                          , 0x07fe, et_mil_val},
  { "LZ_VERD_1_KUEHLBETRIEB"                           , 0x07ff, et_mil_val},
  { "LZ_VERD_2_KUEHLBETRIEB"                           , 0x0800, et_mil_val},
  { "LZ_VERD_1_2_KUEHLBETRIEB"                         , 0x0801, et_mil_val},
  { "LZ_VERD_1_WW_BETRIEB"                             , 0x0802, 0},
  { "LZ_VERD_2_WW_BETRIEB"                             , 0x0803, 0},
  { "LZ_VERD_1_2_WW_BETRIEB"                           , 0x0804, 0},
  { "LZ_DHC12"                                         , 0x0805, 0},
  { "STARTS_ABTAUUNG"                                  , 0x0806, 0},
  { "ZEITDAUER_LETZTE_ABTAUUNG"                        , 0x0807, 0},
  { "ABTAUZEIT_VERD1"                                  , 0x0808, 0},
  { "ABTAUZEIT_VERD2"                                  , 0x0809, 0},
  { "TAUPUNKTTEMPERATUR_REFERENZ"                      , 0x080a, 0},
  { "TAUPUNKTTEMPERATUR_KOMPENSIERT"                   , 0x080b, 0},
  { "DRUCKREGELUNG_ND"                                 , 0x080c, 0},
  { "DRUCK_VERDAMPFER_GEFILTERT"                       , 0x080d, 0},
  { "FATAL_ERROR"                                      , 0x080e, 0},
  { "UEBERHITZUNG_ZWISCHENEINSPRITZUNG"                , 0x080f, 0},
  { "UNSYMMETRIE_DRUCK_ZE"                             , 0x0810, 0},
  { "VORSTEUER_ZE_FAKTOR"                              , 0x0811, 0},
  { "VORSTEUER_ZE_OFFSET"                              , 0x0812, 0},
  { "EINFLUSS_OG_DRUCK_ZE"                             , 0x0813, 0},
  { "P_ANTEIL_ZWISCHENEINSPRITZUNG"                    , 0x0814, 0},
  { "I_ANTEIL_ZWISCHENEINSPRITZUNG"                    , 0x0815, 0},
  { "VARIATION_OG_ZE"                                  , 0x0816, 0},
  { "UEBERHITZ_ZU_LEISTUNG_K"                          , 0x0817, 0},
  { "V_OG_ZU_LEISTUNG_K"                               , 0x0818, 0},
  { "DRUCK_ZWISCHENEINSPRITZUNG"                       , 0x0819, 0},
  { "UEBERHITZUNG_IST_ZWISCHENEINSPRITZUNG"            , 0x081a, 0},
  { "V_OEFFNUNGSGRAD_ZWISCHENEINSPRITZUNG"             , 0x081b, 0},
  { "EXV_OEFFNUNGSGRAD_ZWISCHENEINSPRITZUNG"           , 0x081c, 0},
  { "LAUFZEIT_VERD_BEI_SPEICHERBEDARF"                 , 0x081d, 0},
  { "AUSSEN_LUEFTERLEISTUNG_AT_MIN"                    , 0x081e, 0},
  { "AUSSEN_LUEFTERLEISTUNG_AT_MAX"                    , 0x081f, 0},
  { "VERDAMPFERTEMP_VOR_KOMPENSATION"                  , 0x0820, 0},
  { "VERDAMPFERTEMP_NACH_KOMPENSATION"                 , 0x0821, 0},
  { "VORLAUFISTTEMP_WP_IWS"                            , 0x0822, 0},
  { "RUECKLAUFISTTEMP_WP_IWS"                          , 0x0823, 0},
  { "OEFFGRAD_ZE_KUEHLUNG"                             , 0x0824, 0},
  { "DATENLOGGER_RING_BETRIEBSART"                     , 0x0825, 0},
  { "DATENLOGGER_RING_ZYKLUS"                          , 0x0826, 0},
  { "DATENLOGGER_TRIGGER_EREIGNIS"                     , 0x0827, 0},
  { "FEHLER_PARAMETERSATZ_IWS"                         , 0x0828, 0},
  { "PARAMETERSATZ_ANGEPASST_IWS"                      , 0x0829, 0},
  { "MIN_VORLAUF_KUEHLBETRIEB"                         , 0x082a, 0},
  { "AKT_KALIBRIERWERT_V"                              , 0x082b, 0},
  { "FUEHLERZEITKONSTANTE"                             , 0x082c, 0},
  { "KONFIG_0_BIS_10V"                                 , 0x082d, 0},
  { "EVE_GRENZWERT_KUEHLBETRIEB"                       , 0x082e, 0},
  { "MODKLAPPENLAUFZEIT"                               , 0x082f, 0},
  { "KONFIG_0_BIS_5V"                                  , 0x0830, 0},
  { "MESSSTROM_MITTELDRUCK"                            , 0x0831, 0},
  { "ANZEIGE_MITTELDRUCK"                              , 0x0832, 0},
  { "LUEFTERDREHZAHL"                                  , 0x0833, 0},
  { "D_ANTEIL_ZWISCHENEINSPRITZUNG"                    , 0x0834, 0},
  { "SOLLWERT_UEBERHITZUNG_ZWISCHENEINSPRITZUNG"       , 0x0835, 0},
  { "GESPEICHERTE_MODULE_LETZTER_INDEX"                , 0x0836, 0},
  { "GESPEICHERTE_MODULE_0"                            , 0x0837, 0},
  { "GESPEICHERTE_MODULE_1"                            , 0x0838, 0},
  { "GESPEICHERTE_MODULE_2"                            , 0x0839, 0},
  { "GESPEICHERTE_MODULE_3"                            , 0x083a, 0},
  { "GESPEICHERTE_MODULE_4"                            , 0x083b, 0},
  { "GESPEICHERTE_MODULE_5"                            , 0x083c, 0},
  { "GESPEICHERTE_MODULE_6"                            , 0x083d, 0},
  { "GESPEICHERTE_MODULE_7"                            , 0x083e, 0},
  { "GESPEICHERTE_MODULE_8"                            , 0x083f, 0},
  { "GESPEICHERTE_MODULE_9"                            , 0x0840, 0},
  { "GESPEICHERTE_MODULE_10"                           , 0x0841, 0},
  { "GESPEICHERTE_MODULE_11"                           , 0x0842, 0},
  { "GESPEICHERTE_MODULE_12"                           , 0x0843, 0},
  { "GESPEICHERTE_MODULE_13"                           , 0x0844, 0},
  { "GESPEICHERTE_MODULE_14"                           , 0x0845, 0},
  { "GESPEICHERTE_MODULE_15"                           , 0x0846, 0},
  { "GESPEICHERTE_MODULE_16"                           , 0x0847, 0},
  { "GESPEICHERTE_MODULE_17"                           , 0x0848, 0},
  { "GESPEICHERTE_MODULE_18"                           , 0x0849, 0},
  { "GESPEICHERTE_MODULE_19"                           , 0x084a, 0},
  { "GESPEICHERTE_MODULE_20"                           , 0x084b, 0},
  { "GESPEICHERTE_MODULE_21"                           , 0x084c, 0},
  { "GESPEICHERTE_MODULE_22"                           , 0x084d, 0},
  { "GESPEICHERTE_MODULE_23"                           , 0x084e, 0},
  { "GESPEICHERTE_MODULE_24"                           , 0x084f, 0},
  { "GESPEICHERTE_MODULE_25"                           , 0x0850, 0},
  { "GESPEICHERTE_MODULE_26"                           , 0x0851, 0},
  { "GESPEICHERTE_MODULE_27"                           , 0x0852, 0},
  { "GESPEICHERTE_MODULE_28"                           , 0x0853, 0},
  { "GESPEICHERTE_MODULE_29"                           , 0x0854, 0},
  { "GESPEICHERTE_MODULE_30"                           , 0x0855, 0},
  { "GESPEICHERTE_MODULE_31"                           , 0x0856, 0},
  { "GESPEICHERTE_MODULE_32"                           , 0x0857, 0},
  { "GESPEICHERTE_MODULE_33"                           , 0x0858, 0},
  { "GESPEICHERTE_MODULE_34"                           , 0x0859, 0},
  { "GESPEICHERTE_MODULE_35"                           , 0x085a, 0},
  { "GESPEICHERTE_MODULE_36"                           , 0x085b, 0},
  { "GESPEICHERTE_MODULE_37"                           , 0x085c, 0},
  { "GESPEICHERTE_MODULE_38"                           , 0x085d, 0},
  { "GESPEICHERTE_MODULE_39"                           , 0x085e, 0},
  { "GESPEICHERTE_MODULE_40"                           , 0x085f, 0},
  { "GESPEICHERTE_MODULE_41"                           , 0x0860, 0},
  { "GESPEICHERTE_MODULE_42"                           , 0x0861, 0},
  { "GESPEICHERTE_MODULE_43"                           , 0x0862, 0},
  { "GESPEICHERTE_MODULE_44"                           , 0x0863, 0},
  { "GESPEICHERTE_MODULE_45"                           , 0x0864, 0},
  { "GESPEICHERTE_MODULE_46"                           , 0x0865, 0},
  { "GESPEICHERTE_MODULE_47"                           , 0x0866, 0},
  { "GESPEICHERTE_MODULE_48"                           , 0x0867, 0},
  { "GESPEICHERTE_MODULE_49"                           , 0x0868, 0},
  { "GESPEICHERTE_MODULE_50"                           , 0x0869, 0},
  { "GESPEICHERTE_MODULE_51"                           , 0x086a, 0},
  { "GESPEICHERTE_MODULE_52"                           , 0x086b, 0},
  { "GESPEICHERTE_MODULE_53"                           , 0x086c, 0},
  { "GESPEICHERTE_MODULE_54"                           , 0x086d, 0},
  { "GESPEICHERTE_MODULE_55"                           , 0x086e, 0},
  { "GESPEICHERTE_MODULE_56"                           , 0x086f, 0},
  { "GESPEICHERTE_MODULE_57"                           , 0x0870, 0},
  { "GESPEICHERTE_MODULE_58"                           , 0x0871, 0},
  { "GESPEICHERTE_MODULE_59"                           , 0x0872, 0},
  { "GESPEICHERTE_MODULE_60"                           , 0x0873, 0},
  { "GESPEICHERTE_MODULE_61"                           , 0x0874, 0},
  { "GESPEICHERTE_MODULE_62"                           , 0x0875, 0},
  { "GESPEICHERTE_MODULE_63"                           , 0x0876, 0},
  { "LUEFTER_IST_DREHZAHL_WE1"                         , 0x0908, 0},
  { "LUEFTER_IST_DREHZAHL_WE2"                         , 0x0909, 0},
  { "STROMAUFNAHME_WE1_STUFE_1"                        , 0x090a, 0},
  { "STROMAUFNAHME_WE1_STUFE_2"                        , 0x090b, 0},
  { "STROMAUFNAHME_WE2_STUFE_1"                        , 0x090c, 0},
  { "STROMAUFNAHME_WE2_STUFE_2"                        , 0x090d, 0},
  { "STROMAUFNAHME_WE3_STUFE_1"                        , 0x090e, 0},
  { "STROMAUFNAHME_WE3_STUFE_2"                        , 0x090f, 0},
  { "STROMAUFNAHME_WE4_STUFE_1"                        , 0x0910, 0},
  { "STROMAUFNAHME_WE4_STUFE_2"                        , 0x0911, 0},
  { "EXV_SCHRITTWEITE"                                 , 0x0912, 0},
  { "MAX_RUECKLAUFTEMP_WP"                             , 0x0913, 0},
  { "MINDESTLAUFZEIT_WE"                               , 0x0914, 0},
  { "STUETZSTELLE_MD1"                                 , 0x0915, 0},
  { "STUETZSTELLE_MD2"                                 , 0x0916, 0},
  { "INTEGRAL_REGELABWEICHUNG_RELATIV"                 , 0x0917, 0},
  { "NIEDERDRUCK_MOP_HD"                               , 0x0918, 0},
  { "AUSLEGUNG_WE_LEISTUNG_TA"                         , 0x0919, 0},
  { "EL_AUFNAHMELEISTUNG_WW_TAG_WH"                    , 0x091a, 0},
  { "EL_AUFNAHMELEISTUNG_WW_TAG_KWH"                   , 0x091b, et_double_val},
  { "EL_AUFNAHMELEISTUNG_WW_SUM_KWH"                   , 0x091c, 0},
  { "EL_AUFNAHMELEISTUNG_WW_SUM_MWH"                   , 0x091d, et_double_val},
  { "EL_AUFNAHMELEISTUNG_HEIZ_TAG_WH"                  , 0x091e, 0},
  { "EL_AUFNAHMELEISTUNG_HEIZ_TAG_KWH"                 , 0x091f, et_double_val},
  { "EL_AUFNAHMELEISTUNG_HEIZ_SUM_KWH"                 , 0x0920, 0},
  { "EL_AUFNAHMELEISTUNG_HEIZ_SUM_MWH"                 , 0x0921, et_double_val},
  { "WAERMEERTRAG_2WE_WW_TAG_WH"                       , 0x0922, 0},
  { "WAERMEERTRAG_2WE_WW_TAG_KWH"                      , 0x0923, et_double_val},
  { "WAERMEERTRAG_2WE_WW_SUM_KWH"                      , 0x0924, 0},
  { "WAERMEERTRAG_2WE_WW_SUM_MWH"                      , 0x0925, et_double_val},
  { "WAERMEERTRAG_2WE_HEIZ_TAG_WH"                     , 0x0926, 0},
  { "WAERMEERTRAG_2WE_HEIZ_TAG_KWH"                    , 0x0927, et_double_val},
  { "WAERMEERTRAG_2WE_HEIZ_SUM_KWH"                    , 0x0928, 0},
  { "WAERMEERTRAG_2WE_HEIZ_SUM_MWH"                    , 0x0929, et_double_val},
  { "WAERMEERTRAG_WW_TAG_WH"                           , 0x092a, 0},
  { "WAERMEERTRAG_WW_TAG_KWH"                          , 0x092b, et_double_val},
  { "WAERMEERTRAG_WW_SUM_KWH"                          , 0x092c, 0},
  { "WAERMEERTRAG_WW_SUM_MWH"                          , 0x092d, et_double_val},
  { "WAERMEERTRAG_HEIZ_TAG_WH"                         , 0x092e, 0},
  { "WAERMEERTRAG_HEIZ_TAG_KWH"                        , 0x092f, et_double_val},
  { "WAERMEERTRAG_HEIZ_SUM_KWH"                        , 0x0930, 0},
  { "WAERMEERTRAG_HEIZ_SUM_MWH"                        , 0x0931, et_double_val},
  { "BUSKENNUNG_HEIZMODUL0"                            , 0x0932, 0},
  { "KUEHLEN_AUS_BEI_WW"                               , 0x0933, 0},
  { "KUEHL_HYSTERESEZEIT"                              , 0x0934, 0},
  { "MAX_KUEHL_HYSTERESE"                              , 0x0935, 0},
  { "KUEHL_HYSTERESE_2"                                , 0x0936, 0},
  { "KUEHL_SPERRZEIT"                                  , 0x0937, 0},
  { "MAX_RUECKLAUFSOLLTEMP_WP"                         , 0x0938, 0},
  { "MIN_RUECKLAUFSOLLTEMP_WP"                         , 0x0939, 0},
  { "MAX_AUSSENTEMP_WE"                                , 0x093a, 0},
  { "MIN_AUSSENTMEP_WP"                                , 0x093b, 0},
  { "KUEHLEN_MIT_WP"                                   , 0x093c, 0},
  { "PU_NACHTLADUNGPROG_EINSCHALTZEIT"                 , 0x093d, 0},
  { "PU_NACHTLADUNGPROG_AUSSCHALTZEIT"                 , 0x093e, 0},
  { "PU_NACHTLADUNG_TEMP"                              , 0x093f, 0},
  { "MIN_PU_TEMP_WE"                                   , 0x0940, 0},
  { "MIN_WW_TEMP_WE"                                   , 0x0941, 0},
  { "MAX_WE_SPERRZEIT"                                 , 0x0942, 0},
  { "MIN_RUECKLAUFKUEHLTEMP"                           , 0x0943, 0},
  { "SOMMERZEIT_AUTOMATIK"                             , 0x0944, 0},
  { "P_ANTEIL_EXV_ZE"                                  , 0x0945, 0},
  { "I_ANTEIL_EXV_ZE"                                  , 0x0946, 0},
  { "D_ANTEIL_EXV_ZE"                                  , 0x0947, 0},
  { "RESET_FEHLERBIT_STATUS_STUFE1"                    , 0x0948, 0},
  { "RESET_FEHLERBIT_STATUS_STUFE2"                    , 0x0949, 0},
  { "FEHLERBIT_STATUS_STUFE1"                          , 0x094a, 0},
  { "FEHLERBIT_STATUS_STUFE2"                          , 0x094b, 0},
  { "OT_TSP_0"                                         , 0x094c, 0},
  { "OT_TSP_1"                                         , 0x094d, 0},
  { "OT_TSP_2"                                         , 0x094e, 0},
  { "OT_TSP_3"                                         , 0x094f, 0},
  { "OT_TSP_4"                                         , 0x0950, 0},
  { "OT_TSP_5"                                         , 0x0951, 0},
  { "OT_TSP_6"                                         , 0x0952, 0},
  { "OT_TSP_7"                                         , 0x0953, 0},
  { "OT_TSP_8"                                         , 0x0954, 0},
  { "OT_TSP_9"                                         , 0x0955, 0},
  { "OT_TSP_10"                                        , 0x0956, 0},
  { "OT_TSP_11"                                        , 0x0957, 0},
  { "OT_TSP_12"                                        , 0x0958, 0},
  { "OT_TSP_13"                                        , 0x0959, 0},
  { "OT_TSP_14"                                        , 0x095a, 0},
  { "OT_TSP_15"                                        , 0x095b, 0},
  { "OT_TSP_16"                                        , 0x095c, 0},
  { "OT_TSP_17"                                        , 0x095d, 0},
  { "OT_TSP_18"                                        , 0x095e, 0},
  { "OT_TSP_19"                                        , 0x095f, 0},
  { "OT_TSP_20"                                        , 0x0960, 0},
  { "SAMMEL_RELAISSTATUS_ANZ"                          , 0x0962, 0},
  { "FOLGENWECHSEL_MINCOUNTER_LOW"                     , 0x0963, 0},
  { "FOLGENWECHSEL_MINCOUNTER_HIGH"                    , 0x0964, 0},
  { "ERKANNTE_KASKADENKESSEL"                          , 0x0965, 0},
  { "SCHWIMMBADISTTEMP"                                , 0x0966, 0},
  { "SCHWIMMBADSOLLTEMP_I"                             , 0x0967, 0},
  { "SCHWIMMBADSOLLTEMP_II"                            , 0x0968, 0},
  { "SCHWIMMBADSOLLTEMP_III"                           , 0x0969, 0},
  { "STATUSANZEIGE"                                    , 0x096a, 0},
  { "KONTRAST"                                         , 0x096b, 0},
  { "PARAMETER_SPANNUNGSEINGANG"                       , 0x096c, 0},
  { "PROGRAMMSCHALTER_LEITSTELLE"                      , 0x096d, 0},
  { "BERECHNETE_AUFHEIZOPTIMIERUNGSZEIT"               , 0x096e, 0},
  { "ANTILEGIONELLEN_ERFOLGREICH_MIT_SOLAR"            , 0x096f, 0},
  { "TEMPORAERE_PROGSTELL"                             , 0x0970, 0},
  { "RAUMREGLER_I_ANTEIL"                              , 0x0971, 0},
  { "HZK_VORVERLEGUNGSZEIT"                            , 0x0972, 0},
  { "HZK_TYP"                                          , 0x0973, 0},
  { "INIT_FUEHLER"                                     , 0x0974, 0},
  { "FEHLER_STUNDE"                                    , 0x0975, 0},
  { "FEHLER_MINUTE"                                    , 0x0976, 0},
  { "KOLLEKTORTEMP1_MIN_24H"                           , 0x0977, 0},
  { "KOLLEKTORTEMP1_MAX_24H"                           , 0x0978, 0},
  { "KOLLEKTORTEMP2_MIN_24H"                           , 0x0979, 0},
  { "KOLLEKTORTEMP2_MAX_24H"                           , 0x097a, 0},
  { "SPEICHER_UNTEN_TEMP1_MIN_24H"                     , 0x097b, 0},
  { "SPEICHER_UNTEN_TEMP1_MAX_24H"                     , 0x097c, 0},
  { "SPEICHER_UNTEN_TEMP2_MIN_24H"                     , 0x097d, 0},
  { "SPEICHER_UNTEN_TEMP2_MAX_24H"                     , 0x097e, 0},
  { "SPEICHER_UNTEN_TEMP3_MIN_24H"                     , 0x097f, 0},
  { "SPEICHER_UNTEN_TEMP3_MAX_24H"                     , 0x0980, 0},
  { "EINSTRAHLUNG_MIN_24H"                             , 0x0981, 0},
  { "EINSTRAHLUNG_MAX_24H"                             , 0x0982, 0},
  { "FUEHLER_FUER_RLW_FUNKTION"                        , 0x0983, 0},
  { "FUEHLER_FUER_TH1_FUNKTION"                        , 0x0984, 0},
  { "FUEHLER_FUER_TH2_FUNKTION"                        , 0x0985, 0},
  { "FUEHLER_FUER_TH3_FUNKTION"                        , 0x0986, 0},
  { "FUEHLER_FUER_TH4_FUNKTION"                        , 0x0987, 0},
  { "FUEHLER1_FUER_DT1_FUNKTION"                       , 0x0988, 0},
  { "FUEHLER2_FUER_DT1_FUNKTION"                       , 0x0989, 0},
  { "FUEHLER1_FUER_DT2_FUNKTION"                       , 0x098a, 0},
  { "FUEHLER2_FUER_DT2_FUNKTION"                       , 0x098b, 0},
  { "TEMPERATUR_TH1_FUNKTION_EIN"                      , 0x098c, 0},
  { "TEMPERATUR_TH1_FUNKTION_AUS"                      , 0x098d, 0},
  { "TEMPERATUR_TH2_FUNKTION_EIN"                      , 0x098e, 0},
  { "TEMPERATUR_TH2_FUNKTION_AUS"                      , 0x098f, 0},
  { "TEMPERATUR_TH3_FUNKTION_EIN"                      , 0x0990, 0},
  { "TEMPERATUR_TH3_FUNKTION_AUS"                      , 0x0991, 0},
  { "TEMPERATUR_TH4_FUNKTION_EIN"                      , 0x0992, 0},
  { "TEMPERATUR_TH4_FUNKTION_AUS"                      , 0x0993, 0},
  { "TEMPERATUR_DT1_FUNKTION_EIN"                      , 0x0994, 0},
  { "TEMPERATUR_DT1_FUNKTION_AUS"                      , 0x0995, 0},
  { "TEMPERATUR_DT2_FUNKTION_EIN"                      , 0x0996, 0},
  { "TEMPERATUR_DT2_FUNKTION_AUS"                      , 0x0997, 0},
  { "WARMLUFTKOLLEKTOR_RAUMSOLL_EINSCHALTTEMP"         , 0x0998, 0},
  { "WARMLUFTKOLLEKTOR_RAUMSOLL_AUSSCHALTTEMP"         , 0x0999, 0},
  { "WARMLUFTKOLLEKTOR_DIFFERENZ_EIN"                  , 0x099a, 0},
  { "WARMLUFTKOLLEKTOR_DIFFERENZ_AUS"                  , 0x099b, 0},
  { "WARMLUFTKOLLEKTOR_THERMOSTAT_EIN"                 , 0x099c, 0},
  { "WARMLUFTKOLLEKTOR_THERMOSTAT_AUS"                 , 0x099d, 0},
  { "WARMLUFTKOLLEKTOR_MAXTEMP"                        , 0x099e, 0},
  { "WARMLUFTKOLLEKTOR_WIEDEREIN_NACH_MAXTEMP"         , 0x099f, 0},
  { "FESTSTOFF_THERMOSTAT"                             , 0x09a0, 0},
  { "FESTSTOFF_THERMOSTAT_AUS"                         , 0x09a1, 0},
  { "FESTSTOFF_DIFFERENZ"                              , 0x09a2, 0},
  { "FESTSTOFF_DIFFERENZ_AUS"                          , 0x09a3, 0},
  { "RUECKLAUFW_DIFFERENZ"                             , 0x09a4, 0},
  { "RUECKLAUFW_DIFFERENZ_AUS"                         , 0x09a5, 0},
  { "UMLADUNG_DIFFERENZ"                               , 0x09a6, 0},
  { "UMLADUNG_DIFFERENZ_AUS"                           , 0x09a7, 0},
  { "UMLADUNG_ZIELSPEICHER_MAXTEMP"                    , 0x09a8, 0},
  { "UMLADUNG_WIEDEREIN_NACH_ZIELSP_MAXTEMP"           , 0x09a9, 0},
  { "WW_NACHHEIZUNG_FREIGABE"                          , 0x09aa, 0},
  { "WMZ_IMPULSRATE_SOLAR"                             , 0x09ab, 0},
  { "WMZ_SOLARMEDIUM"                                  , 0x09ac, 0},
  { "WMZ_KONZENTRATION_SOLARMEDIUM"                    , 0x09ad, 0},
  { "WMZ_MESSUNG_IMPULS"                               , 0x09ae, 0},
  { "WMZ_VOLUMENSTROM_FIX_SOLARPUMPE1"                 , 0x09af, 0},
  { "WMZ_VOLUMENSTROM_FIX_SOLARPUMPE2"                 , 0x09b0, 0},
  { "ZIRKPUMPE_IMPULS_LAUFZEIT"                        , 0x09b1, 0},
  { "ZIRKPUMPE_IMPULS_SPERRZEIT"                       , 0x09b2, 0},
  { "VORRANG_TEST_ZEIT"                                , 0x09b3, 0},
  { "VORRANG_TEST_GRADIENT"                            , 0x09b4, 0},
  { "STRAHLUNGSSENSOR_FUNKTION"                        , 0x09b5, 0},
  { "STRAHLUNGSSENSOR_ABGLEICH"                        , 0x09b6, 0},
  { "SOLAR_KICKPAUSE1"                                 , 0x09b7, 0},
  { "SOLAR_KICKDAUER1"                                 , 0x09b8, 0},
  { "SOLAR_KICKPAUSE2"                                 , 0x09b9, 0},
  { "SOLAR_KICKDAUER2"                                 , 0x09ba, 0},
  { "SOLAR_KICKPROG_EINSCAHLTZEIT"                     , 0x09bb, 0},
  { "SOLAR_KICKPROG_AUSSCHALTZEIT"                     , 0x09bc, 0},
  { "SOLAR_KICK_GRADIENTENZEIT1"                       , 0x09bd, 0},
  { "SOLAR_KICK_GRADIENTENZEIT2"                       , 0x09be, 0},
  { "SOLAR_OST_WEST_KOLLEKTOR"                         , 0x09bf, 0},
  { "SOLAR_DIFFERENZ_KOLLEKTOR1"                       , 0x09c0, 0},
  { "SOLAR_DIFFERENZ_KOLLEKTOR1_AUS"                   , 0x09c1, 0},
  { "SOLAR_DIFFERENZ_KOLLEKTOR2"                       , 0x09c2, 0},
  { "SOLAR_DIFFERENZ_KOLLEKTOR2_AUS"                   , 0x09c3, 0},
  { "SOLAR_THERMOSTAT_KOLLEKTOR1"                      , 0x09c4, 0},
  { "SOLAR_THERMOSTAT_KOLLEKTOR1_AUS"                  , 0x09c5, 0},
  { "SOLAR_THERMOSTAT_KOLLEKTOR2"                      , 0x09c6, 0},
  { "SOLAR_THERMOSTAT_KOLLEKTOR2_AUS"                  , 0x09c7, 0},
  { "SOLAR_KOLLEKTOR1_KUEHL"                           , 0x09c8, 0},
  { "SOLAR_KOLLEKTOR1_KUEHL_AUS"                       , 0x09c9, 0},
  { "SOLAR_KOLLEKTOR2_KUEHL"                           , 0x09ca, 0},
  { "SOLAR_KOLLEKTOR2_KUEHL_AUS"                       , 0x09cb, 0},
  { "SOLAR_KOLLEKTOR1_NOTAUS"                          , 0x09cc, 0},
  { "SOLAR_KOLLEKTOR1_WIEDEREIN_NACH_NOTAUS"           , 0x09cd, 0},
  { "SOLAR_KOLLEKTOR2_NOTAUS"                          , 0x09ce, 0},
  { "SOLAR_KOLLEKTOR2_WIEDEREIN_NACH_NOTAUS"           , 0x09cf, 0},
  { "SOLAR_KOLLEKTOR_KUEHL_SPEICHER_NR"                , 0x09d0, 0},
  { "FEUCHTEREGELUNG_EIN_AUS"                          , 0x09d1, 0},
  { "MIN_SOLL_FEUCHTE"                                 , 0x09d2, 0},
  { "MAX_SOLL_FEUCHTE"                                 , 0x09d3, 0},
  { "MAXTEMP_SPEICHER1"                                , 0x09d4, 0},
  { "MAXTEMP_SPEICHER1_WIEDEREIN"                      , 0x09d5, 0},
  { "MAXTEMP_SPEICHER2"                                , 0x09d6, 0},
  { "MAXTEMP_SPEICHER2_WIEDEREIN"                      , 0x09d7, 0},
  { "MAXTEMP_SPEICHER3"                                , 0x09d8, 0},
  { "MAXTEMP_SPEICHER3_WIEDEREIN"                      , 0x09d9, 0},
  { "MAXTEMP_SPEICHER_KUEHLFUNKTION"                   , 0x09da, 0},
  { "LAUFZEIT_SOLAR_HIGH"                              , 0x09db, 0},
  { "LAUFZEIT_SOLAR2"                                  , 0x09dc, 0},
  { "LAUFZEIT_SOLAR2_HIGH"                             , 0x09dd, 0},
  { "LADEZEIT_SPEICHER"                                , 0x09de, 0},
  { "LADEZEIT_SPEICHER_HIGH"                           , 0x09df, 0},
  { "LADEZEIT_SPEICHER2"                               , 0x09e0, 0},
  { "LADEZEIT_SPEICHER2_HIGH"                          , 0x09e1, 0},
  { "LADEZEIT_SPEICHER3"                               , 0x09e2, 0},
  { "LADEZEIT_SPEICHER3_HIGH"                          , 0x09e3, 0},
  { "PELLET_EIN_AUS"                                   , 0x09e4, 0},
  { "PELLET_PUFFER_LADETEMP"                           , 0x09e5, 0},
  { "PELLET_KUEHLFUNKTION"                             , 0x09e6, 0},
  { "PELLET_KUEHLFUNKTION_SCHALTTEMP"                  , 0x09e7, 0},
  { "PELLET_KUEHLFUNKTION_VORLAUFSOLLTEMP"             , 0x09e8, 0},
  { "MAX_PP_GRADIENTEN_TEMP"                           , 0x09e9, 0},
  { "MAX_PP_GRADIENT"                                  , 0x09ea, 0},
  { "ECO_PUFFERTEMP_ABSOLUT_EIN"                       , 0x09eb, 0},
  { "ECO_PUFFERTEMP_ABSOLUT_AUS"                       , 0x09ec, 0},
  { "WARMLUFTKOLLEKTOR_WW_MAXTEMP"                     , 0x09ed, 0},
  { "WARMLUFTKOLLEKTOR_WW_WIEDEREIN_NACH_MAXTEMP"      , 0x09ee, 0},
  { "SCHWIMMBADREGELUNG_EIN_AUS"                       , 0x09f0, 0},
  { "SOLAR_PLAUSI_FEHLERMELDUNGEN_EIN_AUS"             , 0x09f1, 0},
  { "SPEICHERLADEPUMPE_PWM_SIGNAL"                     , 0x09f2, 0},
  { "AKT_SPERRZEIT"                                    , 0x09f3, 0},
  { "KASKADEN_SCHALTWERT"                              , 0x09f4, 0},
  { "REGELDIFFERENZ"                                   , 0x09f5, 0},
  { "SCHALTHYSTERESE_PUFFER"                           , 0x09f6, 0},
  { "PUFFERUEBERHOEHUNGSDIFF"                          , 0x09f7, 0},
  { "MAX_PUFFERTEMPERATUR"                             , 0x09f8, 0},
  { "MIN_PUFFERTEMPERATUR"                             , 0x09f9, 0},
  { "MAX_SAMMLERTEMPERATUR"                            , 0x09fa, 0},
  { "MIN_SAMMLERTEMPERATUR"                            , 0x09fb, 0},
  { "SAMMLERUEBERHOEHUNGSDIFF"                         , 0x09fc, 0},
  { "ABREGELTEMPERATUR"                                , 0x09fd, 0},
  { "FOLGEWECHSEL_IN_STD"                              , 0x09fe, 0},
  { "SONDERNIVEAU_TEMPERATUR"                          , 0x09ff, 0},
  { "AUSSEN_FROSTTEMP"                                 , 0x0a00, et_dec_val},
  { "BRENNER1LAUFZEIT"                                 , 0x0a02, 0},
  { "BRENNER1STARTS"                                   , 0x0a03, 0},
  { "BRENNER2LAUFZEIT"                                 , 0x0a04, 0},
  { "BRENNER2STARTS"                                   , 0x0a05, 0},
  { "EINSTELL_SPEICHERSOLLTEMP2"                       , 0x0a06, et_dec_val},
  { "STATUS_HK_ANZEIGE"                                , 0x0a07, 0},
  { "UEBERLAUF_BRENNER1LAUFZEIT"                       , 0x0a08, 0},
  { "UEBERLAUF_BRENNER1STARTS"                         , 0x0a09, 0},
  { "UEBERLAUF_BRENNER2LAUFZEIT"                       , 0x0a0a, 0},
  { "UEBERLAUF_BRENNER2STARTS"                         , 0x0a0b, 0},
  { "AUSSENTEMP_MITTEL"                                , 0x0a0c, 0},
  { "KEIN_HEIZBEDARF"                                  , 0x0a0d, 0},
  { "STATUSWAERMEANFORDERUNG"                          , 0x0a0e, 0},
  { "VARIABLER_VERBRAUCHER"                            , 0x0a0f, 0},
  { "CUST_EEPR_TIMEOUT"                                , 0x0a10, 0},
  { "HARDWARE_VERSION"                                 , 0x0a11, 0},
  { "ESTRICH_TAG"                                      , 0x0a12, 0},
  { "ESTRICH_VORLAUFTEMP"                              , 0x0a13, 0},
  { "RAUM_FROSTSCHUTZTEMP"                             , 0x0a14, 0},
  { "SOLL_TEMP_MODE"                                   , 0x0a15, 0},
  { "MERKER_ECO"                                       , 0x0a16, 0},
  { "MERKER_ECO_2"                                     , 0x0a17, 0},
  { "MERKER_SOMMER"                                    , 0x0a18, 0},
  { "WCM_GERAET"                                       , 0x0a19, 0},
  { "AUSSENTEMP_MISCH"                                 , 0x0a1a, 0},
  { "TIMEOUT"                                          , 0x0a1b, 0},
  { "VAR_RAUMTHERMOSTAT"                               , 0x0a1c, 0},
  { "MERKER_RAUMTHERMOSTAT"                            , 0x0a1d, 0},
  { "KESSELLEISTUNG"                                   , 0x0a1e, 0},
  { "ZEITMASTER"                                       , 0x0a1f, 0},
  // ID = 0x180
  // DHC1:            0x0001
  // DHC2:            0x0002
  // WW Ventil:       0x0010
  // Heizkreispumpe:  0x0020
  // Pufferladepunpe: 0x0040
  // Quellenpumpe:    0x0100
  // Kühlen:          0x0200
  { "SAMMEL_RELAISSTATUS"                              , 0x0a20, 0},
  { "PARAMETER_KONFIGURATION"                          , 0x0a21, 0},
  { "EBUS_STROMUEBERSCHUSS"                            , 0x0a22, 0},
  { "MASTERZUGRIFF"                                    , 0x0a23, 0},
  { "EBUS_SPERRZAEHLER"                                , 0x0a24, 0},
  { "FEHLERSTRING"                                     , 0x0a25, 0},
  { "BUSFEHLER"                                        , 0x0a26, 0}, // auf ID 000 abfragen
  { "DIREKT_EINGANG"                                   , 0x0a27, 0},
  { "EINGANG0"                                         , 0x0a28, 0},
  { "EINGANG1"                                         , 0x0a29, 0},
  { "EINGANG2"                                         , 0x0a2a, 0},
  { "EINGANG3"                                         , 0x0a2b, 0},
  { "EINGANG4"                                         , 0x0a2c, 0},
  { "EINGANG5"                                         , 0x0a2d, 0},
  { "EINGANG6"                                         , 0x0a2e, 0},
  { "EINGANG7"                                         , 0x0a2f, 0},
  { "EINGANG8"                                         , 0x0a30, 0},
  { "EINGANG9"                                         , 0x0a31, 0},
  { "EINGANG10"                                        , 0x0a32, 0},
  { "EINGANG11"                                        , 0x0a33, 0},
  { "EINGANG12"                                        , 0x0a34, 0},
  { "EINGANG13"                                        , 0x0a35, 0},
  { "EINGANG14"                                        , 0x0a36, 0},
  { "EINGANG15"                                        , 0x0a37, 0},
  { "EINGANG16"                                        , 0x0a38, 0},
  { "EINGANG17"                                        , 0x0a39, 0},
  { "EINGANG18"                                        , 0x0a3a, 0},
  { "EINGANG19"                                        , 0x0a3b, 0},
  { "EINGANG20"                                        , 0x0a3c, 0},
  { "KONFIG_EINGANG0"                                  , 0x0a5a, 0},
  { "KONFIG_EINGANG1"                                  , 0x0a5b, 0},
  { "KONFIG_EINGANG2"                                  , 0x0a5c, 0},
  { "KONFIG_EINGANG3"                                  , 0x0a5d, 0},
  { "KONFIG_EINGANG4"                                  , 0x0a5e, 0},
  { "KONFIG_EINGANG5"                                  , 0x0a5f, 0},
  { "KONFIG_EINGANG6"                                  , 0x0a60, 0},
  { "KONFIG_EINGANG7"                                  , 0x0a61, 0},
  { "KONFIG_EINGANG8"                                  , 0x0a62, 0},
  { "KONFIG_EINGANG9"                                  , 0x0a63, 0},
  { "KONFIG_EINGANG10"                                 , 0x0a64, 0},
  { "KONFIG_EINGANG11"                                 , 0x0a65, 0},
  { "KONFIG_EINGANG12"                                 , 0x0a66, 0},
  { "KONFIG_EINGANG13"                                 , 0x0a67, 0},
  { "KONFIG_EINGANG14"                                 , 0x0a68, 0},
  { "KONFIG_EINGANG15"                                 , 0x0a69, 0},
  { "KONFIG_EINGANG16"                                 , 0x0a6a, 0},
  { "KONFIG_EINGANG17"                                 , 0x0a6b, 0},
  { "KONFIG_EINGANG18"                                 , 0x0a6c, 0},
  { "KONFIG_EINGANG19"                                 , 0x0a6d, 0},
  { "KONFIG_EINGANG20"                                 , 0x0a6e, 0},
  { "AUSGANG0"                                         , 0x0a8c, 0},
  { "AUSGANG1"                                         , 0x0a8d, 0},
  { "AUSGANG2"                                         , 0x0a8e, 0},
  { "AUSGANG3"                                         , 0x0a8f, 0},
  { "AUSGANG4"                                         , 0x0a90, 0},
  { "AUSGANG5"                                         , 0x0a91, 0},
  { "AUSGANG6"                                         , 0x0a92, 0},
  { "AUSGANG7"                                         , 0x0a93, 0},
  { "AUSGANG8"                                         , 0x0a94, 0},
  { "AUSGANG9"                                         , 0x0a95, 0},
  { "AUSGANG10"                                        , 0x0a96, 0},
  { "AUSGANG11"                                        , 0x0a97, 0},
  { "AUSGANG12"                                        , 0x0a98, 0},
  { "AUSGANG13"                                        , 0x0a99, 0},
  { "AUSGANG14"                                        , 0x0a9a, 0},
  { "AUSGANG15"                                        , 0x0a9b, 0},
  { "AUSGANG16"                                        , 0x0a9c, 0},
  { "AUSGANG17"                                        , 0x0a9d, 0},
  { "AUSGANG18"                                        , 0x0a9e, 0},
  { "AUSGANG19"                                        , 0x0a9f, 0},
  { "AUSGANG20"                                        , 0x0aa0, 0},
  { "KONFIG_AUSGANG0"                                  , 0x0abe, 0},
  { "KONFIG_AUSGANG1"                                  , 0x0abf, 0},
  { "KONFIG_AUSGANG2"                                  , 0x0ac0, 0},
  { "KONFIG_AUSGANG3"                                  , 0x0ac1, 0},
  { "KONFIG_AUSGANG4"                                  , 0x0ac2, 0},
  { "KONFIG_AUSGANG5"                                  , 0x0ac3, 0},
  { "KONFIG_AUSGANG6"                                  , 0x0ac4, 0},
  { "KONFIG_AUSGANG7"                                  , 0x0ac5, 0},
  { "KONFIG_AUSGANG8"                                  , 0x0ac6, 0},
  { "KONFIG_AUSGANG9"                                  , 0x0ac7, 0},
  { "KONFIG_AUSGANG10"                                 , 0x0ac8, 0},
  { "KONFIG_AUSGANG11"                                 , 0x0ac9, 0},
  { "KONFIG_AUSGANG12"                                 , 0x0aca, 0},
  { "KONFIG_AUSGANG13"                                 , 0x0acb, 0},
  { "KONFIG_AUSGANG14"                                 , 0x0acc, 0},
  { "KONFIG_AUSGANG15"                                 , 0x0acd, 0},
  { "KONFIG_AUSGANG16"                                 , 0x0ace, 0},
  { "KONFIG_AUSGANG17"                                 , 0x0acf, 0},
  { "KONFIG_AUSGANG18"                                 , 0x0ad0, 0},
  { "KONFIG_AUSGANG19"                                 , 0x0ad1, 0},
  { "KONFIG_AUSGANG20"                                 , 0x0ad2, 0},
  { "FEHLERFELD_0"                                     , 0x0b00, 0}, // Min
  { "FEHLERFELD_1"                                     , 0x0b01, 0}, // Std
  { "FEHLERFELD_2"                                     , 0x0b02, 0}, // Tag
  { "FEHLERFELD_3"                                     , 0x0b03, 0}, // Monat
  { "FEHLERFELD_4"                                     , 0x0b04, 0}, // Jahr
  { "FEHLERFELD_5"                                     , 0x0b05, et_dev_nr},
  { "FEHLERFELD_6"                                     , 0x0b06, et_err_nr},
  { "FEHLERFELD_7"                                     , 0x0b07, 0},
  { "FEHLERFELD_8"                                     , 0x0b08, 0},
  { "FEHLERFELD_9"                                     , 0x0b09, 0},
  { "FEHLERFELD_10"                                    , 0x0b0a, 0},
  { "FEHLERFELD_11"                                    , 0x0b0b, 0},
  { "FEHLERFELD_12"                                    , 0x0b0c, et_dev_nr},
  { "FEHLERFELD_13"                                    , 0x0b0d, et_err_nr},
  { "FEHLERFELD_14"                                    , 0x0b0e, 0},
  { "FEHLERFELD_15"                                    , 0x0b0f, 0},
  { "FEHLERFELD_16"                                    , 0x0b10, 0},
  { "FEHLERFELD_17"                                    , 0x0b11, 0},
  { "FEHLERFELD_18"                                    , 0x0b12, 0},
  { "FEHLERFELD_19"                                    , 0x0b13, et_dev_nr},
  { "FEHLERFELD_20"                                    , 0x0b14, et_err_nr},
  { "FEHLERFELD_21"                                    , 0x0b15, 0},
  { "FEHLERFELD_22"                                    , 0x0b16, 0},
  { "FEHLERFELD_23"                                    , 0x0b17, 0},
  { "FEHLERFELD_24"                                    , 0x0b18, 0},
  { "FEHLERFELD_25"                                    , 0x0b19, 0},
  { "FEHLERFELD_26"                                    , 0x0b1a, et_dev_nr},
  { "FEHLERFELD_27"                                    , 0x0b1b, et_err_nr},
  { "FEHLERFELD_28"                                    , 0x0b1c, 0},
  { "FEHLERFELD_29"                                    , 0x0b1d, 0},
  { "FEHLERFELD_30"                                    , 0x0b1e, 0},
  { "FEHLERFELD_31"                                    , 0x0b1f, 0},
  { "FEHLERFELD_32"                                    , 0x0b20, 0},
  { "FEHLERFELD_33"                                    , 0x0b21, et_dev_nr},
  { "FEHLERFELD_34"                                    , 0x0b22, et_err_nr},
  { "FEHLERFELD_35"                                    , 0x0b23, 0},
  { "FEHLERFELD_36"                                    , 0x0b24, 0},
  { "FEHLERFELD_37"                                    , 0x0b25, 0},
  { "FEHLERFELD_38"                                    , 0x0b26, 0},
  { "FEHLERFELD_39"                                    , 0x0b27, 0},
  { "FEHLERFELD_40"                                    , 0x0b28, et_dev_nr},
  { "FEHLERFELD_41"                                    , 0x0b29, et_err_nr},
  { "FEHLERFELD_42"                                    , 0x0b2a, 0},
  { "FEHLERFELD_43"                                    , 0x0b2b, 0},
  { "FEHLERFELD_44"                                    , 0x0b2c, 0},
  { "FEHLERFELD_45"                                    , 0x0b2d, 0},
  { "FEHLERFELD_46"                                    , 0x0b2e, 0},
  { "FEHLERFELD_47"                                    , 0x0b2f, et_dev_nr},
  { "FEHLERFELD_48"                                    , 0x0b30, et_err_nr},
  { "FEHLERFELD_49"                                    , 0x0b31, 0},
  { "FEHLERFELD_50"                                    , 0x0b32, 0},
  { "FEHLERFELD_51"                                    , 0x0b33, 0},
  { "FEHLERFELD_52"                                    , 0x0b34, 0},
  { "FEHLERFELD_53"                                    , 0x0b35, 0},
  { "FEHLERFELD_54"                                    , 0x0b36, et_dev_nr},
  { "FEHLERFELD_55"                                    , 0x0b37, et_err_nr},
  { "FEHLERFELD_56"                                    , 0x0b38, 0},
  { "FEHLERFELD_57"                                    , 0x0b39, 0},
  { "FEHLERFELD_58"                                    , 0x0b3a, 0},
  { "FEHLERFELD_59"                                    , 0x0b3b, 0},
  { "FEHLERFELD_60"                                    , 0x0b3c, 0},
  { "FEHLERFELD_61"                                    , 0x0b3d, et_dev_nr},
  { "FEHLERFELD_62"                                    , 0x0b3e, et_err_nr},
  { "FEHLERFELD_63"                                    , 0x0b3f, 0},
  { "FEHLERFELD_64"                                    , 0x0b40, 0},
  { "FEHLERFELD_65"                                    , 0x0b41, 0},
  { "FEHLERFELD_66"                                    , 0x0b42, 0},
  { "FEHLERFELD_67"                                    , 0x0b43, 0},
  { "FEHLERFELD_68"                                    , 0x0b44, et_dev_nr},
  { "FEHLERFELD_69"                                    , 0x0b45, et_err_nr},
  { "FEHLERFELD_70"                                    , 0x0b46, 0},
  { "FEHLERFELD_71"                                    , 0x0b47, 0},
  { "FEHLERFELD_72"                                    , 0x0b48, 0},
  { "FEHLERFELD_73"                                    , 0x0b49, 0},
  { "FEHLERFELD_74"                                    , 0x0b4a, 0},
  { "FEHLERFELD_75"                                    , 0x0b4b, et_dev_nr},
  { "FEHLERFELD_76"                                    , 0x0b4c, et_err_nr},
  { "FEHLERFELD_77"                                    , 0x0b4d, 0},
  { "FEHLERFELD_78"                                    , 0x0b4e, 0},
  { "FEHLERFELD_79"                                    , 0x0b4f, 0},
  { "FEHLERFELD_80"                                    , 0x0b50, 0},
  { "FEHLERFELD_81"                                    , 0x0b51, 0},
  { "FEHLERFELD_82"                                    , 0x0b52, et_dev_nr},
  { "FEHLERFELD_83"                                    , 0x0b53, et_err_nr},
  { "FEHLERFELD_84"                                    , 0x0b54, 0},
  { "FEHLERFELD_85"                                    , 0x0b55, 0},
  { "FEHLERFELD_86"                                    , 0x0b56, 0},
  { "FEHLERFELD_87"                                    , 0x0b57, 0},
  { "FEHLERFELD_88"                                    , 0x0b58, 0},
  { "FEHLERFELD_89"                                    , 0x0b59, et_dev_nr},
  { "FEHLERFELD_90"                                    , 0x0b5a, et_err_nr},
  { "FEHLERFELD_91"                                    , 0x0b5b, 0},
  { "FEHLERFELD_92"                                    , 0x0b5c, 0},
  { "FEHLERFELD_93"                                    , 0x0b5d, 0},
  { "FEHLERFELD_94"                                    , 0x0b5e, 0},
  { "FEHLERFELD_95"                                    , 0x0b5f, 0},
  { "FEHLERFELD_96"                                    , 0x0b60, et_dev_nr},
  { "FEHLERFELD_97"                                    , 0x0b61, et_err_nr},
  { "FEHLERFELD_98"                                    , 0x0b62, 0},
  { "FEHLERFELD_99"                                    , 0x0b63, 0},
  { "FEHLERFELD_100"                                   , 0x0b64, 0},
  { "FEHLERFELD_101"                                   , 0x0b65, 0},
  { "FEHLERFELD_102"                                   , 0x0b66, 0},
  { "FEHLERFELD_103"                                   , 0x0b67, et_dev_nr},
  { "FEHLERFELD_104"                                   , 0x0b68, et_err_nr},
  { "FEHLERFELD_105"                                   , 0x0b69, 0},
  { "FEHLERFELD_106"                                   , 0x0b6a, 0},
  { "FEHLERFELD_107"                                   , 0x0b6b, 0},
  { "FEHLERFELD_108"                                   , 0x0b6c, 0},
  { "FEHLERFELD_109"                                   , 0x0b6d, 0},
  { "FEHLERFELD_110"                                   , 0x0b6e, et_dev_nr},
  { "FEHLERFELD_111"                                   , 0x0b6f, et_err_nr},
  { "FEHLERFELD_112"                                   , 0x0b70, 0},
  { "FEHLERFELD_113"                                   , 0x0b71, 0},
  { "FEHLERFELD_114"                                   , 0x0b72, 0},
  { "FEHLERFELD_115"                                   , 0x0b73, 0},
  { "FEHLERFELD_116"                                   , 0x0b74, 0},
  { "FEHLERFELD_117"                                   , 0x0b75, et_dev_nr},
  { "FEHLERFELD_118"                                   , 0x0b76, et_err_nr},
  { "FEHLERFELD_119"                                   , 0x0b77, 0},
  { "FEHLERFELD_120"                                   , 0x0b78, 0},
  { "FEHLERFELD_121"                                   , 0x0b79, 0},
  { "FEHLERFELD_122"                                   , 0x0b7a, 0},
  { "FEHLERFELD_123"                                   , 0x0b7b, 0},
  { "FEHLERFELD_124"                                   , 0x0b7c, et_dev_nr},
  { "FEHLERFELD_125"                                   , 0x0b7d, et_err_nr},
  { "FEHLERFELD_126"                                   , 0x0b7e, 0},
  { "FEHLERFELD_127"                                   , 0x0b7f, 0},
  { "FEHLERFELD_128"                                   , 0x0b80, 0},
  { "FEHLERFELD_129"                                   , 0x0b81, 0},
  { "FEHLERFELD_130"                                   , 0x0b82, 0},
  { "FEHLERFELD_131"                                   , 0x0b83, et_dev_nr},
  { "FEHLERFELD_132"                                   , 0x0b84, et_err_nr},
  { "FEHLERFELD_133"                                   , 0x0b85, 0},
  { "FEHLERFELD_134"                                   , 0x0b86, 0},
  { "FEHLERFELD_135"                                   , 0x0b87, 0},
  { "FEHLERFELD_136"                                   , 0x0b88, 0},
  { "FEHLERFELD_137"                                   , 0x0b89, 0},
  { "FEHLERFELD_138"                                   , 0x0b8a, et_dev_nr},
  { "FEHLERFELD_139"                                   , 0x0b8b, et_err_nr},
  { "FEHLERSPEICHER_FELDINDEX"                         , 0x0b9a, 0},
  { "FEHLERSPEICHER_FEHLERNUMMER"                      , 0x0b9b, 0},
  { "FEHLERSPEICHER_MODULTYD"                          , 0x0b9c, 0},
  { "FEHLERSPEICHER_BUSKENNUNG"                        , 0x0b9d, 0},
  { "FEHLERSPEICHER_SEKUNDE"                           , 0x0b9e, 0},
  { "FEHLERSPEICHER_MINUTE"                            , 0x0b9f, 0},
  { "FEHLERSPEICHER_STUNDE"                            , 0x0ba0, 0},
  { "FEHLERSPEICHER_TAG"                               , 0x0ba1, 0},
  { "FEHLERSPEICHER_MONAT"                             , 0x0ba2, 0},
  { "FEHLERSPEICHER_JAHR"                              , 0x0ba3, 0},
  { "ESTRICHPROGRAMM_TAG_1"                            , 0x0bb9, 0},
  { "ESTRICHPROGRAMM_TAG_2"                            , 0x0bba, 0},
  { "ESTRICHPROGRAMM_TAG_3"                            , 0x0bbb, 0},
  { "ESTRICHPROGRAMM_TAG_4"                            , 0x0bbc, 0},
  { "ESTRICHPROGRAMM_TAG_5"                            , 0x0bbd, 0},
  { "ESTRICHPROGRAMM_TAG_6"                            , 0x0bbe, 0},
  { "ESTRICHPROGRAMM_TAG_7"                            , 0x0bbf, 0},
  { "ESTRICHPROGRAMM_TAG_8"                            , 0x0bc0, 0},
  { "ESTRICHPROGRAMM_TAG_9"                            , 0x0bc1, 0},
  { "ESTRICHPROGRAMM_TAG_10"                           , 0x0bc2, 0},
  { "ESTRICHPROGRAMM_TAG_11"                           , 0x0bc3, 0},
  { "ESTRICHPROGRAMM_TAG_12"                           , 0x0bc4, 0},
  { "ESTRICHPROGRAMM_TAG_13"                           , 0x0bc5, 0},
  { "ESTRICHPROGRAMM_TAG_14"                           , 0x0bc6, 0},
  { "ESTRICHPROGRAMM_TAG_15"                           , 0x0bc7, 0},
  { "ESTRICHPROGRAMM_TAG_16"                           , 0x0bc8, 0},
  { "ESTRICHPROGRAMM_TAG_17"                           , 0x0bc9, 0},
  { "ESTRICHPROGRAMM_TAG_18"                           , 0x0bca, 0},
  { "ESTRICHPROGRAMM_TAG_19"                           , 0x0bcb, 0},
  { "ESTRICHPROGRAMM_TAG_20"                           , 0x0bcc, 0},
  { "ESTRICHPROGRAMM_TAG_21"                           , 0x0bcd, 0},
  { "ESTRICHPROGRAMM_TAG_22"                           , 0x0bce, 0},
  { "ESTRICHPROGRAMM_TAG_23"                           , 0x0bcf, 0},
  { "ESTRICHPROGRAMM_TAG_24"                           , 0x0bd0, 0},
  { "ESTRICHPROGRAMM_TAG_25"                           , 0x0bd1, 0},
  { "ESTRICHPROGRAMM_TAG_26"                           , 0x0bd2, 0},
  { "ESTRICHPROGRAMM_TAG_27"                           , 0x0bd3, 0},
  { "ESTRICHPROGRAMM_TAG_28"                           , 0x0bd4, 0},
  { "ESTRICHPROGRAMM_TAG_29"                           , 0x0bd5, 0},
  { "ESTRICHPROGRAMM_TAG_30"                           , 0x0bd6, 0},
  { "ESTRICHPROGRAMM_TAG_31"                           , 0x0bd7, 0},
  { "OT_REQUEST_CODE"                                  , 0x0be9, 0},
  { "OT_FHB_00"                                        , 0x0bea, 0},
  { "OT_FHB_01"                                        , 0x0beb, 0},
  { "OT_FHB_02"                                        , 0x0bec, 0},
  { "OT_FHB_03"                                        , 0x0bed, 0},
  { "OT_FHB_04"                                        , 0x0bee, 0},
  { "OT_FHB_05"                                        , 0x0bef, 0},
  { "OT_FHB_06"                                        , 0x0bf0, 0},
  { "OT_FHB_07"                                        , 0x0bf1, 0},
  { "OT_FHB_08"                                        , 0x0bf2, 0},
  { "OT_FHB_09"                                        , 0x0bf3, 0},
  { "START_BEREICH_INFONUMMERN_OS"                     , 0x0c1c, 0},
  { "FERNSTEUERBETRIEB_TEMPERATURSOLLWERT"             , 0x0c1d, 0},
  { "ESTB_ISTTEMPERATUR"                               , 0x0c1e, 0},
  { "FESTWERT_HEIZUNGSBETRIEB"                         , 0x0c1f, 0},
  { "AUSSENFUEHLERKORREKTURWERT"                       , 0x0c20, 0},
  { "HZK_PUMPE_DAUERLAUF"                              , 0x0c21, 0},
  { "PWM_PUMPENMODE"                                   , 0x0c22, 0},
  { "PWM_TEMPERATURDIFFERENZREGELUNG_TV_TWEICHE"       , 0x0c23, 0},
  { "PWM_TEMPERATURDIFFERENZREGELUNG_TV_TR"            , 0x0c24, 0},
  { "WARTUNGSINTERVAL_STUNDEN"                         , 0x0c25, 0},
  { "PRUEFSTANDSBEFEHL"                                , 0x1324, 0},
  { "ENDE_BEREICH_INFONUMMERN_OS"                      , 0x1325, 0},
  { "SOLAR_KOLLEKTOR_1_P_ANTEIL"                       , 0x1326, 0},
  { "SOLAR_KOLLEKTOR_1_I_ANTEIL"                       , 0x1327, 0},
  { "SOLAR_KOLLEKTOR_2_P_ANTEIL"                       , 0x1328, 0},
  { "SOLAR_KOLLEKTOR_2_I_ANTEIL"                       , 0x1329, 0},
  { "SOLAR_KOLLEKTOR_3_P_ANTEIL"                       , 0x132a, 0},
  { "SOLAR_KOLLEKTOR_3_I_ANTEIL"                       , 0x1388, 0},
  { "FEHLERNUMMER"                                     , 0x1389, 0},
  { "REPEAT_MESSAGE_ALL_24H"                           , 0x1389, 0},
  { "LARGE_STATUS_AUSGANG"                             , 0x13b5, 0},
  { "LARGE_KONFIGURATION_AUSGANG"                      , 0x13b6, 0},
  { "LARGE_INFO_AN_BEI_AUSGANG"                        , 0x13b7, 0},
  { "LARGE_SONDERFUNKTIONEN_AUSGANG"                   , 0x13b8, 0},
  { "LARGE_KONFIGURATION_EINGANG"                      , 0x13b9, 0},
  { "LARGE_FAKTOR_EINGANG"                             , 0x13ba, 0},
  { "LARGE_EINHEIT_EINGANG"                            , 0x13bb, 0},
  { "LARGE_KONTAKT_GESCHLOSSEN_EINGANG"                , 0x13bc, 0},
  { "LARGE_INFO_AN_BEI_EINGANG"                        , 0x13bd, 0},
  { "LARGE_SMS_ZUSATZTEXT_EINGANG"                     , 0x13be, 0},
  { "LARGE_USERNAMER"                                  , 0x13bf, 0},
  { "LARGE_USERPASSWORD"                               , 0x13c0, 0},
  { "LARGE_USERGROUP"                                  , 0x13c1, 0},
  { "LARGE_STATUS_EINGANG"                             , 0x13c2, 0},
  { "LARGE_RESET_COUNTER_EINGANG"                      , 0x13c3, 0},
  { "LARGE_SMTP_SERVER"                                , 0x13c4, 0},
  { "LARGE_SMTP_LOGINNAME"                             , 0x13c5, 0},
  { "LARGE_SMTP_PASSWORT"                              , 0x13c6, 0},
  { "LARGE_POP3_SERVER"                                , 0x13c7, 0},
  { "LARGE_POP3_LOGINNAME"                             , 0x13c8, 0},
  { "LARGE_POP3_PASSWORT"                              , 0x13c9, 0},
  { "LARGE_SMS_TEXT_ADRESSE"                           , 0x13ca, 0},
  { "LARGE_EMPFAEGER_KONTAKTDATEN_NAME"                , 0x13cc, 0},
  { "LARGE_EMPFAEGER_KONTAKTDATEN_RUFNUMMER"           , 0x13cd, 0},
  { "LARGE_EMPFAEGER_KONTAKTDATEN_EMAIL"               , 0x13ce, 0},
  { "LARGE_UEBERTRAGUNGSWEG"                           , 0x13cf, 0},
  { "LARGE_TEST_NACHRICHT_SENDEN"                      , 0x13d0, 0},
  { "GSM_SIGNAL_POWER"                                 , 0x13d1, 0},
  { "GSM_CONNECTION_STATE"                             , 0x13d2, 0},
  { "GSM_SWITCH_OFF"                                   , 0x13d3, 0},
  { "GSM_PIN"                                          , 0x13d4, 0},
  { "GSM_PIN_OFF"                                      , 0x13d5, 0},
  { "LARGE_ACCESSPOINT"                                , 0x13d6, 0},
  { "LARGE_SMS_ADRESSTEXT"                             , 0x13d7, 0},
  { "SMS_24h_REPEAT"                                   , 0x13d8, 0},
  { "LARGE_ALARM_KONFIGURATION_1"                      , 0x13d9, 0},
  { "LARGE_ALARM_KONFIGURATION_2"                      , 0x13da, 0},
  { "LARGE_ALARM_KONFIGURATION_3"                      , 0x13db, 0},
  { "LARGE_ALARM_KONFIGURATION_4"                      , 0x13dc, 0},
  { "LARGE_ALARM_KONFIGURATION_5"                      , 0x13dd, 0},
  { "IP_MODE"                                          , 0x13de, 0},
  { "LARGE_IP_ADRESS"                                  , 0x13df, 0},
  { "LARGE_SUBNET"                                     , 0x13e0, 0},
  { "LARGE_GATEWAY"                                    , 0x13e1, 0},
  { "LARGE_DEVICENAME"                                 , 0x13e2, 0},
  { "LARGE_MAC_ADR"                                    , 0x13e3, 0},
  { "BUS_STATUS"                                       , 0x13e4, 0},
  { "LARGE_EWI_FILTER"                                 , 0x13e5, 0},
  { "LARGE_ERRORLOGDATA"                               , 0x13e6, 0},
  { "KEEP_ALIVE"                                       , 0x13e7, 0},
  { "LARGE_ERRORLOG_DATA"                              , 0x13e8, 0},
  { "LARGE_EWI_FILTER_CONFIG"                          , 0x13e9, 0},
  { "LARGE_COCO_CONFIG_PARAMETER"                      , 0x13ea, 0},
  { "LARGE_DATALOGGER_DATA"                            , 0x13eb, 0},
  { "LARGE_DATALOGGER_DATA_POINTER"                    , 0x13ec, 0},
  { "WE3_TYP"                                          , 0x13ed, 0},
  { "WE4_TYP"                                          , 0x13ee, 0},
  { "SCAN_AKTIV"                                       , 0x13ef, 0},
  { "RUECKLAUFISTTEMP_GES"                             , 0x13f0, 0},
  { "SOLARNUTZUNG"                                     , 0x13f1, 0},
  { "MAX_MODGRAD_WW"                                   , 0x13f2, 0},
  { "ZIRKPUMPE_BEI_ANTILEG"                            , 0x13f3, 0},
  { "LARGE_USB_CONF_TCP_IP"                            , 0x13f4, 0},
  { "LARGE_USB_CONF_TCP_IP_INDEX"                      , 0x13f5, 0},
  { "MAC_ADR_0"                                        , 0x13f6, 0},
  { "MAC_ADR_1"                                        , 0x13f7, 0},
  { "MAC_ADR_2"                                        , 0x13f8, 0},
  { "MAC_ADR_3"                                        , 0x13f9, 0},
  { "MAC_ADR_4"                                        , 0x13fa, 0},
  { "MAC_ADR_5"                                        , 0x13fb, 0},
  { "CELSIUS_FAHRENHEIT_UMSCH"                         , 0x13fc, 0},
  { "WP_VERZOEGERUNG"                                  , 0x13fd, 0},
  { "MAX_RL_KUEHLEN"                                   , 0x13fe, 0},
  { "LARGE_DATALOGGER_HEADER"                          , 0x13ff, 0},
  { "HEIZPROG_1"                                       , 0x1400, 0},
  // pro Tag sind 3 Bereiche moeglich
  // Anfang und Ende sind je mit einem Byte in 15 Min.-Schritten definiert
  // ungenutzte Bereiche enthalten 0x8080
  { "HEIZPROG_1_MO"                                    , 0x1410, et_time_domain},
  { "HEIZPROG_1_MO_SCHALT_2"                           , 0x1411, et_time_domain},
  { "HEIZPROG_1_MO_SCHALT_3"                           , 0x1412, et_time_domain},
  { "HEIZPROG_1_DI"                                    , 0x1420, et_time_domain},
  { "HEIZPROG_1_DI_SCHALT_2"                           , 0x1421, et_time_domain},
  { "HEIZPROG_1_DI_SCHALT_3"                           , 0x1422, et_time_domain},
  { "HEIZPROG_1_MI"                                    , 0x1430, et_time_domain},
  { "HEIZPROG_1_MI_SCHALT_2"                           , 0x1431, et_time_domain},
  { "HEIZPROG_1_MI_SCHALT_3"                           , 0x1432, et_time_domain},
  { "HEIZPROG_1_DO"                                    , 0x1440, et_time_domain},
  { "HEIZPROG_1_DO_SCHALT_2"                           , 0x1441, et_time_domain},
  { "HEIZPROG_1_DO_SCHALT_3"                           , 0x1442, et_time_domain},
  { "HEIZPROG_1_FR"                                    , 0x1450, et_time_domain},
  { "HEIZPROG_1_FR_SCHALT_2"                           , 0x1451, et_time_domain},
  { "HEIZPROG_1_FR_SCHALT_3"                           , 0x1452, et_time_domain},
  { "HEIZPROG_1_SA"                                    , 0x1460, et_time_domain},
  { "HEIZPROG_1_SA_SCHALT_2"                           , 0x1461, et_time_domain},
  { "HEIZPROG_1_SA_SCHALT_3"                           , 0x1462, et_time_domain},
  { "HEIZPROG_1_SO"                                    , 0x1470, et_time_domain},
  { "HEIZPROG_1_SO_SCHALT_2"                           , 0x1471, et_time_domain},
  { "HEIZPROG_1_SO_SCHALT_3"                           , 0x1472, et_time_domain},
  { "HEIZPROG_1_MO_FR"                                 , 0x1480, 0},
  { "HEIZPROG_1_MO_FR_SCHALT_2"                        , 0x1481, 0},
  { "HEIZPROG_1_MO_FR_SCHALT_3"                        , 0x1482, 0},
  { "HEIZPROG_1_SA_SO"                                 , 0x1490, 0},
  { "HEIZPROG_1_SA_SO_SCHALT_2"                        , 0x1491, 0},
  { "HEIZPROG_1_SA_SO_SCHALT_3"                        , 0x1492, 0},
  { "HEIZPROG_1_MO_SO"                                 , 0x14a0, 0},
  { "HEIZPROG_1_MO_SO_SCHALT_2"                        , 0x14a1, 0},
  { "HEIZPROG_1_MO_SO_SCHALT_3"                        , 0x14a2, 0},
  { "HEIZPROG_1_MO_DO"                                 , 0x14b0, 0},
  { "HEIZPROG_1_MO_DO_SCHALT_2"                        , 0x14b1, 0},
  { "HEIZPROG_1_MO_DO_SCHALT_3"                        , 0x14b2, 0},
  { "HEIZPROG_2"                                       , 0x1500, 0},
  { "HEIZPROG_2_MO"                                    , 0x1510, et_time_domain},
  { "HEIZPROG_2_MO_SCHALT_2"                           , 0x1511, et_time_domain},
  { "HEIZPROG_2_MO_SCHALT_3"                           , 0x1512, et_time_domain},
  { "HEIZPROG_2_DI"                                    , 0x1520, et_time_domain},
  { "HEIZPROG_2_DI_SCHALT_2"                           , 0x1521, et_time_domain},
  { "HEIZPROG_2_DI_SCHALT_3"                           , 0x1522, et_time_domain},
  { "HEIZPROG_2_MI"                                    , 0x1530, et_time_domain},
  { "HEIZPROG_2_MI_SCHALT_2"                           , 0x1531, et_time_domain},
  { "HEIZPROG_2_MI_SCHALT_3"                           , 0x1532, et_time_domain},
  { "HEIZPROG_2_DO"                                    , 0x1540, et_time_domain},
  { "HEIZPROG_2_DO_SCHALT_2"                           , 0x1541, et_time_domain},
  { "HEIZPROG_2_DO_SCHALT_3"                           , 0x1542, et_time_domain},
  { "HEIZPROG_2_FR"                                    , 0x1550, et_time_domain},
  { "HEIZPROG_2_FR_SCHALT_2"                           , 0x1551, et_time_domain},
  { "HEIZPROG_2_FR_SCHALT_3"                           , 0x1552, et_time_domain},
  { "HEIZPROG_2_SA"                                    , 0x1560, et_time_domain},
  { "HEIZPROG_2_SA_SCHALT_2"                           , 0x1561, et_time_domain},
  { "HEIZPROG_2_SA_SCHALT_3"                           , 0x1562, et_time_domain},
  { "HEIZPROG_2_SO"                                    , 0x1570, et_time_domain},
  { "HEIZPROG_2_SO_SCHALT_2"                           , 0x1571, et_time_domain},
  { "HEIZPROG_2_SO_SCHALT_3"                           , 0x1572, et_time_domain},
  { "HEIZPROG_2_MO_FR"                                 , 0x1580, 0},
  { "HEIZPROG_2_MO_FR_SCHALT_2"                        , 0x1581, 0},
  { "HEIZPROG_2_MO_FR_SCHALT_3"                        , 0x1582, 0},
  { "HEIZPROG_2_SA_SO"                                 , 0x1590, 0},
  { "HEIZPROG_2_SA_SO_SCHALT_2"                        , 0x1591, 0},
  { "HEIZPROG_2_SA_SO_SCHALT_3"                        , 0x1592, 0},
  { "HEIZPROG_2_MO_SO"                                 , 0x15a0, 0},
  { "HEIZPROG_2_MO_SO_SCHALT_2"                        , 0x15a1, 0},
  { "HEIZPROG_2_MO_SO_SCHALT_3"                        , 0x15a2, 0},
  { "HEIZPROG_2_MO_DO"                                 , 0x15b0, 0},
  { "HEIZPROG_2_MO_DO_SCHALT_2"                        , 0x15b1, 0},
  { "HEIZPROG_2_MO_DO_SCHALT_3"                        , 0x15b2, 0},
  { "HEIZPROG_3"                                       , 0x1600, 0},
  { "HEIZPROG_3_MO"                                    , 0x1610, et_time_domain},
  { "HEIZPROG_3_MO_SCHALT_2"                           , 0x1611, et_time_domain},
  { "HEIZPROG_3_MO_SCHALT_3"                           , 0x1612, et_time_domain},
  { "HEIZPROG_3_DI"                                    , 0x1620, et_time_domain},
  { "HEIZPROG_3_DI_SCHALT_2"                           , 0x1621, et_time_domain},
  { "HEIZPROG_3_DI_SCHALT_3"                           , 0x1622, et_time_domain},
  { "HEIZPROG_3_MI"                                    , 0x1630, et_time_domain},
  { "HEIZPROG_3_MI_SCHALT_2"                           , 0x1631, et_time_domain},
  { "HEIZPROG_3_MI_SCHALT_3"                           , 0x1632, et_time_domain},
  { "HEIZPROG_3_DO"                                    , 0x1640, et_time_domain},
  { "HEIZPROG_3_DO_SCHALT_2"                           , 0x1641, et_time_domain},
  { "HEIZPROG_3_DO_SCHALT_3"                           , 0x1642, et_time_domain},
  { "HEIZPROG_3_FR"                                    , 0x1650, et_time_domain},
  { "HEIZPROG_3_FR_SCHALT_2"                           , 0x1651, et_time_domain},
  { "HEIZPROG_3_FR_SCHALT_3"                           , 0x1652, et_time_domain},
  { "HEIZPROG_3_SA"                                    , 0x1660, et_time_domain},
  { "HEIZPROG_3_SA_SCHALT_2"                           , 0x1661, et_time_domain},
  { "HEIZPROG_3_SA_SCHALT_3"                           , 0x1662, et_time_domain},
  { "HEIZPROG_3_SO"                                    , 0x1670, et_time_domain},
  { "HEIZPROG_3_SO_SCHALT_2"                           , 0x1671, et_time_domain},
  { "HEIZPROG_3_SO_SCHALT_3"                           , 0x1672, et_time_domain},
  { "HEIZPROG_3_MO_FR"                                 , 0x1680, 0},
  { "HEIZPROG_3_MO_FR_SCHALT_2"                        , 0x1681, 0},
  { "HEIZPROG_3_MO_FR_SCHALT_3"                        , 0x1682, 0},
  { "HEIZPROG_3_SA_SO"                                 , 0x1690, 0},
  { "HEIZPROG_3_SA_SO_SCHALT_2"                        , 0x1691, 0},
  { "HEIZPROG_3_SA_SO_SCHALT_3"                        , 0x1692, 0},
  { "HEIZPROG_3_MO_SO"                                 , 0x16a0, 0},
  { "HEIZPROG_3_MO_SO_SCHALT_2"                        , 0x16a1, 0},
  { "HEIZPROG_3_MO_SO_SCHALT_3"                        , 0x16a2, 0},
  { "HEIZPROG_3_MO_DO"                                 , 0x16b0, 0},
  { "HEIZPROG_3_MO_DO_SCHALT_2"                        , 0x16b1, 0},
  { "HEIZPROG_3_MO_DO_SCHALT_3"                        , 0x16b2, 0},
  { "W_WASSERPROG_1"                                   , 0x1700, 0},
  { "W_WASSERPROG_1_MO"                                , 0x1710, et_time_domain},
  { "W_WASSERPROG_1_MO_SCHALT_2"                       , 0x1711, et_time_domain},
  { "W_WASSERPROG_1_MO_SCHALT_3"                       , 0x1712, et_time_domain},
  { "W_WASSERPROG_1_DI"                                , 0x1720, et_time_domain},
  { "W_WASSERPROG_1_DI_SCHALT_2"                       , 0x1721, et_time_domain},
  { "W_WASSERPROG_1_DI_SCHALT_3"                       , 0x1722, et_time_domain},
  { "W_WASSERPROG_1_MI"                                , 0x1730, et_time_domain},
  { "W_WASSERPROG_1_MI_SCHALT_2"                       , 0x1731, et_time_domain},
  { "W_WASSERPROG_1_MI_SCHALT_3"                       , 0x1732, et_time_domain},
  { "W_WASSERPROG_1_DO"                                , 0x1740, et_time_domain},
  { "W_WASSERPROG_1_DO_SCHALT_2"                       , 0x1741, et_time_domain},
  { "W_WASSERPROG_1_DO_SCHALT_3"                       , 0x1742, et_time_domain},
  { "W_WASSERPROG_1_FR"                                , 0x1750, et_time_domain},
  { "W_WASSERPROG_1_FR_SCHALT_2"                       , 0x1751, et_time_domain},
  { "W_WASSERPROG_1_FR_SCHALT_3"                       , 0x1752, et_time_domain},
  { "W_WASSERPROG_1_SA"                                , 0x1760, et_time_domain},
  { "W_WASSERPROG_1_SA_SCHALT_2"                       , 0x1761, et_time_domain},
  { "W_WASSERPROG_1_SA_SCHALT_3"                       , 0x1762, et_time_domain},
  { "W_WASSERPROG_1_SO"                                , 0x1770, et_time_domain},
  { "W_WASSERPROG_1_SO_SCHALT_2"                       , 0x1771, et_time_domain},
  { "W_WASSERPROG_1_SO_SCHALT_3"                       , 0x1772, et_time_domain},
  { "W_WASSERPROG_1_MO_FR"                             , 0x1780, 0},
  { "W_WASSERPROG_1_MO_FR_SCHALT_2"                    , 0x1781, 0},
  { "W_WASSERPROG_1_MO_FR_SCHALT_3"                    , 0x1782, 0},
  { "W_WASSERPROG_1_SA_SO"                             , 0x1790, 0},
  { "W_WASSERPROG_1_SA_SO_SCHALT_2"                    , 0x1791, 0},
  { "W_WASSERPROG_1_SA_SO_SCHALT_3"                    , 0x1792, 0},
  { "W_WASSERPROG_1_MO_SO"                             , 0x17a0, 0},
  { "W_WASSERPROG_1_MO_SO_SCHALT_2"                    , 0x17a1, 0},
  { "W_WASSERPROG_1_MO_SO_SCHALT_3"                    , 0x17a2, 0},
  { "W_WASSERPROG_1_MO_DO"                             , 0x17b0, 0},
  { "W_WASSERPROG_1_MO_DO_SCHALT_2"                    , 0x17b1, 0},
  { "W_WASSERPROG_1_MO_DO_SCHALT_3"                    , 0x17b2, 0},
  { "W_WASSERPROG_2"                                   , 0x1800, 0},
  { "W_WASSERPROG_2_MO"                                , 0x1810, et_time_domain},
  { "W_WASSERPROG_2_MO_SCHALT_2"                       , 0x1811, et_time_domain},
  { "W_WASSERPROG_2_MO_SCHALT_3"                       , 0x1812, et_time_domain},
  { "W_WASSERPROG_2_DI"                                , 0x1820, et_time_domain},
  { "W_WASSERPROG_2_DI_SCHALT_2"                       , 0x1821, et_time_domain},
  { "W_WASSERPROG_2_DI_SCHALT_3"                       , 0x1822, et_time_domain},
  { "W_WASSERPROG_2_MI"                                , 0x1830, et_time_domain},
  { "W_WASSERPROG_2_MI_SCHALT_2"                       , 0x1831, et_time_domain},
  { "W_WASSERPROG_2_MI_SCHALT_3"                       , 0x1832, et_time_domain},
  { "W_WASSERPROG_2_DO"                                , 0x1840, et_time_domain},
  { "W_WASSERPROG_2_DO_SCHALT_2"                       , 0x1841, et_time_domain},
  { "W_WASSERPROG_2_DO_SCHALT_3"                       , 0x1842, et_time_domain},
  { "W_WASSERPROG_2_FR"                                , 0x1850, et_time_domain},
  { "W_WASSERPROG_2_FR_SCHALT_2"                       , 0x1851, et_time_domain},
  { "W_WASSERPROG_2_FR_SCHALT_3"                       , 0x1852, et_time_domain},
  { "W_WASSERPROG_2_SA"                                , 0x1860, et_time_domain},
  { "W_WASSERPROG_2_SA_SCHALT_2"                       , 0x1861, et_time_domain},
  { "W_WASSERPROG_2_SA_SCHALT_3"                       , 0x1862, et_time_domain},
  { "W_WASSERPROG_2_SO"                                , 0x1870, et_time_domain},
  { "W_WASSERPROG_2_SO_SCHALT_2"                       , 0x1871, et_time_domain},
  { "W_WASSERPROG_2_SO_SCHALT_3"                       , 0x1872, et_time_domain},
  { "W_WASSERPROG_2_MO_FR"                             , 0x1880, 0},
  { "W_WASSERPROG_2_MO_FR_SCHALT_2"                    , 0x1881, 0},
  { "W_WASSERPROG_2_MO_FR_SCHALT_3"                    , 0x1882, 0},
  { "W_WASSERPROG_2_SA_SO"                             , 0x1890, 0},
  { "W_WASSERPROG_2_SA_SO_SCHALT_2"                    , 0x1891, 0},
  { "W_WASSERPROG_2_SA_SO_SCHALT_3"                    , 0x1892, 0},
  { "W_WASSERPROG_2_MO_SO"                             , 0x18a0, 0},
  { "W_WASSERPROG_2_MO_SO_SCHALT_2"                    , 0x18a1, 0},
  { "W_WASSERPROG_2_MO_SO_SCHALT_3"                    , 0x18a2, 0},
  { "W_WASSERPROG_2_MO_DO"                             , 0x18b0, 0},
  { "W_WASSERPROG_2_MO_DO_SCHALT_2"                    , 0x18b1, 0},
  { "W_WASSERPROG_2_MO_DO_SCHALT_3"                    , 0x18b2, 0},
  { "W_WASSERPROG_3"                                   , 0x1900, 0},
  { "W_WASSERPROG_3_MO"                                , 0x1910, et_time_domain},
  { "W_WASSERPROG_3_MO_SCHALT_2"                       , 0x1911, et_time_domain},
  { "W_WASSERPROG_3_MO_SCHALT_3"                       , 0x1912, et_time_domain},
  { "W_WASSERPROG_3_DI"                                , 0x1920, et_time_domain},
  { "W_WASSERPROG_3_DI_SCHALT_2"                       , 0x1921, et_time_domain},
  { "W_WASSERPROG_3_DI_SCHALT_3"                       , 0x1922, et_time_domain},
  { "W_WASSERPROG_3_MI"                                , 0x1930, et_time_domain},
  { "W_WASSERPROG_3_MI_SCHALT_2"                       , 0x1931, et_time_domain},
  { "W_WASSERPROG_3_MI_SCHALT_3"                       , 0x1932, et_time_domain},
  { "W_WASSERPROG_3_DO"                                , 0x1940, et_time_domain},
  { "W_WASSERPROG_3_DO_SCHALT_2"                       , 0x1941, et_time_domain},
  { "W_WASSERPROG_3_DO_SCHALT_3"                       , 0x1942, et_time_domain},
  { "W_WASSERPROG_3_FR"                                , 0x1950, et_time_domain},
  { "W_WASSERPROG_3_FR_SCHALT_2"                       , 0x1951, et_time_domain},
  { "W_WASSERPROG_3_FR_SCHALT_3"                       , 0x1952, et_time_domain},
  { "W_WASSERPROG_3_SA"                                , 0x1960, et_time_domain},
  { "W_WASSERPROG_3_SA_SCHALT_2"                       , 0x1961, et_time_domain},
  { "W_WASSERPROG_3_SA_SCHALT_3"                       , 0x1962, et_time_domain},
  { "W_WASSERPROG_3_SO"                                , 0x1970, et_time_domain},
  { "W_WASSERPROG_3_SO_SCHALT_2"                       , 0x1971, et_time_domain},
  { "W_WASSERPROG_3_SO_SCHALT_3"                       , 0x1972, et_time_domain},
  { "W_WASSERPROG_3_MO_FR"                             , 0x1980, 0},
  { "W_WASSERPROG_3_MO_FR_SCHALT_2"                    , 0x1981, 0},
  { "W_WASSERPROG_3_MO_FR_SCHALT_3"                    , 0x1982, 0},
  { "W_WASSERPROG_3_SA_SO"                             , 0x1990, 0},
  { "W_WASSERPROG_3_SA_SO_SCHALT_2"                    , 0x1991, 0},
  { "W_WASSERPROG_3_SA_SO_SCHALT_3"                    , 0x1992, 0},
  { "W_WASSERPROG_3_MO_SO"                             , 0x19a0, 0},
  { "W_WASSERPROG_3_MO_SO_SCHALT_2"                    , 0x19a1, 0},
  { "W_WASSERPROG_3_MO_SO_SCHALT_3"                    , 0x19a2, 0},
  { "W_WASSERPROG_3_MO_DO"                             , 0x19b0, 0},
  { "W_WASSERPROG_3_MO_DO_SCHALT_2"                    , 0x19b1, 0},
  { "W_WASSERPROG_3_MO_DO_SCHALT_3"                    , 0x19b2, 0},
  { "ZIRKPROG_1"                                       , 0x1a00, 0},
  { "ZIRKPROG_1_MO"                                    , 0x1a10, et_time_domain},
  { "ZIRKPROG_1_MO_SCHALT_2"                           , 0x1a11, et_time_domain},
  { "ZIRKPROG_1_MO_SCHALT_3"                           , 0x1a12, et_time_domain},
  { "ZIRKPROG_1_DI"                                    , 0x1a20, et_time_domain},
  { "ZIRKPROG_1_DI_SCHALT_2"                           , 0x1a21, et_time_domain},
  { "ZIRKPROG_1_DI_SCHALT_3"                           , 0x1a22, et_time_domain},
  { "ZIRKPROG_1_MI"                                    , 0x1a30, et_time_domain},
  { "ZIRKPROG_1_MI_SCHALT_2"                           , 0x1a31, et_time_domain},
  { "ZIRKPROG_1_MI_SCHALT_3"                           , 0x1a32, et_time_domain},
  { "ZIRKPROG_1_DO"                                    , 0x1a40, et_time_domain},
  { "ZIRKPROG_1_DO_SCHALT_2"                           , 0x1a41, et_time_domain},
  { "ZIRKPROG_1_DO_SCHALT_3"                           , 0x1a42, et_time_domain},
  { "ZIRKPROG_1_FR"                                    , 0x1a50, et_time_domain},
  { "ZIRKPROG_1_FR_SCHALT_2"                           , 0x1a51, et_time_domain},
  { "ZIRKPROG_1_FR_SCHALT_3"                           , 0x1a52, et_time_domain},
  { "ZIRKPROG_1_SA"                                    , 0x1a60, et_time_domain},
  { "ZIRKPROG_1_SA_SCHALT_2"                           , 0x1a61, et_time_domain},
  { "ZIRKPROG_1_SA_SCHALT_3"                           , 0x1a62, et_time_domain},
  { "ZIRKPROG_1_SO"                                    , 0x1a70, et_time_domain},
  { "ZIRKPROG_1_SO_SCHALT_2"                           , 0x1a71, et_time_domain},
  { "ZIRKPROG_1_SO_SCHALT_3"                           , 0x1a72, et_time_domain},
  { "ZIRKPROG_1_MO_FR"                                 , 0x1a80, 0},
  { "ZIRKPROG_1_MO_FR_SCHALT_2"                        , 0x1a81, 0},
  { "ZIRKPROG_1_MO_FR_SCHALT_3"                        , 0x1a82, 0},
  { "ZIRKPROG_1_SA_SO"                                 , 0x1a90, 0},
  { "ZIRKPROG_1_SA_SO_SCHALT_2"                        , 0x1a91, 0},
  { "ZIRKPROG_1_SA_SO_SCHALT_3"                        , 0x1a92, 0},
  { "ZIRKPROG_1_MO_SO"                                 , 0x1aa0, 0},
  { "ZIRKPROG_1_MO_SO_SCHALT_2"                        , 0x1aa1, 0},
  { "ZIRKPROG_1_MO_SO_SCHALT_3"                        , 0x1aa2, 0},
  { "ZIRKPROG_1_MO_DO"                                 , 0x1ab0, 0},
  { "ZIRKPROG_1_MO_DO_SCHALT_2"                        , 0x1ab1, 0},
  { "ZIRKPROG_1_MO_DO_SCHALT_3"                        , 0x1ab2, 0},
  { "ZIRKPROG_2"                                       , 0x1b00, 0},
  { "ZIRKPROG_2_MO"                                    , 0x1b10, et_time_domain},
  { "ZIRKPROG_2_MO_SCHALT_2"                           , 0x1b11, et_time_domain},
  { "ZIRKPROG_2_MO_SCHALT_3"                           , 0x1b12, et_time_domain},
  { "ZIRKPROG_2_DI"                                    , 0x1b20, et_time_domain},
  { "ZIRKPROG_2_DI_SCHALT_2"                           , 0x1b21, et_time_domain},
  { "ZIRKPROG_2_DI_SCHALT_3"                           , 0x1b22, et_time_domain},
  { "ZIRKPROG_2_MI"                                    , 0x1b30, et_time_domain},
  { "ZIRKPROG_2_MI_SCHALT_2"                           , 0x1b31, et_time_domain},
  { "ZIRKPROG_2_MI_SCHALT_3"                           , 0x1b32, et_time_domain},
  { "ZIRKPROG_2_DO"                                    , 0x1b40, et_time_domain},
  { "ZIRKPROG_2_DO_SCHALT_2"                           , 0x1b41, et_time_domain},
  { "ZIRKPROG_2_DO_SCHALT_3"                           , 0x1b42, et_time_domain},
  { "ZIRKPROG_2_FR"                                    , 0x1b50, et_time_domain},
  { "ZIRKPROG_2_FR_SCHALT_2"                           , 0x1b51, et_time_domain},
  { "ZIRKPROG_2_FR_SCHALT_3"                           , 0x1b52, et_time_domain},
  { "ZIRKPROG_2_SA"                                    , 0x1b60, et_time_domain},
  { "ZIRKPROG_2_SA_SCHALT_2"                           , 0x1b61, et_time_domain},
  { "ZIRKPROG_2_SA_SCHALT_3"                           , 0x1b62, et_time_domain},
  { "ZIRKPROG_2_SO"                                    , 0x1b70, et_time_domain},
  { "ZIRKPROG_2_SO_SCHALT_2"                           , 0x1b71, et_time_domain},
  { "ZIRKPROG_2_SO_SCHALT_3"                           , 0x1b72, et_time_domain},
  { "ZIRKPROG_2_MO_FR"                                 , 0x1b80, 0},
  { "ZIRKPROG_2_MO_FR_SCHALT_2"                        , 0x1b81, 0},
  { "ZIRKPROG_2_MO_FR_SCHALT_3"                        , 0x1b82, 0},
  { "ZIRKPROG_2_SA_SO"                                 , 0x1b90, 0},
  { "ZIRKPROG_2_SA_SO_SCHALT_2"                        , 0x1b91, 0},
  { "ZIRKPROG_2_SA_SO_SCHALT_3"                        , 0x1b92, 0},
  { "ZIRKPROG_2_MO_SO"                                 , 0x1ba0, 0},
  { "ZIRKPROG_2_MO_SO_SCHALT_2"                        , 0x1ba1, 0},
  { "ZIRKPROG_2_MO_SO_SCHALT_3"                        , 0x1ba2, 0},
  { "ZIRKPROG_2_MO_DO"                                 , 0x1bb0, 0},
  { "ZIRKPROG_2_MO_DO_SCHALT_2"                        , 0x1bb1, 0},
  { "ZIRKPROG_2_MO_DO_SCHALT_3"                        , 0x1bb2, 0},
  { "ZIRKPROG_3"                                       , 0x1c00, 0},
  { "ZIRKPROG_3_MO"                                    , 0x1c10, et_time_domain},
  { "ZIRKPROG_3_MO_SCHALT_2"                           , 0x1c11, et_time_domain},
  { "ZIRKPROG_3_MO_SCHALT_3"                           , 0x1c12, et_time_domain},
  { "ZIRKPROG_3_DI"                                    , 0x1c20, et_time_domain},
  { "ZIRKPROG_3_DI_SCHALT_2"                           , 0x1c21, et_time_domain},
  { "ZIRKPROG_3_DI_SCHALT_3"                           , 0x1c22, et_time_domain},
  { "ZIRKPROG_3_MI"                                    , 0x1c30, et_time_domain},
  { "ZIRKPROG_3_MI_SCHALT_2"                           , 0x1c31, et_time_domain},
  { "ZIRKPROG_3_MI_SCHALT_3"                           , 0x1c32, et_time_domain},
  { "ZIRKPROG_3_DO"                                    , 0x1c40, et_time_domain},
  { "ZIRKPROG_3_DO_SCHALT_2"                           , 0x1c41, et_time_domain},
  { "ZIRKPROG_3_DO_SCHALT_3"                           , 0x1c42, et_time_domain},
  { "ZIRKPROG_3_FR"                                    , 0x1c50, et_time_domain},
  { "ZIRKPROG_3_FR_SCHALT_2"                           , 0x1c51, et_time_domain},
  { "ZIRKPROG_3_FR_SCHALT_3"                           , 0x1c52, et_time_domain},
  { "ZIRKPROG_3_SA"                                    , 0x1c60, et_time_domain},
  { "ZIRKPROG_3_SA_SCHALT_2"                           , 0x1c61, et_time_domain},
  { "ZIRKPROG_3_SA_SCHALT_3"                           , 0x1c62, et_time_domain},
  { "ZIRKPROG_3_SO"                                    , 0x1c70, et_time_domain},
  { "ZIRKPROG_3_SO_SCHALT_2"                           , 0x1c71, et_time_domain},
  { "ZIRKPROG_3_SO_SCHALT_3"                           , 0x1c72, et_time_domain},
  { "ZIRKPROG_3_MO_FR"                                 , 0x1c80, 0},
  { "ZIRKPROG_3_MO_FR_SCHALT_2"                        , 0x1c81, 0},
  { "ZIRKPROG_3_MO_FR_SCHALT_3"                        , 0x1c82, 0},
  { "ZIRKPROG_3_SA_SO"                                 , 0x1c90, 0},
  { "ZIRKPROG_3_SA_SO_SCHALT_2"                        , 0x1c91, 0},
  { "ZIRKPROG_3_SA_SO_SCHALT_3"                        , 0x1c92, 0},
  { "ZIRKPROG_3_MO_SO"                                 , 0x1ca0, 0},
  { "ZIRKPROG_3_MO_SO_SCHALT_2"                        , 0x1ca1, 0},
  { "ZIRKPROG_3_MO_SO_SCHALT_3"                        , 0x1ca2, 0},
  { "ZIRKPROG_3_MO_DO"                                 , 0x1cb0, 0},
  { "ZIRKPROG_3_MO_DO_SCHALT_2"                        , 0x1cb1, 0},
  { "ZIRKPROG_3_MO_DO_SCHALT_3"                        , 0x1cb2, 0},
  { "ZBV_PROG_1"                                       , 0x1d00, 0},
  { "ZBV_PROG_1_MO"                                    , 0x1d10, et_time_domain},
  { "ZBV_PROG_1_MO_SCHALT_2"                           , 0x1d11, et_time_domain},
  { "ZBV_PROG_1_MO_SCHALT_3"                           , 0x1d12, et_time_domain},
  { "ZBV_PROG_1_DI"                                    , 0x1d20, et_time_domain},
  { "ZBV_PROG_1_DI_SCHALT_2"                           , 0x1d21, et_time_domain},
  { "ZBV_PROG_1_DI_SCHALT_3"                           , 0x1d22, et_time_domain},
  { "ZBV_PROG_1_MI"                                    , 0x1d30, et_time_domain},
  { "ZBV_PROG_1_MI_SCHALT_2"                           , 0x1d31, et_time_domain},
  { "ZBV_PROG_1_MI_SCHALT_3"                           , 0x1d32, et_time_domain},
  { "ZBV_PROG_1_DO"                                    , 0x1d40, et_time_domain},
  { "ZBV_PROG_1_DO_SCHALT_2"                           , 0x1d41, et_time_domain},
  { "ZBV_PROG_1_DO_SCHALT_3"                           , 0x1d42, et_time_domain},
  { "ZBV_PROG_1_FR"                                    , 0x1d50, et_time_domain},
  { "ZBV_PROG_1_FR_SCHALT_2"                           , 0x1d51, et_time_domain},
  { "ZBV_PROG_1_FR_SCHALT_3"                           , 0x1d52, et_time_domain},
  { "ZBV_PROG_1_SA"                                    , 0x1d60, et_time_domain},
  { "ZBV_PROG_1_SA_SCHALT_2"                           , 0x1d61, et_time_domain},
  { "ZBV_PROG_1_SA_SCHALT_3"                           , 0x1d62, et_time_domain},
  { "ZBV_PROG_1_SO"                                    , 0x1d70, et_time_domain},
  { "ZBV_PROG_1_SO_SCHALT_2"                           , 0x1d71, et_time_domain},
  { "ZBV_PROG_1_SO_SCHALT_3"                           , 0x1d72, et_time_domain},
  { "ZBV_PROG_1_MO_FR"                                 , 0x1d80, 0},
  { "ZBV_PROG_1_MO_FR_SCHALT_2"                        , 0x1d81, 0},
  { "ZBV_PROG_1_MO_FR_SCHALT_3"                        , 0x1d82, 0},
  { "ZBV_PROG_1_SA_SO"                                 , 0x1d90, 0},
  { "ZBV_PROG_1_SA_SO_SCHALT_2"                        , 0x1d91, 0},
  { "ZBV_PROG_1_SA_SO_SCHALT_3"                        , 0x1d92, 0},
  { "ZBV_PROG_1_MO_SO"                                 , 0x1da0, 0},
  { "ZBV_PROG_1_MO_SO_SCHALT_2"                        , 0x1da1, 0},
  { "ZBV_PROG_1_MO_SO_SCHALT_3"                        , 0x1da2, 0},
  { "ZBV_PROG_1_MO_DO"                                 , 0x1db0, 0},
  { "ZBV_PROG_1_MO_DO_SCHALT_2"                        , 0x1db1, 0},
  { "ZBV_PROG_1_MO_DO_SCHALT_3"                        , 0x1db2, 0},
  { "ZBV_PROG_2"                                       , 0x1e00, 0},
  { "ZBV_PROG_2_MO"                                    , 0x1e10, et_time_domain},
  { "ZBV_PROG_2_MO_SCHALT_2"                           , 0x1e11, et_time_domain},
  { "ZBV_PROG_2_MO_SCHALT_3"                           , 0x1e12, et_time_domain},
  { "ZBV_PROG_2_DI"                                    , 0x1e20, et_time_domain},
  { "ZBV_PROG_2_DI_SCHALT_2"                           , 0x1e21, et_time_domain},
  { "ZBV_PROG_2_DI_SCHALT_3"                           , 0x1e22, et_time_domain},
  { "ZBV_PROG_2_MI"                                    , 0x1e30, et_time_domain},
  { "ZBV_PROG_2_MI_SCHALT_2"                           , 0x1e31, et_time_domain},
  { "ZBV_PROG_2_MI_SCHALT_3"                           , 0x1e32, et_time_domain},
  { "ZBV_PROG_2_DO"                                    , 0x1e40, et_time_domain},
  { "ZBV_PROG_2_DO_SCHALT_2"                           , 0x1e41, et_time_domain},
  { "ZBV_PROG_2_DO_SCHALT_3"                           , 0x1e42, et_time_domain},
  { "ZBV_PROG_2_FR"                                    , 0x1e50, et_time_domain},
  { "ZBV_PROG_2_FR_SCHALT_2"                           , 0x1e51, et_time_domain},
  { "ZBV_PROG_2_FR_SCHALT_3"                           , 0x1e52, et_time_domain},
  { "ZBV_PROG_2_SA"                                    , 0x1e60, et_time_domain},
  { "ZBV_PROG_2_SA_SCHALT_2"                           , 0x1e61, et_time_domain},
  { "ZBV_PROG_2_SA_SCHALT_3"                           , 0x1e62, et_time_domain},
  { "ZBV_PROG_2_SO"                                    , 0x1e70, et_time_domain},
  { "ZBV_PROG_2_SO_SCHALT_2"                           , 0x1e71, et_time_domain},
  { "ZBV_PROG_2_SO_SCHALT_3"                           , 0x1e72, et_time_domain},
  { "ZBV_PROG_2_MO_FR"                                 , 0x1e80, 0},
  { "ZBV_PROG_2_MO_FR_SCHALT_2"                        , 0x1e81, 0},
  { "ZBV_PROG_2_MO_FR_SCHALT_3"                        , 0x1e82, 0},
  { "ZBV_PROG_2_SA_SO"                                 , 0x1e90, 0},
  { "ZBV_PROG_2_SA_SO_SCHALT_2"                        , 0x1e91, 0},
  { "ZBV_PROG_2_SA_SO_SCHALT_3"                        , 0x1e92, 0},
  { "ZBV_PROG_2_MO_SO"                                 , 0x1ea0, 0},
  { "ZBV_PROG_2_MO_SO_SCHALT_2"                        , 0x1ea1, 0},
  { "ZBV_PROG_2_MO_SO_SCHALT_3"                        , 0x1ea2, 0},
  { "ZBV_PROG_2_MO_DO"                                 , 0x1eb0, 0},
  { "ZBV_PROG_2_MO_DO_SCHALT_2"                        , 0x1eb1, 0},
  { "ZBV_PROG_2_MO_DO_SCHALT_3"                        , 0x1eb2, 0},
  { "HEIZPROG_1_SCHALTPKT_1"                           , 0x14c0, 0},
  { "HEIZPROG_1_SCHALTPKT_2"                           , 0x14c1, 0},
  { "HEIZPROG_1_SCHALTPKT_3"                           , 0x14c2, 0},
  { "HEIZPROG_1_SCHALTPKT_4"                           , 0x14c3, 0},
  { "HEIZPROG_1_SCHALTPKT_5"                           , 0x14c4, 0},
  { "HEIZPROG_1_SCHALTPKT_6"                           , 0x14c5, 0},
  { "HEIZPROG_1_SCHALTPKT_7"                           , 0x14c6, 0},
  { "HEIZPROG_1_SCHALTPKT_8"                           , 0x14c7, 0},
  { "HEIZPROG_1_SCHALTPKT_9"                           , 0x14c8, 0},
  { "HEIZPROG_1_SCHALTPKT_10"                          , 0x14c9, 0},
  { "HEIZPROG_1_SCHALTPKT_11"                          , 0x14ca, 0},
  { "HEIZPROG_1_SCHALTPKT_12"                          , 0x14cb, 0},
  { "HEIZPROG_1_SCHALTPKT_13"                          , 0x14cc, 0},
  { "HEIZPROG_1_SCHALTPKT_14"                          , 0x14cd, 0},
  { "HEIZPROG_2_SCHALTPKT_1"                           , 0x15c0, 0},
  { "HEIZPROG_2_SCHALTPKT_2"                           , 0x15c1, 0},
  { "HEIZPROG_2_SCHALTPKT_3"                           , 0x15c2, 0},
  { "HEIZPROG_2_SCHALTPKT_4"                           , 0x15c3, 0},
  { "HEIZPROG_2_SCHALTPKT_5"                           , 0x15c4, 0},
  { "HEIZPROG_2_SCHALTPKT_6"                           , 0x15c5, 0},
  { "HEIZPROG_2_SCHALTPKT_7"                           , 0x15c6, 0},
  { "HEIZPROG_2_SCHALTPKT_8"                           , 0x15c7, 0},
  { "HEIZPROG_2_SCHALTPKT_9"                           , 0x15c8, 0},
  { "HEIZPROG_2_SCHALTPKT_10"                          , 0x15c9, 0},
  { "HEIZPROG_2_SCHALTPKT_11"                          , 0x15ca, 0},
  { "HEIZPROG_2_SCHALTPKT_12"                          , 0x15cb, 0},
  { "HEIZPROG_2_SCHALTPKT_13"                          , 0x15cc, 0},
  { "HEIZPROG_2_SCHALTPKT_14"                          , 0x15cd, 0},
  { "HEIZPROG_3_SCHALTPKT_1"                           , 0x16c0, 0},
  { "HEIZPROG_3_SCHALTPKT_2"                           , 0x16c1, 0},
  { "HEIZPROG_3_SCHALTPKT_3"                           , 0x16c2, 0},
  { "HEIZPROG_3_SCHALTPKT_4"                           , 0x16c3, 0},
  { "HEIZPROG_3_SCHALTPKT_5"                           , 0x16c4, 0},
  { "HEIZPROG_3_SCHALTPKT_6"                           , 0x16c5, 0},
  { "HEIZPROG_3_SCHALTPKT_7"                           , 0x16c6, 0},
  { "HEIZPROG_3_SCHALTPKT_8"                           , 0x16c7, 0},
  { "HEIZPROG_3_SCHALTPKT_9"                           , 0x16c8, 0},
  { "HEIZPROG_3_SCHALTPKT_10"                          , 0x16c9, 0},
  { "HEIZPROG_3_SCHALTPKT_11"                          , 0x16ca, 0},
  { "HEIZPROG_3_SCHALTPKT_12"                          , 0x16cb, 0},
  { "HEIZPROG_3_SCHALTPKT_13"                          , 0x16cc, 0},
  { "HEIZPROG_3_SCHALTPKT_14"                          , 0x16cd, 0},
  { "WWROG_1_SCHALTPKT_1"                              , 0x17c0, 0},
  { "WWROG_1_SCHALTPKT_2"                              , 0x17c1, 0},
  { "WWROG_1_SCHALTPKT_3"                              , 0x17c2, 0},
  { "WWROG_1_SCHALTPKT_4"                              , 0x17c3, 0},
  { "WWROG_1_SCHALTPKT_5"                              , 0x17c4, 0},
  { "WWROG_1_SCHALTPKT_6"                              , 0x17c5, 0},
  { "WWROG_1_SCHALTPKT_7"                              , 0x17c6, 0},
  { "WWROG_1_SCHALTPKT_8"                              , 0x17c7, 0},
  { "WWROG_1_SCHALTPKT_9"                              , 0x17c8, 0},
  { "WWROG_1_SCHALTPKT_10"                             , 0x17c9, 0},
  { "WWROG_1_SCHALTPKT_11"                             , 0x17ca, 0},
  { "WWROG_1_SCHALTPKT_12"                             , 0x17cb, 0},
  { "WWROG_1_SCHALTPKT_13"                             , 0x17cc, 0},
  { "WWROG_1_SCHALTPKT_14"                             , 0x17cd, 0},
  { "WWROG_2_SCHALTPKT_1"                              , 0x18c0, 0},
  { "WWROG_2_SCHALTPKT_2"                              , 0x18c1, 0},
  { "WWROG_2_SCHALTPKT_3"                              , 0x18c2, 0},
  { "WWROG_2_SCHALTPKT_4"                              , 0x18c3, 0},
  { "WWROG_2_SCHALTPKT_5"                              , 0x18c4, 0},
  { "WWROG_2_SCHALTPKT_6"                              , 0x18c5, 0},
  { "WWROG_2_SCHALTPKT_7"                              , 0x18c6, 0},
  { "WWROG_2_SCHALTPKT_8"                              , 0x18c7, 0},
  { "WWROG_2_SCHALTPKT_9"                              , 0x18c8, 0},
  { "WWROG_2_SCHALTPKT_10"                             , 0x18c9, 0},
  { "WWROG_2_SCHALTPKT_11"                             , 0x18ca, 0},
  { "WWROG_2_SCHALTPKT_12"                             , 0x18cb, 0},
  { "WWROG_2_SCHALTPKT_13"                             , 0x18cc, 0},
  { "WWROG_2_SCHALTPKT_14"                             , 0x18cd, 0},
  { "WWROG_3_SCHALTPKT_1"                              , 0x19c0, 0},
  { "WWROG_3_SCHALTPKT_2"                              , 0x19c1, 0},
  { "WWROG_3_SCHALTPKT_3"                              , 0x19c2, 0},
  { "WWROG_3_SCHALTPKT_4"                              , 0x19c3, 0},
  { "WWROG_3_SCHALTPKT_5"                              , 0x19c4, 0},
  { "WWROG_3_SCHALTPKT_6"                              , 0x19c5, 0},
  { "WWROG_3_SCHALTPKT_7"                              , 0x19c6, 0},
  { "WWROG_3_SCHALTPKT_8"                              , 0x19c7, 0},
  { "WWROG_3_SCHALTPKT_9"                              , 0x19c8, 0},
  { "WWROG_3_SCHALTPKT_10"                             , 0x19c9, 0},
  { "WWROG_3_SCHALTPKT_11"                             , 0x19ca, 0},
  { "WWROG_3_SCHALTPKT_12"                             , 0x19cb, 0},
  { "WWROG_3_SCHALTPKT_13"                             , 0x19cc, 0},
  { "WWROG_3_SCHALTPKT_14"                             , 0x19cd, 0},
  { "ZIRKROG_1_SCHALTPKT_1"                            , 0x1ac0, 0},
  { "ZIRKROG_1_SCHALTPKT_2"                            , 0x1ac1, 0},
  { "ZIRKROG_1_SCHALTPKT_3"                            , 0x1ac2, 0},
  { "ZIRKROG_1_SCHALTPKT_4"                            , 0x1ac3, 0},
  { "ZIRKROG_1_SCHALTPKT_5"                            , 0x1ac4, 0},
  { "ZIRKROG_1_SCHALTPKT_6"                            , 0x1ac5, 0},
  { "ZIRKROG_1_SCHALTPKT_7"                            , 0x1ac6, 0},
  { "ZIRKROG_1_SCHALTPKT_8"                            , 0x1ac7, 0},
  { "ZIRKROG_1_SCHALTPKT_9"                            , 0x1ac8, 0},
  { "ZIRKROG_1_SCHALTPKT_10"                           , 0x1ac9, 0},
  { "ZIRKROG_1_SCHALTPKT_11"                           , 0x1aca, 0},
  { "ZIRKROG_1_SCHALTPKT_12"                           , 0x1acb, 0},
  { "ZIRKROG_1_SCHALTPKT_13"                           , 0x1acc, 0},
  { "ZIRKROG_1_SCHALTPKT_14"                           , 0x1acd, 0},
  { "ZIRKROG_2_SCHALTPKT_1"                            , 0x1bc0, 0},
  { "ZIRKROG_2_SCHALTPKT_2"                            , 0x1bc1, 0},
  { "ZIRKROG_2_SCHALTPKT_3"                            , 0x1bc2, 0},
  { "ZIRKROG_2_SCHALTPKT_4"                            , 0x1bc3, 0},
  { "ZIRKROG_2_SCHALTPKT_5"                            , 0x1bc4, 0},
  { "ZIRKROG_2_SCHALTPKT_6"                            , 0x1bc5, 0},
  { "ZIRKROG_2_SCHALTPKT_7"                            , 0x1bc6, 0},
  { "ZIRKROG_2_SCHALTPKT_8"                            , 0x1bc7, 0},
  { "ZIRKROG_2_SCHALTPKT_9"                            , 0x1bc8, 0},
  { "ZIRKROG_2_SCHALTPKT_10"                           , 0x1bc9, 0},
  { "ZIRKROG_2_SCHALTPKT_11"                           , 0x1bca, 0},
  { "ZIRKROG_2_SCHALTPKT_12"                           , 0x1bcb, 0},
  { "ZIRKROG_2_SCHALTPKT_13"                           , 0x1bcc, 0},
  { "ZIRKROG_2_SCHALTPKT_14"                           , 0x1bcd, 0},
  { "ZIRKROG_3_SCHALTPKT_1"                            , 0x1cc0, 0},
  { "ZIRKROG_3_SCHALTPKT_2"                            , 0x1cc1, 0},
  { "ZIRKROG_3_SCHALTPKT_3"                            , 0x1cc2, 0},
  { "ZIRKROG_3_SCHALTPKT_4"                            , 0x1cc3, 0},
  { "ZIRKROG_3_SCHALTPKT_5"                            , 0x1cc4, 0},
  { "ZIRKROG_3_SCHALTPKT_6"                            , 0x1cc5, 0},
  { "ZIRKROG_3_SCHALTPKT_7"                            , 0x1cc6, 0},
  { "ZIRKROG_3_SCHALTPKT_8"                            , 0x1cc7, 0},
  { "ZIRKROG_3_SCHALTPKT_9"                            , 0x1cc8, 0},
  { "ZIRKROG_3_SCHALTPKT_10"                           , 0x1cc9, 0},
  { "ZIRKROG_3_SCHALTPKT_11"                           , 0x1cca, 0},
  { "ZIRKROG_3_SCHALTPKT_12"                           , 0x1ccb, 0},
  { "ZIRKROG_3_SCHALTPKT_13"                           , 0x1ccc, 0},
  { "ZIRKROG_3_SCHALTPKT_14"                           , 0x1ccd, 0},
  { "ZEITPROG_1"                                       , 0x2000, 0},
  { "ZEITPROG_1_MO"                                    , 0x2010, et_time_domain},
  { "ZEITPROG_1_MO_SCHALT_2"                           , 0x2011, et_time_domain},
  { "ZEITPROG_1_MO_SCHALT_3"                           , 0x2012, et_time_domain},
  { "ZEITPROG_1_DI"                                    , 0x2020, et_time_domain},
  { "ZEITPROG_1_DI_SCHALT_2"                           , 0x2021, et_time_domain},
  { "ZEITPROG_1_DI_SCHALT_3"                           , 0x2022, et_time_domain},
  { "ZEITPROG_1_MI"                                    , 0x2030, et_time_domain},
  { "ZEITPROG_1_MI_SCHALT_2"                           , 0x2031, et_time_domain},
  { "ZEITPROG_1_MI_SCHALT_3"                           , 0x2032, et_time_domain},
  { "ZEITPROG_1_DO"                                    , 0x2040, et_time_domain},
  { "ZEITPROG_1_DO_SCHALT_2"                           , 0x2041, et_time_domain},
  { "ZEITPROG_1_DO_SCHALT_3"                           , 0x2042, et_time_domain},
  { "ZEITPROG_1_FR"                                    , 0x2050, et_time_domain},
  { "ZEITPROG_1_FR_SCHALT_2"                           , 0x2051, et_time_domain},
  { "ZEITPROG_1_FR_SCHALT_3"                           , 0x2052, et_time_domain},
  { "ZEITPROG_1_SA"                                    , 0x2060, et_time_domain},
  { "ZEITPROG_1_SA_SCHALT_2"                           , 0x2061, et_time_domain},
  { "ZEITPROG_1_SA_SCHALT_3"                           , 0x2062, et_time_domain},
  { "ZEITPROG_1_SO"                                    , 0x2070, et_time_domain},
  { "ZEITPROG_1_SO_SCHALT_2"                           , 0x2071, et_time_domain},
  { "ZEITPROG_1_SO_SCHALT_3"                           , 0x2072, et_time_domain},
  { "ZEITPROG_1_MO_FR"                                 , 0x2080, 0},
  { "ZEITPROG_1_MO_FR_SCHALT_2"                        , 0x2081, 0},
  { "ZEITPROG_1_MO_FR_SCHALT_3"                        , 0x2082, 0},
  { "ZEITPROG_1_SA_SO"                                 , 0x2090, 0},
  { "ZEITPROG_1_SA_SO_SCHALT_2"                        , 0x2091, 0},
  { "ZEITPROG_1_SA_SO_SCHALT_3"                        , 0x2092, 0},
  { "ZEITPROG_1_MO_SO"                                 , 0x20a0, 0},
  { "ZEITPROG_1_MO_SO_SCHALT_2"                        , 0x20a1, 0},
  { "ZEITPROG_1_MO_SO_SCHALT_3"                        , 0x20a2, 0},
  { "ZEITPROG_1_MO_DO"                                 , 0x20b0, 0},
  { "ZEITPROG_1_MO_DO_SCHALT_2"                        , 0x20b1, 0},
  { "ZEITPROG_1_MO_DO_SCHALT_3"                        , 0x20b2, 0},
  { "ZEITPROG_2"                                       , 0x2100, 0},
  { "ZEITPROG_2_MO"                                    , 0x2110, et_time_domain},
  { "ZEITPROG_2_MO_SCHALT_2"                           , 0x2111, et_time_domain},
  { "ZEITPROG_2_MO_SCHALT_3"                           , 0x2112, et_time_domain},
  { "ZEITPROG_2_DI"                                    , 0x2120, et_time_domain},
  { "ZEITPROG_2_DI_SCHALT_2"                           , 0x2121, et_time_domain},
  { "ZEITPROG_2_DI_SCHALT_3"                           , 0x2122, et_time_domain},
  { "ZEITPROG_2_MI"                                    , 0x2130, et_time_domain},
  { "ZEITPROG_2_MI_SCHALT_2"                           , 0x2131, et_time_domain},
  { "ZEITPROG_2_MI_SCHALT_3"                           , 0x2132, et_time_domain},
  { "ZEITPROG_2_DO"                                    , 0x2140, et_time_domain},
  { "ZEITPROG_2_DO_SCHALT_2"                           , 0x2141, et_time_domain},
  { "ZEITPROG_2_DO_SCHALT_3"                           , 0x2142, et_time_domain},
  { "ZEITPROG_2_FR"                                    , 0x2150, et_time_domain},
  { "ZEITPROG_2_FR_SCHALT_2"                           , 0x2151, et_time_domain},
  { "ZEITPROG_2_FR_SCHALT_3"                           , 0x2152, et_time_domain},
  { "ZEITPROG_2_SA"                                    , 0x2160, et_time_domain},
  { "ZEITPROG_2_SA_SCHALT_2"                           , 0x2161, et_time_domain},
  { "ZEITPROG_2_SA_SCHALT_3"                           , 0x2162, et_time_domain},
  { "ZEITPROG_2_SO"                                    , 0x2170, et_time_domain},
  { "ZEITPROG_2_SO_SCHALT_2"                           , 0x2171, et_time_domain},
  { "ZEITPROG_2_SO_SCHALT_3"                           , 0x2172, et_time_domain},
  { "ZEITPROG_2_MO_FR"                                 , 0x2180, 0},
  { "ZEITPROG_2_MO_FR_SCHALT_2"                        , 0x2181, 0},
  { "ZEITPROG_2_MO_FR_SCHALT_3"                        , 0x2182, 0},
  { "ZEITPROG_2_SA_SO"                                 , 0x2190, 0},
  { "ZEITPROG_2_SA_SO_SCHALT_2"                        , 0x2191, 0},
  { "ZEITPROG_2_SA_SO_SCHALT_3"                        , 0x2192, 0},
  { "ZEITPROG_2_MO_SO"                                 , 0x21a0, 0},
  { "ZEITPROG_2_MO_SO_SCHALT_2"                        , 0x21a1, 0},
  { "ZEITPROG_2_MO_SO_SCHALT_3"                        , 0x21a2, 0},
  { "ZEITPROG_2_MO_DO"                                 , 0x21b0, 0},
  { "ZEITPROG_2_MO_DO_SCHALT_2"                        , 0x21b1, 0},
  { "ZEITPROG_2_MO_DO_SCHALT_3"                        , 0x21b2, 0},
  { "ZEITPROG_3"                                       , 0x2200, 0},
  { "ZEITPROG_3_MO"                                    , 0x2210, et_time_domain},
  { "ZEITPROG_3_MO_SCHALT_2"                           , 0x2211, et_time_domain},
  { "ZEITPROG_3_MO_SCHALT_3"                           , 0x2212, et_time_domain},
  { "ZEITPROG_3_DI"                                    , 0x2220, et_time_domain},
  { "ZEITPROG_3_DI_SCHALT_2"                           , 0x2221, et_time_domain},
  { "ZEITPROG_3_DI_SCHALT_3"                           , 0x2222, et_time_domain},
  { "ZEITPROG_3_MI"                                    , 0x2230, et_time_domain},
  { "ZEITPROG_3_MI_SCHALT_2"                           , 0x2231, et_time_domain},
  { "ZEITPROG_3_MI_SCHALT_3"                           , 0x2232, et_time_domain},
  { "ZEITPROG_3_DO"                                    , 0x2240, et_time_domain},
  { "ZEITPROG_3_DO_SCHALT_2"                           , 0x2241, et_time_domain},
  { "ZEITPROG_3_DO_SCHALT_3"                           , 0x2242, et_time_domain},
  { "ZEITPROG_3_FR"                                    , 0x2250, et_time_domain},
  { "ZEITPROG_3_FR_SCHALT_2"                           , 0x2251, et_time_domain},
  { "ZEITPROG_3_FR_SCHALT_3"                           , 0x2252, et_time_domain},
  { "ZEITPROG_3_SA"                                    , 0x2260, et_time_domain},
  { "ZEITPROG_3_SA_SCHALT_2"                           , 0x2261, et_time_domain},
  { "ZEITPROG_3_SA_SCHALT_3"                           , 0x2262, et_time_domain},
  { "ZEITPROG_3_SO"                                    , 0x2270, et_time_domain},
  { "ZEITPROG_3_SO_SCHALT_2"                           , 0x2271, et_time_domain},
  { "ZEITPROG_3_SO_SCHALT_3"                           , 0x2272, et_time_domain},
  { "ZEITPROG_3_MO_FR"                                 , 0x2280, 0},
  { "ZEITPROG_3_MO_FR_SCHALT_2"                        , 0x2281, 0},
  { "ZEITPROG_3_MO_FR_SCHALT_3"                        , 0x2282, 0},
  { "ZEITPROG_3_SA_SO"                                 , 0x2290, 0},
  { "ZEITPROG_3_SA_SO_SCHALT_2"                        , 0x2291, 0},
  { "ZEITPROG_3_SA_SO_SCHALT_3"                        , 0x2292, 0},
  { "ZEITPROG_3_MO_SO"                                 , 0x22a0, 0},
  { "ZEITPROG_3_MO_SO_SCHALT_2"                        , 0x22a1, 0},
  { "ZEITPROG_3_MO_SO_SCHALT_3"                        , 0x22a2, 0},
  { "ZEITPROG_3_MO_DO"                                 , 0x22b0, 0},
  { "ZEITPROG_3_MO_DO_SCHALT_2"                        , 0x22b1, 0},
  { "ZEITPROG_3_MO_DO_SCHALT_3"                        , 0x22b2, 0},
  { "ZEITPROG_4"                                       , 0x2300, 0},
  { "ZEITPROG_4_MO"                                    , 0x2310, et_time_domain},
  { "ZEITPROG_4_MO_SCHALT_2"                           , 0x2311, et_time_domain},
  { "ZEITPROG_4_MO_SCHALT_3"                           , 0x2312, et_time_domain},
  { "ZEITPROG_4_DI"                                    , 0x2320, et_time_domain},
  { "ZEITPROG_4_DI_SCHALT_2"                           , 0x2321, et_time_domain},
  { "ZEITPROG_4_DI_SCHALT_3"                           , 0x2322, et_time_domain},
  { "ZEITPROG_4_MI"                                    , 0x2330, et_time_domain},
  { "ZEITPROG_4_MI_SCHALT_2"                           , 0x2331, et_time_domain},
  { "ZEITPROG_4_MI_SCHALT_3"                           , 0x2332, et_time_domain},
  { "ZEITPROG_4_DO"                                    , 0x2340, et_time_domain},
  { "ZEITPROG_4_DO_SCHALT_2"                           , 0x2341, et_time_domain},
  { "ZEITPROG_4_DO_SCHALT_3"                           , 0x2342, et_time_domain},
  { "ZEITPROG_4_FR"                                    , 0x2350, et_time_domain},
  { "ZEITPROG_4_FR_SCHALT_2"                           , 0x2351, et_time_domain},
  { "ZEITPROG_4_FR_SCHALT_3"                           , 0x2352, et_time_domain},
  { "ZEITPROG_4_SA"                                    , 0x2360, et_time_domain},
  { "ZEITPROG_4_SA_SCHALT_2"                           , 0x2361, et_time_domain},
  { "ZEITPROG_4_SA_SCHALT_3"                           , 0x2362, et_time_domain},
  { "ZEITPROG_4_SO"                                    , 0x2370, et_time_domain},
  { "ZEITPROG_4_SO_SCHALT_2"                           , 0x2371, et_time_domain},
  { "ZEITPROG_4_SO_SCHALT_3"                           , 0x2372, et_time_domain},
  { "ZEITPROG_4_MO_FR"                                 , 0x2380, 0},
  { "ZEITPROG_4_MO_FR_SCHALT_2"                        , 0x2381, 0},
  { "ZEITPROG_4_MO_FR_SCHALT_3"                        , 0x2382, 0},
  { "ZEITPROG_4_SA_SO"                                 , 0x2390, 0},
  { "ZEITPROG_4_SA_SO_SCHALT_2"                        , 0x2391, 0},
  { "ZEITPROG_4_SA_SO_SCHALT_3"                        , 0x2392, 0},
  { "ZEITPROG_4_MO_SO"                                 , 0x23a0, 0},
  { "ZEITPROG_4_MO_SO_SCHALT_2"                        , 0x23a1, 0},
  { "ZEITPROG_4_MO_SO_SCHALT_3"                        , 0x23a2, 0},
  { "ZEITPROG_4_MO_DO"                                 , 0x23b0, 0},
  { "ZEITPROG_4_MO_DO_SCHALT_2"                        , 0x23b1, 0},
  { "ZEITPROG_4_MO_DO_SCHALT_3"                        , 0x23b2, 0},
  { "HF_MONITOR_TYP"                                   , 0xc34f, 0},
  { "START_BEREICH_SOFTWARE_SIMULATION"                , 0xc350, 0},
  { "SOFTWARE_SIMULATION_0"                            , 0xc351, 0},
  { "SOFTWARE_SIMULATION_1"                            , 0xc352, 0},
  { "SOFTWARE_SIMULATION_2"                            , 0xc353, 0},
  { "SOFTWARE_SIMULATION_3"                            , 0xc354, 0},
  { "SOFTWARE_SIMULATION_4"                            , 0xc355, 0},
  { "SOFTWARE_SIMULATION_5"                            , 0xc356, 0},
  { "SOFTWARE_SIMULATION_6"                            , 0xc357, 0},
  { "SOFTWARE_SIMULATION_7"                            , 0xc358, 0},
  { "SOFTWARE_SIMULATION_8"                            , 0xc359, 0},
  { "SOFTWARE_SIMULATION_9"                            , 0xc35a, 0},
  { "SOFTWARE_SIMULATION_10"                           , 0xc35b, 0},
  { "SOFTWARE_SIMULATION_11"                           , 0xc35c, 0},
  { "SOFTWARE_SIMULATION_12"                           , 0xc35d, 0},
  { "SOFTWARE_SIMULATION_13"                           , 0xc35e, 0},
  { "SOFTWARE_SIMULATION_14"                           , 0xc35f, 0},
  { "SOFTWARE_SIMULATION_15"                           , 0xc360, 0},
  { "SOFTWARE_SIMULATION_16"                           , 0xc361, 0},
  { "SOFTWARE_SIMULATION_17"                           , 0xc362, 0},
  { "SOFTWARE_SIMULATION_18"                           , 0xc363, 0},
  { "SOFTWARE_SIMULATION_19"                           , 0xc364, 0},
  { "SOFTWARE_SIMULATION_20"                           , 0xc365, 0},
  { "SOFTWARE_SIMULATION_21"                           , 0xc366, 0},
  { "SOFTWARE_SIMULATION_22"                           , 0xc367, 0},
  { "SOFTWARE_SIMULATION_23"                           , 0xc368, 0},
  { "SOFTWARE_SIMULATION_24"                           , 0xc369, 0},
  { "SOFTWARE_SIMULATION_25"                           , 0xc36a, 0},
  { "SOFTWARE_SIMULATION_26"                           , 0xc36b, 0},
  { "SOFTWARE_SIMULATION_27"                           , 0xc36c, 0},
  { "SOFTWARE_SIMULATION_28"                           , 0xc36d, 0},
  { "SOFTWARE_SIMULATION_29"                           , 0xc36e, 0},
  { "SOFTWARE_SIMULATION_30"                           , 0xc36f, 0},
  { "SOFTWARE_SIMULATION_31"                           , 0xc370, 0},
  { "SOFTWARE_SIMULATION_32"                           , 0xc371, 0},
  { "SOFTWARE_SIMULATION_33"                           , 0xc372, 0},
  { "SOFTWARE_SIMULATION_34"                           , 0xc373, 0},
  { "SOFTWARE_SIMULATION_35"                           , 0xc374, 0},
  { "SOFTWARE_SIMULATION_36"                           , 0xc375, 0},
  { "SOFTWARE_SIMULATION_37"                           , 0xc376, 0},
  { "SOFTWARE_SIMULATION_38"                           , 0xc377, 0},
  { "SOFTWARE_SIMULATION_39"                           , 0xc378, 0},
  { "SOFTWARE_SIMULATION_40"                           , 0xc379, 0},
  { "SOFTWARE_SIMULATION_41"                           , 0xc37a, 0},
  { "SOFTWARE_SIMULATION_42"                           , 0xc37b, 0},
  { "SOFTWARE_SIMULATION_43"                           , 0xc37c, 0},
  { "SOFTWARE_SIMULATION_44"                           , 0xc37d, 0},
  { "SOFTWARE_SIMULATION_45"                           , 0xc37e, 0},
  { "SOFTWARE_SIMULATION_46"                           , 0xc37f, 0},
  { "SOFTWARE_SIMULATION_47"                           , 0xc380, 0},
  { "SOFTWARE_SIMULATION_48"                           , 0xc381, 0},
  { "SOFTWARE_SIMULATION_49"                           , 0xc382, 0},
  { "SOFTWARE_SIMULATION_50"                           , 0xc383, 0},
  { "SOFTWARE_SIMULATION_51"                           , 0xc384, 0},
  { "SOFTWARE_SIMULATION_52"                           , 0xc385, 0},
  { "SOFTWARE_SIMULATION_53"                           , 0xc386, 0},
  { "SOFTWARE_SIMULATION_54"                           , 0xc387, 0},
  { "SOFTWARE_SIMULATION_55"                           , 0xc388, 0},
  { "SOFTWARE_SIMULATION_56"                           , 0xc389, 0},
  { "SOFTWARE_SIMULATION_57"                           , 0xc38a, 0},
  { "SOFTWARE_SIMULATION_58"                           , 0xc38b, 0},
  { "SOFTWARE_SIMULATION_59"                           , 0xc38c, 0},
  { "SOFTWARE_SIMULATION_60"                           , 0xc38d, 0},
  { "SOFTWARE_SIMULATION_61"                           , 0xc38e, 0},
  { "SOFTWARE_SIMULATION_62"                           , 0xc38f, 0},
  { "SOFTWARE_SIMULATION_63"                           , 0xc390, 0},
  { "SOFTWARE_SIMULATION_64"                           , 0xc391, 0},
  { "SOFTWARE_SIMULATION_65"                           , 0xc392, 0},
  { "SOFTWARE_SIMULATION_66"                           , 0xc393, 0},
  { "SOFTWARE_SIMULATION_67"                           , 0xc394, 0},
  { "SOFTWARE_SIMULATION_68"                           , 0xc395, 0},
  { "SOFTWARE_SIMULATION_69"                           , 0xc396, 0},
  { "SOFTWARE_SIMULATION_70"                           , 0xc397, 0},
  { "SOFTWARE_SIMULATION_71"                           , 0xc398, 0},
  { "SOFTWARE_SIMULATION_72"                           , 0xc399, 0},
  { "SOFTWARE_SIMULATION_73"                           , 0xc39a, 0},
  { "SOFTWARE_SIMULATION_74"                           , 0xc39b, 0},
  { "SOFTWARE_SIMULATION_75"                           , 0xc39c, 0},
  { "SOFTWARE_SIMULATION_76"                           , 0xc39d, 0},
  { "SOFTWARE_SIMULATION_77"                           , 0xc39e, 0},
  { "SOFTWARE_SIMULATION_78"                           , 0xc39f, 0},
  { "SOFTWARE_SIMULATION_79"                           , 0xc3a0, 0},
  { "SOFTWARE_SIMULATION_80"                           , 0xc3a1, 0},
  { "SOFTWARE_SIMULATION_81"                           , 0xc3a2, 0},
  { "SOFTWARE_SIMULATION_82"                           , 0xc3a3, 0},
  { "SOFTWARE_SIMULATION_83"                           , 0xc3a4, 0},
  { "SOFTWARE_SIMULATION_84"                           , 0xc3a5, 0},
  { "SOFTWARE_SIMULATION_85"                           , 0xc3a6, 0},
  { "SOFTWARE_SIMULATION_86"                           , 0xc3a7, 0},
  { "SOFTWARE_SIMULATION_87"                           , 0xc3a8, 0},
  { "SOFTWARE_SIMULATION_88"                           , 0xc3a9, 0},
  { "SOFTWARE_SIMULATION_89"                           , 0xc3aa, 0},
  { "SOFTWARE_SIMULATION_90"                           , 0xc3ab, 0},
  { "SOFTWARE_SIMULATION_91"                           , 0xc3ac, 0},
  { "SOFTWARE_SIMULATION_92"                           , 0xc3ad, 0},
  { "SOFTWARE_SIMULATION_93"                           , 0xc3ae, 0},
  { "SOFTWARE_SIMULATION_94"                           , 0xc3af, 0},
  { "SOFTWARE_SIMULATION_95"                           , 0xc3b0, 0},
  { "SOFTWARE_SIMULATION_96"                           , 0xc3b1, 0},
  { "SOFTWARE_SIMULATION_97"                           , 0xc3b2, 0},
  { "SOFTWARE_SIMULATION_98"                           , 0xc3b3, 0},
  { "SOFTWARE_SIMULATION_99"                           , 0xc3b4, 0},
  { "SOFTWARE_SIMULATION_100"                          , 0xc3b5, 0},
  { "SOFTWARE_SIMULATION_101"                          , 0xc3b6, 0},
  { "SOFTWARE_SIMULATION_102"                          , 0xc3b7, 0},
  { "SOFTWARE_SIMULATION_103"                          , 0xc3b8, 0},
  { "SOFTWARE_SIMULATION_104"                          , 0xc3b9, 0},
  { "SOFTWARE_SIMULATION_105"                          , 0xc3ba, 0},
  { "SOFTWARE_SIMULATION_106"                          , 0xc3bb, 0},
  { "SOFTWARE_SIMULATION_107"                          , 0xc3bc, 0},
  { "SOFTWARE_SIMULATION_108"                          , 0xc3bd, 0},
  { "SOFTWARE_SIMULATION_109"                          , 0xc3be, 0},
  { "SOFTWARE_SIMULATION_110"                          , 0xc3bf, 0},
  { "SOFTWARE_SIMULATION_111"                          , 0xc3c0, 0},
  { "SOFTWARE_SIMULATION_112"                          , 0xc3c1, 0},
  { "SOFTWARE_SIMULATION_113"                          , 0xc3c2, 0},
  { "SOFTWARE_SIMULATION_114"                          , 0xc3c3, 0},
  { "SOFTWARE_SIMULATION_115"                          , 0xc3c4, 0},
  { "SOFTWARE_SIMULATION_116"                          , 0xc3c5, 0},
  { "SOFTWARE_SIMULATION_117"                          , 0xc3c6, 0},
  { "SOFTWARE_SIMULATION_118"                          , 0xc3c7, 0},
  { "SOFTWARE_SIMULATION_119"                          , 0xc3c8, 0},
  { "SOFTWARE_SIMULATION_120"                          , 0xc3c9, 0},
  { "SOFTWARE_SIMULATION_121"                          , 0xc3ca, 0},
  { "SOFTWARE_SIMULATION_122"                          , 0xc3cb, 0},
  { "SOFTWARE_SIMULATION_123"                          , 0xc3cc, 0},
  { "SOFTWARE_SIMULATION_124"                          , 0xc3cd, 0},
  { "SOFTWARE_SIMULATION_125"                          , 0xc3ce, 0},
  { "SOFTWARE_SIMULATION_126"                          , 0xc3cf, 0},
  { "SOFTWARE_SIMULATION_127"                          , 0xc3d0, 0},
  { "SOFTWARE_SIMULATION_128"                          , 0xc3d1, 0},
  { "SOFTWARE_SIMULATION_129"                          , 0xc3d2, 0},
  { "SOFTWARE_SIMULATION_130"                          , 0xc3d3, 0},
  { "SOFTWARE_SIMULATION_131"                          , 0xc3d4, 0},
  { "SOFTWARE_SIMULATION_132"                          , 0xc3d5, 0},
  { "SOFTWARE_SIMULATION_133"                          , 0xc3d6, 0},
  { "SOFTWARE_SIMULATION_134"                          , 0xc3d7, 0},
  { "SOFTWARE_SIMULATION_135"                          , 0xc3d8, 0},
  { "SOFTWARE_SIMULATION_136"                          , 0xc3d9, 0},
  { "SOFTWARE_SIMULATION_137"                          , 0xc3da, 0},
  { "SOFTWARE_SIMULATION_138"                          , 0xc3db, 0},
  { "SOFTWARE_SIMULATION_139"                          , 0xc3dc, 0},
  { "SOFTWARE_SIMULATION_140"                          , 0xc3dd, 0},
  { "SOFTWARE_SIMULATION_141"                          , 0xc3de, 0},
  { "SOFTWARE_SIMULATION_142"                          , 0xc3df, 0},
  { "SOFTWARE_SIMULATION_143"                          , 0xc3e0, 0},
  { "SOFTWARE_SIMULATION_144"                          , 0xc3e1, 0},
  { "SOFTWARE_SIMULATION_145"                          , 0xc3e2, 0},
  { "SOFTWARE_SIMULATION_146"                          , 0xc3e3, 0},
  { "SOFTWARE_SIMULATION_147"                          , 0xc3e4, 0},
  { "SOFTWARE_SIMULATION_148"                          , 0xc3e5, 0},
  { "SOFTWARE_SIMULATION_149"                          , 0xc3e6, 0},
  { "SOFTWARE_SIMULATION_150"                          , 0xc3e7, 0},
  { "SOFTWARE_SIMULATION_151"                          , 0xc3e8, 0},
  { "SOFTWARE_SIMULATION_152"                          , 0xc3e9, 0},
  { "SOFTWARE_SIMULATION_153"                          , 0xc3ea, 0},
  { "SOFTWARE_SIMULATION_154"                          , 0xc3eb, 0},
  { "SOFTWARE_SIMULATION_155"                          , 0xc3ec, 0},
  { "SOFTWARE_SIMULATION_156"                          , 0xc3ed, 0},
  { "SOFTWARE_SIMULATION_157"                          , 0xc3ee, 0},
  { "SOFTWARE_SIMULATION_158"                          , 0xc3ef, 0},
  { "SOFTWARE_SIMULATION_159"                          , 0xc3f0, 0},
  { "SOFTWARE_SIMULATION_160"                          , 0xc3f1, 0},
  { "SOFTWARE_SIMULATION_161"                          , 0xc3f2, 0},
  { "SOFTWARE_SIMULATION_162"                          , 0xc3f3, 0},
  { "SOFTWARE_SIMULATION_163"                          , 0xc3f4, 0},
  { "SOFTWARE_SIMULATION_164"                          , 0xc3f5, 0},
  { "SOFTWARE_SIMULATION_165"                          , 0xc3f6, 0},
  { "SOFTWARE_SIMULATION_166"                          , 0xc3f7, 0},
  { "SOFTWARE_SIMULATION_167"                          , 0xc3f8, 0},
  { "SOFTWARE_SIMULATION_168"                          , 0xc3f9, 0},
  { "SOFTWARE_SIMULATION_169"                          , 0xc3fa, 0},
  { "SOFTWARE_SIMULATION_170"                          , 0xc3fb, 0},
  { "SOFTWARE_SIMULATION_171"                          , 0xc3fc, 0},
  { "SOFTWARE_SIMULATION_172"                          , 0xc3fd, 0},
  { "SOFTWARE_SIMULATION_173"                          , 0xc3fe, 0},
  { "SOFTWARE_SIMULATION_174"                          , 0xc3ff, 0},
  { "SOFTWARE_SIMULATION_175"                          , 0xc400, 0},
  { "SOFTWARE_SIMULATION_176"                          , 0xc401, 0},
  { "SOFTWARE_SIMULATION_177"                          , 0xc402, 0},
  { "SOFTWARE_SIMULATION_178"                          , 0xc403, 0},
  { "SOFTWARE_SIMULATION_179"                          , 0xc404, 0},
  { "SOFTWARE_SIMULATION_180"                          , 0xc405, 0},
  { "SOFTWARE_SIMULATION_181"                          , 0xc406, 0},
  { "SOFTWARE_SIMULATION_182"                          , 0xc407, 0},
  { "SOFTWARE_SIMULATION_183"                          , 0xc408, 0},
  { "SOFTWARE_SIMULATION_184"                          , 0xc409, 0},
  { "SOFTWARE_SIMULATION_185"                          , 0xc40a, 0},
  { "SOFTWARE_SIMULATION_186"                          , 0xc40b, 0},
  { "SOFTWARE_SIMULATION_187"                          , 0xc40c, 0},
  { "SOFTWARE_SIMULATION_188"                          , 0xc40d, 0},
  { "SOFTWARE_SIMULATION_189"                          , 0xc40e, 0},
  { "SOFTWARE_SIMULATION_190"                          , 0xc40f, 0},
  { "SOFTWARE_SIMULATION_191"                          , 0xc410, 0},
  { "SOFTWARE_SIMULATION_192"                          , 0xc411, 0},
  { "SOFTWARE_SIMULATION_193"                          , 0xc412, 0},
  { "SOFTWARE_SIMULATION_194"                          , 0xc413, 0},
  { "SOFTWARE_SIMULATION_195"                          , 0xc414, 0},
  { "SOFTWARE_SIMULATION_196"                          , 0xc415, 0},
  { "SOFTWARE_SIMULATION_197"                          , 0xc416, 0},
  { "SOFTWARE_SIMULATION_198"                          , 0xc417, 0},
  { "SOFTWARE_SIMULATION_199"                          , 0xc418, 0},
  { "SOFTWARE_SIMULATION_200"                          , 0xc419, 0},
  { "SOFTWARE_SIMULATION_201"                          , 0xc41a, 0},
  { "SOFTWARE_SIMULATION_202"                          , 0xc41b, 0},
  { "SOFTWARE_SIMULATION_203"                          , 0xc41c, 0},
  { "SOFTWARE_SIMULATION_204"                          , 0xc41d, 0},
  { "SOFTWARE_SIMULATION_205"                          , 0xc41e, 0},
  { "SOFTWARE_SIMULATION_206"                          , 0xc41f, 0},
  { "SOFTWARE_SIMULATION_207"                          , 0xc420, 0},
  { "SOFTWARE_SIMULATION_208"                          , 0xc421, 0},
  { "SOFTWARE_SIMULATION_209"                          , 0xc422, 0},
  { "SOFTWARE_SIMULATION_210"                          , 0xc423, 0},
  { "SOFTWARE_SIMULATION_211"                          , 0xc424, 0},
  { "SOFTWARE_SIMULATION_212"                          , 0xc425, 0},
  { "SOFTWARE_SIMULATION_213"                          , 0xc426, 0},
  { "SOFTWARE_SIMULATION_214"                          , 0xc427, 0},
  { "SOFTWARE_SIMULATION_215"                          , 0xc428, 0},
  { "SOFTWARE_SIMULATION_216"                          , 0xc429, 0},
  { "SOFTWARE_SIMULATION_217"                          , 0xc42a, 0},
  { "SOFTWARE_SIMULATION_218"                          , 0xc42b, 0},
  { "SOFTWARE_SIMULATION_219"                          , 0xc42c, 0},
  { "SOFTWARE_SIMULATION_220"                          , 0xc42d, 0},
  { "SOFTWARE_SIMULATION_221"                          , 0xc42e, 0},
  { "SOFTWARE_SIMULATION_222"                          , 0xc42f, 0},
  { "SOFTWARE_SIMULATION_223"                          , 0xc430, 0},
  { "SOFTWARE_SIMULATION_224"                          , 0xc431, 0},
  { "SOFTWARE_SIMULATION_225"                          , 0xc432, 0},
  { "SOFTWARE_SIMULATION_226"                          , 0xc433, 0},
  { "SOFTWARE_SIMULATION_227"                          , 0xc434, 0},
  { "SOFTWARE_SIMULATION_228"                          , 0xc435, 0},
  { "SOFTWARE_SIMULATION_229"                          , 0xc436, 0},
  { "SOFTWARE_SIMULATION_230"                          , 0xc437, 0},
  { "SOFTWARE_SIMULATION_231"                          , 0xc438, 0},
  { "SOFTWARE_SIMULATION_232"                          , 0xc439, 0},
  { "SOFTWARE_SIMULATION_233"                          , 0xc43a, 0},
  { "SOFTWARE_SIMULATION_234"                          , 0xc43b, 0},
  { "SOFTWARE_SIMULATION_235"                          , 0xc43c, 0},
  { "SOFTWARE_SIMULATION_236"                          , 0xc43d, 0},
  { "SOFTWARE_SIMULATION_237"                          , 0xc43e, 0},
  { "SOFTWARE_SIMULATION_238"                          , 0xc43f, 0},
  { "SOFTWARE_SIMULATION_239"                          , 0xc440, 0},
  { "SOFTWARE_SIMULATION_240"                          , 0xc441, 0},
  { "SOFTWARE_SIMULATION_241"                          , 0xc442, 0},
  { "SOFTWARE_SIMULATION_242"                          , 0xc443, 0},
  { "SOFTWARE_SIMULATION_243"                          , 0xc444, 0},
  { "SOFTWARE_SIMULATION_244"                          , 0xc445, 0},
  { "SOFTWARE_SIMULATION_245"                          , 0xc446, 0},
  { "SOFTWARE_SIMULATION_246"                          , 0xc447, 0},
  { "SOFTWARE_SIMULATION_247"                          , 0xc448, 0},
  { "SOFTWARE_SIMULATION_248"                          , 0xc449, 0},
  { "SOFTWARE_SIMULATION_249"                          , 0xc44a, 0},
  { "ENDE_BEREICH_SOFTWARE_SIMULATION"                 , 0xd000, 0},
  { "START_CHAR_BEREICH"                               , 0xfda4, 0},
  { "MODE_MULTIFUNKTIONSAUSGANG_2"                     , 0xfda5, 0},
  { "WECHSELANZEIGE"                                   , 0xfda6, 0},
  { "SCHNELLAUFHEIZUNG"                                , 0xfda7, 0},
  { "FEHLERANZAHL"                                     , 0xfda8, 0},
  { "ANZEIGESTATUS"                                    , 0xfda9, 0},
  { "BUSKONTROLLE"                                     , 0xfdaa, 0},
  { "ZWEITER_WE_STATUS"                                , 0xfdab, et_little_endian},
  { "WP_EVU"                                           , 0xfdac, et_little_endian},
  { "WP_PUMPENSTATUS"                                  , 0xfdad, et_little_endian},
  { "WP_STATUS"                                        , 0xfdae, et_little_endian},
//  { "QUELLE"                                           , 0xfdaf, et_little_endian},
  // Pumpen / Pufferladepumpe (Dauerlauf)
  { "DAUERLAUF_PUFFERLADEPUMPE"                        , 0xfdaf, et_little_endian},
  // Regelung / Regeldynamik
  { "SCHALTWERKDYNAMIKZEIT"                            , 0xfdb0, et_little_endian},
  { "STILLSTANDZEIT"                                   , 0xfdb1, et_little_endian},
  // Heizkreispumpe (zyklisch)  aus 0   ein 01
  { "PUMPENZYKLEN"                                     , 0xfdb2, et_little_endian},
  { "GEBAEUDEART"                                      , 0xfdb3, et_little_endian},
  // aus 00   ein 01
  { "SOMMERBETRIEB"                                    , 0xfdb4, et_little_bool},
  { "IMPULSRATE"                                       , 0xfdb6, et_little_endian},
  { "SOLARBETRIEB"                                     , 0xfdb7, et_little_endian},
  { "WAERMEMENGE"                                      , 0xfdb8, et_little_endian},
//  { "WW_LERNEN"                                        , 0xfdb9, et_little_endian},
  // Warmwasser / WW Automatik  aus 0x0000   ein 0x0100
  { "AUTOMATIK_WARMWASSER"                             , 0xfdb9, et_little_bool},
  // ID = 480
  // EVU Freigabe:         0x0100
  { "ZWEITER_WE_STATUS"                                , 0xfdba, 0},
  { "WPSTUFEN_WW"                                      , 0xfdbb, et_little_endian},
  { "WW_MIT_2WE"                                       , 0xfdbc, et_little_endian},
  { "SPERREN_2WE"                                      , 0xfdbd, et_little_endian},
  { "FREIGABE_2WE"                                     , 0xfdbe, et_little_endian},
  { "DYNAMIK"                                          , 0xfdbf, et_little_endian},
  { "PARTYSTUNDEN"                                     , 0xfdc0, 0},
  { "MANUELLES_ABTAUEN"                                , 0xfdc1, 0},
  { "HEIZKREIS_PROGRAMMSCHALTER"                       , 0xfdc2, 0},
  { "MODE_EINGANG2"                                    , 0xfdc3, 0},
  { "FUEHLERKENNLINIE"                                 , 0xfdc4, 0},
  { "WARTUNG_JAHR"                                     , 0xfdc5, 0},
  { "WARTUNG_MONAT"                                    , 0xfdc6, 0},
  { "WARTUNG_TAG"                                      , 0xfdc7, 0},
  { "THERMOSTATEINGANG_WW"                             , 0xfdc8, 0},
  { "BETRIEBSART_HZK_PUMPE"                            , 0xfdc9, et_little_endian},
  { "ANNAHME_LEISTUNGSZWANG"                           , 0xfdca, 0},
  { "KESSELFOLGE1_1"                                   , 0xfdcb, 0},
  { "KESSELFOLGE1_2"                                   , 0xfdcc, 0},
  { "KESSELFOLGE1_3"                                   , 0xfdcd, 0},
  { "KESSELFOLGE1_4"                                   , 0xfdce, 0},
  { "KESSELFOLGE1_5"                                   , 0xfdcf, 0},
  { "KESSELFOLGE1_6"                                   , 0xfdd0, 0},
  { "KESSELFOLGE1_7"                                   , 0xfdd1, 0},
  { "KESSELFOLGE1_8"                                   , 0xfdd2, 0},
  { "KESSELFOLGE1_9"                                   , 0xfdd3, 0},
  { "KESSELFOLGE1_10"                                  , 0xfdd4, 0},
  { "KESSELFOLGE2_1"                                   , 0xfdd5, 0},
  { "KESSELFOLGE2_2"                                   , 0xfdd6, 0},
  { "KESSELFOLGE2_3"                                   , 0xfdd7, 0},
  { "KESSELFOLGE2_4"                                   , 0xfdd8, 0},
  { "KESSELFOLGE2_5"                                   , 0xfdd9, 0},
  { "KESSELFOLGE2_6"                                   , 0xfdda, 0},
  { "KESSELFOLGE2_7"                                   , 0xfddb, 0},
  { "KESSELFOLGE2_8"                                   , 0xfddc, 0},
  { "KESSELFOLGE2_9"                                   , 0xfddd, 0},
  { "KESSELFOLGE2_10"                                  , 0xfdde, 0},
  { "TAG_SOMMER_BEGIN"                                 , 0xfddf, 0}, // vermutlich 0xfdde
  { "MONAT_SOMMER_BEGIN"                               , 0xfde0, 0},
  { "TAG_SOMMER_ENDE"                                  , 0xfde1, 0},
  { "MONAT_SOMMER_ENDE"                                , 0xfde2, 0},
  { "SCHALTHYST_PUFFER"                                , 0xfde3, 0},
  { "PUFFERUEBERHOEHUNG"                               , 0xfde4, 0},
  { "MAX_PUFFERTEMP"                                   , 0xfde5, 0},
  { "MIN_PUFFERTEMP"                                   , 0xfde6, 0},
  { "MAX_SAMMLERTEMP"                                  , 0xfde7, 0},
  { "MIN_SAMMLERTEMP"                                  , 0xfde8, 0},
  { "SAMMLERUEBERHOEHUNG"                              , 0xfde9, 0},
  { "ABREGELPARAMETER"                                 , 0xfdea, 0},
  { "MAX_MODGRAD"                                      , 0xfdeb, 0},
  { "MIN_MODGRAD"                                      , 0xfdec, 0},
  { "FOLGEWECHSEL_STD"                                 , 0xfded, 0},
  { "FOLGEWECHSELMODUS"                                , 0xfdee, 0},
  { "SONDERNIVEAU_TEMP"                                , 0xfdef, 0},
  { "MODE_EINGANG1"                                    , 0xfdf0, 0},
  { "STATUS_VARIABLER_AUSGANG"                         , 0xfdf1, 0},
  { "MODE_VARIABLER_AUSGANG"                           , 0xfdf2, 0},
  { "STATUS_MULTIFUNKTIONSAUSGANG"                     , 0xfdf3, 0},
  { "MODE_MULTIFUNKTIONSAUSGANG"                       , 0xfdf4, 0},
  { "ANTILEGIONELLEN_ZEITPUNKT"                        , 0xfdf5, 0},
  { "SOFORT_AUS"                                       , 0xfdf6, 0},
  { "PROGSTELL_UHR_SONNE_BEREIT"                       , 0xfdf7, 0},
  { "BM_GEFUNDEN"                                      , 0xfdf8, 0},
  { "HEIZTHERME"                                       , 0xfdf9, 0},
  { "RAUMSOLLTEMP_VERSTELLUNG"                         , 0xfdfa, 0},
  { "FUELLSTAND"                                       , 0xfdfb, 0},
  { "BUSVERSORGUNG"                                    , 0xfdfc, 0},
  { "SOLARSYSTEMAUSWAHL"                               , 0xfdfd, 0},
  { "FUELLSTANDSGEBER"                                 , 0xfdfe, 0},
  { "KESSELTYP"                                        , 0xfdff, 0},
  { "MOD_KLAPPENSTATUS"                                , 0xfe00, 0},
  { "ENDE_CHAR_BEREICH"                                , 0xfe01, 0},
  { "INFOBLOCK_1"                                      , 0xfe02, 0},
  { "INFOBLOCK_2"                                      , 0xfe03, 0},
  { "INFOBLOCK_3"                                      , 0xfe04, 0},
  { "INFOBLOCK_4"                                      , 0xfe05, 0},
  { "INFOBLOCK_5"                                      , 0xfe06, 0},
  { "INFOBLOCK_6"                                      , 0xfe07, 0}
};

static const ErrorIndex ErrorList[] =
{
  { 0x0002, "Schuetz klebt"},
  { 0x0003, "ERR HD-SENSOR"},
  { 0x0004, "Hochdruck"},
  { 0x0005, "Verdampferfuehler"},
  { 0x0006, "Relaistreiber"},
  { 0x0007, "Relaispegel"},
  { 0x0008, "Hexschalter"},
  { 0x0009, "Drehzahl Luefter"},
  { 0x000a, "Lueftertreiber"},
  { 0x000b, "Reset Baustein"},
  { 0x000c, "ND"},
  { 0x000d, "ROM"},
  { 0x000e, "QUELLEN MINTEMP"},
  { 0x0010, "Abtauen"},
  { 0x0012, "ERR T-HEI IWS"},
  { 0x0017, "ERR T-FRO IWS"},
  { 0x001a, "Niederdruck"},
  { 0x001b, "ERR ND-DRUCK"},
  { 0x001c, "ERR HD-DRUCK"},
  { 0x001d, "HD-SENSOR-MAX"},
  { 0x001e, "HEISSGAS-MAX"},
  { 0x001f, "ERR HD-SENSOR"},
  { 0x0020, "Einfrierschutz"},
  { 0x0021, "KEINE LEISTUNG"}
};

static const ErrorIndex BetriebsartList[] =
{
  { 0x0000, "Notbetrieb" },
  { 0x0100, "Bereitschaft" }, 
  { 0x0200, "Automatik" },
  { 0x0300, "Tagbetrieb" },
  { 0x0400, "Absenkbetrieb" },
  { 0x0500, "Warmwasser" }
};



